import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.FlowLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import java.awt.GridLayout;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JTextField;
import javax.swing.UIManager;
import java.awt.ScrollPane;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Panel;
import javax.swing.JButton;

public class ControlBoard extends JFrame implements ActionListener {

	public SampleCode sampleCode;
	public JTabbedPane tabbedPane;
	public GUI_Panel request_response_GUI_Panel, broadcast_GUI_Panel, messages_GUI_Panel, contract_GUI_Panel, deliveryAreas_GUI_Panel,products_GUI_Panel,trades_GUI_Panel;
	public GUI_Panel ownOrders_GUI_Panel, orderBooks_GUI_Panel, RK_Gaps_GUI_Panel;
	public JTextField textField_UserName;
	public JTextField textField_Pwd;
	public JTextField textField_URL1;
	public JTextField textField_URL2;
	public JTextField textField_AMQPStatus;
	public JTextField textField_ConnectionLossNb;
	public JTextField textField_M7LoginStatus;
	public JTextArea textAreaConnection;
	public JTextArea textAreaMessages;
	public JTextArea textAreaErrors;
	public JTextArea textAreaM7Hbts;
	public JTextArea textAreaContracts;
	public JTextArea textAreaOwnTrades;
	public JTextArea textAreaRoutingKeys;
	
	public JTextArea textAreaGaps;
	private SimpleDateFormat sdfStats = new SimpleDateFormat("yyy/MM/dd HH:mm:ss.SSS") ;
	private static final int MAX_PANEL_TEXT_LENGTH = 120000;
	private String EMPTY_CONTENT = "";
	JButton btnButtonLogout, btnButtonThrottlingStatusReq, btnButtonMarketStateReq, btnButtonModifyAllOrdersDeleMember,btnButtonSendWrongContractRequest, btnButtonSendCorrectOrderRandomContract;
	public JTextField textField_MarketState;
	public JTextField textField_BroadcastProcessingCanStart;

	// ***********************************************************
	// constructor: create the main GUI window with different tabs
	// ***********************************************************
	public ControlBoard(SampleCode sampleCode) {
		
		this.sampleCode = sampleCode;
		boolean bIndependentWindow = false;
		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(0, 0, 1800, 800);
	    getContentPane().setLayout(new GridLayout(1, 1, 0, 0));
			    
	    //UIManager.put("TabbedPane.focus", Color.red);
	    tabbedPane = new JTabbedPane(JTabbedPane.TOP);
	    getContentPane().add(tabbedPane);

		// Connection tab : display connection and Login info
		JPanel panelConnection = new JPanel();
		tabbedPane.addTab("Connection", null, panelConnection, null);
		panelConnection.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("User Name");
		lblNewLabel.setBounds(29, 16, 78, 20);
		panelConnection.add(lblNewLabel);
		
		textField_UserName = new JTextField();
		textField_UserName.setBounds(122, 13, 146, 26);
		panelConnection.add(textField_UserName);
		textField_UserName.setColumns(10);
		
		JLabel lblNewLabel_Pwd = new JLabel("Password");
		lblNewLabel_Pwd.setBounds(38, 73, 69, 20);
		panelConnection.add(lblNewLabel_Pwd);
		
		textField_Pwd = new JTextField();
		textField_Pwd.setBounds(122, 70, 146, 26);
		panelConnection.add(textField_Pwd);
		textField_Pwd.setColumns(10);
		
		textField_URL1 = new JTextField();
		textField_URL1.setBounds(122, 134, 297, 26);
		panelConnection.add(textField_URL1);
		textField_URL1.setColumns(10);
		
		JLabel lblLabel_URL1 = new JLabel("URL 1");
		lblLabel_URL1.setBounds(38, 137, 69, 20);
		panelConnection.add(lblLabel_URL1);
		
		JLabel lblLabel_URL2 = new JLabel("URL 2");
		lblLabel_URL2.setBounds(38, 182, 69, 20);
		panelConnection.add(lblLabel_URL2);
		
		textField_URL2 = new JTextField();
		textField_URL2.setBounds(122, 176, 297, 26);
		panelConnection.add(textField_URL2);
		textField_URL2.setColumns(10);
		
		JLabel lblLabel_AMQPStatus = new JLabel("AMQP status:");
		lblLabel_AMQPStatus.setBounds(557, 16, 114, 20);
		panelConnection.add(lblLabel_AMQPStatus);
				
		JLabel lblLabel_LoginStatus = new JLabel("M7 Login status:");
		lblLabel_LoginStatus.setBounds(557, 73, 114, 20);
		panelConnection.add(lblLabel_LoginStatus);
		
		textField_AMQPStatus = new JTextField();
		textField_AMQPStatus.setBounds(686, 13, 146, 26);
		panelConnection.add(textField_AMQPStatus);
		textField_AMQPStatus.setColumns(10);
		
		textField_M7LoginStatus = new JTextField();
		textField_M7LoginStatus.setText("");
		textField_M7LoginStatus.setBounds(686, 70, 146, 26);
		panelConnection.add(textField_M7LoginStatus);
		textField_M7LoginStatus.setColumns(10);
		
		textAreaConnection = new JTextArea();
		textAreaConnection.setBounds(15, -6, 1700, 400);
		panelConnection.add(textAreaConnection);
		
		JScrollPane scrollPane = new JScrollPane(textAreaConnection,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollPane.setBounds(29, 239, 1700, 400);
		panelConnection.add(scrollPane);
		
		Label connectionLossLabel = new Label("Connection Losses: ");
		connectionLossLabel.setBounds(855, 12, 130, 27);
		panelConnection.add(connectionLossLabel);
		
		textField_ConnectionLossNb = new JTextField();
		textField_ConnectionLossNb.setBounds(992, 12, 35, 27);
		panelConnection.add(textField_ConnectionLossNb);
		
		btnButtonLogout = new JButton("Logout & Exit");
		btnButtonLogout.setBounds(545, 131, 115, 29);
		panelConnection.add(btnButtonLogout);
		btnButtonLogout.addActionListener((ActionListener) this);
		
		btnButtonMarketStateReq = new JButton("Market State Req");
		btnButtonMarketStateReq.setBounds(695, 131, 137, 29);
		panelConnection.add(btnButtonMarketStateReq);
		btnButtonMarketStateReq.addActionListener((ActionListener) this);
		
		btnButtonThrottlingStatusReq = new JButton("Throttling Status Req");
		btnButtonThrottlingStatusReq.setBounds(870, 131, 182, 29);
		panelConnection.add(btnButtonThrottlingStatusReq);
		
		JLabel lblLabel_MarketState = new JLabel("Market State");
		lblLabel_MarketState.setBounds(858, 73, 127, 20);
		panelConnection.add(lblLabel_MarketState);
		
		textField_MarketState = new JTextField();
		textField_MarketState.setBounds(991, 70, 91, 26);
		panelConnection.add(textField_MarketState);
		textField_MarketState.setColumns(10);
		btnButtonThrottlingStatusReq.addActionListener((ActionListener) this);
		
		btnButtonModifyAllOrdersDeleMember = new JButton("Delete all member orders");
		btnButtonModifyAllOrdersDeleMember.setBounds(880+200, 131, 200, 29);
		panelConnection.add(btnButtonModifyAllOrdersDeleMember);
		btnButtonModifyAllOrdersDeleMember.addActionListener((ActionListener) this);
		
		
		btnButtonSendCorrectOrderRandomContract = new JButton("Send order random tradable contract");
		btnButtonSendCorrectOrderRandomContract.setBounds(880+200+250, 131, 250, 29);
		panelConnection.add(btnButtonSendCorrectOrderRandomContract);
		btnButtonSendCorrectOrderRandomContract.addActionListener((ActionListener) this);
		
		btnButtonSendWrongContractRequest = new JButton("Test: send order closed contract");
		btnButtonSendWrongContractRequest.setBounds(880+200+250, 131+40, 250, 29);
		panelConnection.add(btnButtonSendWrongContractRequest);
		btnButtonSendWrongContractRequest.addActionListener((ActionListener) this);
		
		JLabel lblLabel_BroadcastProcessingCanStart = new JLabel("All mandatory response received?");
		lblLabel_BroadcastProcessingCanStart.setBounds(1127, 70, 239, 20);
		panelConnection.add(lblLabel_BroadcastProcessingCanStart);
		
		textField_BroadcastProcessingCanStart = new JTextField();
		textField_BroadcastProcessingCanStart.setBounds(1330, 70, 78, 26);
		panelConnection.add(textField_BroadcastProcessingCanStart);
		textField_BroadcastProcessingCanStart.setColumns(10);
		
		this.initConnection(null);

		// requests tab
		JPanel panelRequests = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Requests", null, panelRequests, null);
	    String[] requestColumnLabels= {"#", "Sending/Reception Time", "AMQP Sending Time", "Response Time",
	    							"Request/Response","Type", "State", "Encoding", "Client RTT", "Resp Mandatory",
	    							"Routing Key","Correlation Id", "XML payload"};
		bIndependentWindow = false; 
		request_response_GUI_Panel = new GUI_Panel(bIndependentWindow, panelRequests,  "REQUESTS", requestColumnLabels, 0, 0, 100, 600, 400);
		request_response_GUI_Panel.Init();
	    // color change for a request in Waiting state
		request_response_GUI_Panel.table.getColumnModel().getColumn(6).setCellRenderer(new RequestCellRenderer());
		panelRequests.add(new JScrollPane(request_response_GUI_Panel.table), BorderLayout.CENTER);
		
		// broadcasts tab
	    JPanel panelBroadcasts  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Broadcasts", null, panelBroadcasts, null);
		String[] broadcastColumnLabels= {"#","Reception Time", "Sending Time","Type", "Correlation Id", "Routing Key", "Sequence No", "XML payload"};
		bIndependentWindow = false; 
		broadcast_GUI_Panel = new GUI_Panel(bIndependentWindow, panelBroadcasts,  "BROADCASTS", broadcastColumnLabels, 1, 0, 100, 600, 400);
		broadcast_GUI_Panel.Init();
		panelBroadcasts.add(new JScrollPane(broadcast_GUI_Panel.table), BorderLayout.CENTER);

		// M7 Heartbeats
	    JPanel panel_M7_Heartbeats  = new JPanel();
	    panel_M7_Heartbeats.setLayout(null);
	    tabbedPane.addTab("M7 Heartbeats", null, panel_M7_Heartbeats, null);
	    
		JLabel lblLabel_M7_Hbts = new JLabel("M7 Heartbeats");
		panel_M7_Heartbeats.setBounds(40, 30, 500, 20);
		panel_M7_Heartbeats.add(lblLabel_M7_Hbts);
		
		textAreaM7Hbts = new JTextArea();
		textAreaM7Hbts.setBounds(40, 50, 1400, 300);
		panel_M7_Heartbeats.add(textAreaM7Hbts);
		
		JScrollPane scrollPaneM7Hbts = new JScrollPane(textAreaM7Hbts,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollPaneM7Hbts.setBounds(40, 50, 1400, 300);
		panel_M7_Heartbeats.add(scrollPaneM7Hbts);
		
		// Delivery Areas tab
	    JPanel panelDeliveryAreas  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Delivery Areas", null, panelDeliveryAreas, null);
		String[] deliveryAreasColumnLabels= {"#", "Delivey Area Id",  "Name", "Long Name",  "State", "Remote State","Market Area Id "};
		bIndependentWindow = false; 
		deliveryAreas_GUI_Panel = new GUI_Panel(bIndependentWindow, panelDeliveryAreas,  "ORDER BOOKS", deliveryAreasColumnLabels, 15, 0, 100, 600, 400);
		deliveryAreas_GUI_Panel.Init();
		panelDeliveryAreas.add(new JScrollPane(deliveryAreas_GUI_Panel.table), BorderLayout.CENTER);

		// Products tab
	    JPanel panelProducts  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Products", null, panelProducts, null);
		String[] productsColumnLabels= {"#", "Product Name", "State", "Type", 
									"Min Price", "Max Price", "Min Qty", "Max Qty", "Currency", "Time Zone"};
		bIndependentWindow = false; 
		products_GUI_Panel = new GUI_Panel(bIndependentWindow, panelProducts,  "PRODUCTS", productsColumnLabels, 1, 0, 100, 600, 400);
		products_GUI_Panel.Init();
		panelProducts.add(new JScrollPane(products_GUI_Panel.table), BorderLayout.CENTER);
		
		// Contracts
		JPanel panel_M7_Contracts  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Contracts", null, panel_M7_Contracts, null);
		String[] contractColumnLabels= {"#" , "Row Type", "Contract ID","Revision No", "Product", "Name", "Long Name",
				"Delivery Start", "Delivery End", "Predefined", "State", "Trading Phase", "Duration" ,"Activation Point", "Expiration Point", "Delivery Unit","NB of areas"," Areas List"};
		bIndependentWindow = false; 
		contract_GUI_Panel = new GUI_Panel(bIndependentWindow, panel_M7_Contracts, "CONTRACTS", contractColumnLabels, 1, 0, 100, 600, 400);
		contract_GUI_Panel.Init();
	    // color change for a CONTRACT/AREA row, except the 1st column
		for (int i=1;i< contractColumnLabels.length-1; i++) {
			contract_GUI_Panel.table.getColumnModel().getColumn(i).setCellRenderer(new ContractCellRenderer());	
		}
		panel_M7_Contracts.add(new JScrollPane(contract_GUI_Panel.table), BorderLayout.CENTER);
	
		// order books tab
	    JPanel panelOrderBooks  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Order Books", null, panelOrderBooks, null);
		String[] ordeBooksColumnLabels= {"#", "Contract Id",  "Area Id", "Product",  "Contract Name","Area Name",
										"Best Bid", "Best Ask" ,"Last qty","Last price",  "last update", "last trade", "Nb of orders","Tradable","Area phase", "Area State"};
		bIndependentWindow = false; 
		orderBooks_GUI_Panel = new GUI_Panel(bIndependentWindow, panelOrderBooks,  "ORDER BOOKS", ordeBooksColumnLabels, 15, 0, 100, 600, 400);
		orderBooks_GUI_Panel.Init();
		panelOrderBooks.add(new JScrollPane(orderBooks_GUI_Panel.table), BorderLayout.CENTER);
		
		// Own Orders tab
	    JPanel panelOwnOrders  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Own Orders", null, panelOwnOrders, null);
	    String[] ownOrdersColumnLabels   = {"#","Correlation Id", "Client Order Id", "Locked", "M7 order Id", "Parent Order Id", "Initial Order Id", "Ack Resp", "Error Resp", "action", "RevisionNo", "side", "price", "qty", "Text", " Nb OMT",  "Contract Name", "Area Id","Area name", "Area long name", "client sending","Client RTT","M7 AMQP sending","client reception tm","M7 Timestamp","M7 Last update"};
		bIndependentWindow = false; 
		ownOrders_GUI_Panel = new GUI_Panel(bIndependentWindow, panelOwnOrders,  "OWN ORDERS", ownOrdersColumnLabels, 15, 0, 100, 600, 400);
		ownOrders_GUI_Panel.Init();
		panelOwnOrders.add(new JScrollPane(ownOrders_GUI_Panel.table), BorderLayout.CENTER);
		
		// Own Trades
	    JPanel panel_Trades  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Own Trades", null, panel_Trades, null);
	    String[] tradesColumnLabels = {"#","Trade Id","remote Trade Id", "RevisionNo", "Side", "Contract Id", "Contract Name", "Contract phase", "Product", "State", "ExecutionTime", "XBID trade", "Quantity", "Price", "buy Area", "Sell Area", "Pre-Arranged (OTC)", "BG", "Text", "Self-trade"};
		bIndependentWindow = false; 
		trades_GUI_Panel = new GUI_Panel(bIndependentWindow, panel_Trades, "Trades", tradesColumnLabels, 15, 0, 100, 600, 400);
		trades_GUI_Panel.Init();
		panel_Trades.add(new JScrollPane(trades_GUI_Panel.table), BorderLayout.CENTER);
	
		// Messages
	    JPanel panel_messages  = new JPanel();
	    panel_messages.setLayout(null);
	    tabbedPane.addTab("Messages & Errors", null, panel_messages, null);
	    
		JLabel lblNewLabel_Messages = new JLabel("MESSAGES (Msg Reports)");
		lblNewLabel_Messages.setBounds(40, 30, 500, 20);
		panel_messages.add(lblNewLabel_Messages);
		
		textAreaMessages = new JTextArea();
		textAreaMessages.setBounds(40, 50, 1700, 300);
		panel_messages.add(textAreaMessages);
		
		JScrollPane scrollPaneMessages = new JScrollPane(textAreaMessages,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollPaneMessages.setBounds(40, 50, 1700, 300);
		panel_messages.add(scrollPaneMessages);
				
		JLabel lblNewLabel_Errors = new JLabel("ERRORS (Response or Broadcast)");
		lblNewLabel_Errors.setBounds(40, 375, 310, 29);
		panel_messages.add(lblNewLabel_Errors);
		
		textAreaErrors = new JTextArea();
		textAreaErrors.setBounds(41, 350, 1700, 300);
		panel_messages.add(textAreaErrors);
		
		JScrollPane scrollPaneErrors = new JScrollPane(textAreaErrors,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollPaneErrors.setBounds(41, 400, 1700, 300);
		panel_messages.add(scrollPaneErrors);
		
		// Broadcast Gaps per RK
	    JPanel panel_Gaps  = new JPanel(new BorderLayout());
	    tabbedPane.addTab("Routing Keys/Gaps check", null, panel_Gaps, null);
	    String[] RKColumnLabels = {"#","RK name (AMQP header x-m7-group-id)", "Last sequence No (x-m7-group-sequence)","Gap detected", "Missing Seq No","Missing since"};
		bIndependentWindow = false; 
		RK_Gaps_GUI_Panel = new GUI_Panel(bIndependentWindow, panel_Gaps,  "GAPS per RK", RKColumnLabels, 15, 0, 100, 600, 400);
		RK_Gaps_GUI_Panel.Init();
		panel_Gaps.add(new JScrollPane(RK_Gaps_GUI_Panel.table), BorderLayout.CENTER);
		/*
		 * JLabel lblNewLabel_routingKeys = new
		 * JLabel("ROUTING KEYS (AMQP msgs header info)");
		 * lblNewLabel_routingKeys.setBounds(40, 30, 500, 20);
		 * panel_Gaps.add(lblNewLabel_routingKeys);
		 */
				
		/*
		 * JLabel lblNewLabel_Gaps = new
		 * JLabel("GAPS: MISSED SEQUENCE NUMBERS for a given Routing Key");
		 * lblNewLabel_Gaps.setBounds(40, 375, 369, 29);
		 * panel_gaps.add(lblNewLabel_Gaps);
		 * 
		 * textAreaGaps = new JTextArea(); textAreaGaps.setBounds(41, 350, 1400, 300);
		 * panel_gaps.add(textAreaGaps);
		 * 
		 * JScrollPane scrollPaneGaps = new
		 * JScrollPane(textAreaGaps,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.
		 * HORIZONTAL_SCROLLBAR_ALWAYS); scrollPaneGaps.setBounds(41, 400, 1400, 300);
		 * panel_gaps.add(scrollPaneGaps);
		 */
		
		setVisible(true); 
	    this.setTitle("Control Board");
	    this.requestFocus();
	}
	// **********************************
	// * Initialize text field colors
	// **********************************
	public void initConnection(AMQPConnection connection) {
		this.textField_AMQPStatus.setText("NOT CONNECTED");
		this.textField_AMQPStatus.setBackground(Color.LIGHT_GRAY);
		if (connection != null) updateAMQPConnectionLossNb();
		this.textField_URL1.setBackground(Color.LIGHT_GRAY);
		this.textField_URL2.setBackground(Color.LIGHT_GRAY);

		this.textField_UserName.setBackground(Color.LIGHT_GRAY);
		this.textField_Pwd.setBackground(Color.LIGHT_GRAY);
		this.textField_MarketState.setBackground(Color.LIGHT_GRAY);		
		this.textField_M7LoginStatus.setText("N/A");
		this.textField_M7LoginStatus.setBackground(Color.RED);
		
		this.textField_BroadcastProcessingCanStart.setBackground(Color.LIGHT_GRAY);
	}
	
	// **********************************
	// * actionPerformed
	// **********************************
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==btnButtonLogout) {
			// Logout
			sampleCode.Logout();
			try {
				Thread.sleep(5000);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			System.exit(0);
		}
		else if (e.getSource()==btnButtonThrottlingStatusReq) {
			sampleCode.sendThrottlingStatusReq();
		}
		else if (e.getSource()==btnButtonMarketStateReq) {
			sampleCode.SendMarketStateReq();
		}
		else if (e.getSource()==btnButtonModifyAllOrdersDeleMember) {
			sampleCode.SendModifyAllOrders("DELE");
		}
		else if (e.getSource()==btnButtonSendWrongContractRequest) {
			sampleCode.SendOrderOnClosedContract();
		}
		else if (e.getSource()==btnButtonSendCorrectOrderRandomContract) {
			sampleCode.SendCorrectOrderRandomContract();
		}
	}
	
	// **********************************
	// * AMQP connected
	// **********************************
	public void successfulConnection(AMQPConnection connection) {
		this.textField_AMQPStatus.setBackground(Color.GREEN);
		this.textField_AMQPStatus.setText("CONNECTED");
		updateAMQPConnectionLossNb();
			
		if (connection.connectedURLNb==1) {
			this.textField_URL1.setBackground(Color.GREEN);
		}
		else {
			this.textField_URL2.setBackground(Color.GREEN);				
		}
	}
	// **********************************
	// * AMQP connection loss
	// **********************************
	public void connectionLoss() {
		this.textField_AMQPStatus.setBackground(Color.RED);
		this.textField_AMQPStatus.setText("CONNETION LOSS");
		
		this.textField_URL1.setBackground(Color.LIGHT_GRAY);
		this.textField_URL2.setBackground(Color.LIGHT_GRAY);
		
		updateAMQPConnectionLossNb();
	}
	// **********************************
	// * Update the nb of connection losses
	// **********************************	
	public void updateAMQPConnectionLossNb() {
		this.textField_ConnectionLossNb.setText(Integer.toString(Globals.AMQPConnectionLossNb));
		if (Globals.AMQPConnectionLossNb == 0) this.textField_ConnectionLossNb.setBackground(Color.GREEN);
		else this.textField_ConnectionLossNb.setBackground(Color.ORANGE);
	}

	// **********************************
	// * Update the login text field and color once logged in
	// **********************************
	public void LoggedIn(String text) {
		this.textField_M7LoginStatus.setText("LOGGED IN M7");
		this.AddText(text,this.textAreaConnection);
		this.textField_M7LoginStatus.setBackground(Color.GREEN);
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// select the "Request/Response" tab
		this.tabbedPane.setSelectedIndex(1);
	}
	// **********************************
	// * Update the login text field when logged out
	// **********************************
	public void LoggedOut() {
		this.tabbedPane.setSelectedIndex(0);
		this.textField_M7LoginStatus.setText("LOGGED OUT");
		this.textField_M7LoginStatus.setBackground(Color.RED);
		// select the "Request/Response" tab

	}
	// *******************************************
	// * Append + Format the display in text Areas
	// *******************************************
    public void AddText(String text, JTextArea textArea) {
	    textArea.append(sdfStats.format(new Date()) + "ms: "+ text+"\n");
	    // enable auto-scroll
	    textArea.setCaretPosition(textArea.getDocument().getLength());   
	    // delete/reset text after a certain length (avoid an accumulation)
	    if ((textArea.getDocument().getLength() > MAX_PANEL_TEXT_LENGTH && !this.getTitle().contentEquals("Requests/Responses"))
	    	||	(textArea.getDocument().getLength() > 2*MAX_PANEL_TEXT_LENGTH && this.getTitle().contentEquals("Requests/Responses")))
	    		{
	    	textArea.setText(EMPTY_CONTENT);
	    }
    }

	// *******************************************
	// * Append + Format the display in text Areas
	// *******************************************
    public void AddTextStaticPlace(String text, JTextArea textArea) {
    	textArea.setText("\n"+sdfStats.format(new Date()) + "ms: "+ text+"\n");
    	//textArea.append(sdf.format(new Date()) + "ms: "+ text+"\n");
     }

	// *******************************************
	// * Append + Format the display in text Areas
	// *******************************************
    public void updateBroadcastProcessingStatus() {
    	this.textField_BroadcastProcessingCanStart.setText(String.valueOf(Globals.bBroadcastProcessingCanStart));
    	
    }
}
