import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;

public class GUI_Panel extends JPanel implements  ActionListener { 

	
	JTable table;
	String panelTitle;
	String[] tableHeader;
	int nbRows;
	JTextField commentText;
	JTextField XMLText;
	JTextField AMQPHeaderText;
	JPanel mainPanel;
	JPanel textPanel;	
	JPanel msgDetailsPanel;
	JFrame jFrame;
	int x1, x2, y1, y2;
	DefaultTableModel dataModel ;
	boolean independentWindow; 
	boolean bPaused = false;
	JButton button;
		
	// **********************
	// Constructor
	// **********************
	public GUI_Panel(boolean independentWindow, JPanel sourcePanel, String panelTitle, String[] tableHeader, int nbRows, int x1, int y1, int x2, int y2) {
		this.panelTitle = panelTitle;
		this.tableHeader = tableHeader;
		this.nbRows = nbRows;
		this.independentWindow = independentWindow;
		
		// enable the table and field to be embedded into an existing JFrame
		if (independentWindow == true) {
			jFrame = new JFrame();
		    mainPanel = new JPanel(new BorderLayout());
		}
		else this.mainPanel = sourcePanel;
		
		table = new JTable();
		commentText = new JTextField();
		AMQPHeaderText = new JTextField();
		XMLText = new JTextField();
		button = new JButton("PAUSE/RESUME"); 
		 
		this.x1 = x1;
		this.x2 = x2;
		this.y1 = y1;
		this.y2 = y2;

	    textPanel = new JPanel(new BorderLayout());
	    msgDetailsPanel  = new JPanel(new BorderLayout());
	}

	// **********************
	// Initialize the table
	// **********************
	public void Init() {		

	    // Create the table model
	    dataModel = new DefaultTableModel(tableHeader, nbRows);

	    // create the table
	    table = new JTable(dataModel);
	    table.setAutoCreateRowSorter(true);
	    table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	    ListSelectionModel model=table.getSelectionModel();
	    
	    // center all columns content but the 1st one which contains labels
	    DefaultTableCellRenderer centerRenderer = new DefaultTableCellRenderer();
	    centerRenderer.setHorizontalAlignment( SwingConstants.CENTER);
	    
	    // center all columns content but the 1st one which contains labels
	    for (int i=1; i<table.getColumnCount();i++){
	    	table.setDefaultRenderer(table.getColumnClass(i),centerRenderer);
	    }
	    resizeColumnWidth(table);   

	    textPanel.add(commentText, BorderLayout.SOUTH);
	   // msgDetailsPanel.add(AMQPHeaderText, BorderLayout.SOUTH);
	   // msgDetailsPanel.add(XMLText, BorderLayout.SOUTH);
	    mainPanel.add(button, BorderLayout.SOUTH);
		 
	    //Add the panels and the table to the main panel
	    mainPanel.add(textPanel, BorderLayout.NORTH);
	    mainPanel.add(new JScrollPane(msgDetailsPanel), BorderLayout.WEST);
	    mainPanel.add(new JScrollPane(table), BorderLayout.CENTER);
	    
	    if (independentWindow) {
	    	jFrame.getContentPane().add(mainPanel);
		    jFrame.setBounds(x1, y1, x2, y2); 
		    jFrame.setTitle(panelTitle);
		    jFrame.setVisible(true); 
		    jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	    }
	    
	    AMQPHeaderText.setText("select a message record in the table...");
	        
	    //add listener to the table to enable to react to row selection
	    model.addListSelectionListener(new ListSelectionListener() {

	      public void valueChanged(ListSelectionEvent e) {

	        // JUST IGNORE WHEN USER HAS ATLEAST ONE SELECTION
	        if(e.getValueIsAdjusting())
	        {
	          return;
	        }
	        ListSelectionModel lsm=(ListSelectionModel) e.getSource();

	        if(lsm.isSelectionEmpty())
	        {
	          JOptionPane.showMessageDialog(null, "No selection");
	        }else
	        {
	          int selectedRow=lsm.getMinSelectionIndex();
	       //   JOptionPane.showMessageDialog(null, "XML Payload"+table.getValueAt(selectedRow,7));
	        }
	      }
	    });
	    
	    button.addActionListener((ActionListener) this);
	    
	}
	// ***************************************************
	// *** resizeColumnWidth
	// ***************************************************	
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==button) {
			if (bPaused) bPaused = false;
			else bPaused = true;
			Globals.guiWindowDebug.AddText("bPaused"+bPaused);			
		}
		
	}

	// ***************************************************
	// *** resizeColumnWidth
	// ***************************************************	
		public void resizeColumnWidth(JTable table) {
		    final TableColumnModel columnModel = table.getColumnModel();
		    for (int column = 0; column < table.getColumnCount(); column++) {
		        int width = 15; // Min width
		        for (int row = 0; row < table.getRowCount(); row++) {
		            TableCellRenderer renderer = table.getCellRenderer(row, column);
		            Component comp = table.prepareRenderer(renderer, row, column);
		            width = Math.max(comp.getPreferredSize().width +1 , width);
		        }
		        if(width > 15)
		            width=50;
		        columnModel.getColumn(column).setPreferredWidth(width);
		    }
		}
		
}
