import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

public class ListOfPlayersGraphs {

	private int nbPlayers = 0;
	private CopyOnWriteArrayList<PlayerGraph> listOfPlayersGraphs = new CopyOnWriteArrayList<>();
	
	public int getNbPlayers() {
		return nbPlayers;
	}
	public void setNbPlayers(int nbPlayers) {
		this.nbPlayers = nbPlayers;
	}
	public List<PlayerGraph> getListOfPlayersGraphs() {
		return listOfPlayersGraphs;
	}
	public void setListOfPlayersGraphs(CopyOnWriteArrayList<PlayerGraph> listOfPlayersGraphs) {
		this.listOfPlayersGraphs = listOfPlayersGraphs;
	}
	
   // ***********************************************************
   //  add a player to the list of players' graphs and increase the total nb of players of the list
   // ***********************************************************
	public int addPlayer (String playerName, String playerBG, GraphPoint initialGraphPoint) {
		PlayerGraph playerGraph = new PlayerGraph(playerName, playerBG, initialGraphPoint);
		listOfPlayersGraphs.add(playerGraph);
		this.setNbPlayers(this.getNbPlayers() + 1);
		return this.nbPlayers;
	}
	
   // ***********************************************************
   //  update list : add a player to the list of players' graphs if not already there
   // ***********************************************************	
	public boolean updatePlayerGraph (String playerName, String playerBG, GraphPoint graphPoint) {
		boolean player_Found = false;
		
		for (PlayerGraph next : this.listOfPlayersGraphs) {
			if (next.getPlayerBG().contentEquals(playerBG)) {
				player_Found = true;
				next.getGraphPointsList().add(graphPoint);	
				break;
			}
		}
		
		if (player_Found == false) {
			this.addPlayer(playerName, playerBG, graphPoint);
		}
		
		return player_Found;
	}
}
