import java.io.FileWriter;
import java.io.IOException;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.swing.JTable;
import javax.swing.JTextField;

public class MembersList {
	private CopyOnWriteArrayList<Member> membersList = new CopyOnWriteArrayList<>();
	
	public int getNbMembers() {
		return nbMembers;
	}
	public void setNbMembers(int nbMembers) {
		this.nbMembers = nbMembers;
	}
	private int nbMembers = 0;
	
	private final static String FILE_MEMBERS_NAME = "All Members List.csv";
	private final static String NEW_LINE_SEPARATOR ="\n";
	private final static String CSV_SEPARATOR =";";
	private final static String FILE_MEMBERS_LIST_HEADER = 	"Member ID"+CSV_SEPARATOR + 
														"Member Name" +CSV_SEPARATOR + 
														"state"
														+ NEW_LINE_SEPARATOR;
	// ***************************************************
	// *** WriteMembersListCSVFile
	// ***************************************************	
	public void WriteMembersListCSVFile() {
		try {
			FileWriter fileWriter = new FileWriter(FILE_MEMBERS_NAME);
			fileWriter.append(FILE_MEMBERS_LIST_HEADER);
			
			for (Member next : membersList) {
				String row = 	next.getMemberID() + CSV_SEPARATOR
								+ next.getMemberName() + CSV_SEPARATOR
								+ next.getMemberState()
								+ NEW_LINE_SEPARATOR;
				fileWriter.append(row);
			}			
			fileWriter.flush();
			fileWriter.close();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
	}
	// ***************************************************
	// *** Add a member to the list 
	// ***************************************************
	public int AddMember(String memberID, String memberName, String state, Log appLog) {
		Member  member = new Member();
		
		member.setMemberID(memberID);
		member.setMemberName(memberName);
		member.setMemberState(state);
		
		membersList.add(member);
		this.setNbMembers(this.getNbMembers() + 1);
		
		return this.nbMembers;
	}
		
	// ***************************************************
	// *** Find member name for a given MemberID
	// ***************************************************
	public Member ReturnMemberInfo(String memberID, Log appLog) {
		Member  member = new Member();
		boolean member_Found = false;
				
		for (Member next : membersList) {
			if ( next.getMemberID().contentEquals(memberID)) {
				member_Found = true;
				member.setMemberID(next.getMemberID());
				member.setMemberName(next.getMemberName());
				member.setMemberState(next.getMemberState());
				break;
			}
		}
		if (member_Found == false) {
			member.setMemberName("NOT_FOUND");
			member.setMemberState("NOT_FOUND");
			//appLog.logger.info("MemberID = "+ memberID + " not found in MembersList");
		}
		
		return member;
	}	
		
}
