
public class OrderBook {
private String contractId = "";
private String dlvryAreaId = "";
private String dlvryAreaName = "";

private String dlvryAreaLongName = "";
private String revisionNo = "";
private float lastPx = 0f;
private float lastQty = 0f;
private float totalQty = 0f;
private String lastTradeTime = "";
private String highPx = "";
private String lowPx = "";

private float fBestBid;
private float fBestAsk;
private String sBestBid = "";
private String sBestAsk = "";

// extra info not directly available in an order book
private String contractID_Product = "";
private String contractID_Product_DeliveryUnits = "";
private String contractID_Product_Predefined = "";

private String contractID_Name = "";
private String contractID_Area_State = "";
private String contractID_Area_Phase = "";
private boolean contractID_Area_Is_Tradable = false;
private int nbActiveOrders = 0;
private int spread = 0;
private int depthBid_NbOrders = 0;
private int depthAsk_NbOrders = 0;
public String lastUpdateTime = "";

public String getDlvryAreaName() {
	return dlvryAreaName;
}
public void setDlvryAreaName(String dlvryAreaName) {
	this.dlvryAreaName = dlvryAreaName;
}
public String getDlvryAreaLongName() {
	return dlvryAreaLongName;
}
public void setDlvryAreaLongName(String dlvryAreaLongName) {
	this.dlvryAreaLongName = dlvryAreaLongName;
}
public void setNbActiveOrders(int nbActiveOrders) {
	this.nbActiveOrders = nbActiveOrders;
}
public String getContractID_Product_Predefined() {
	return contractID_Product_Predefined;
}
public void setContractID_Product_Predefined(String contractID_Product_Predefined) {
	this.contractID_Product_Predefined = contractID_Product_Predefined;
}
public String getContractID_Product_DeliveryUnits() {
	return contractID_Product_DeliveryUnits;
}
public void setContractID_Product_DeliveryUnits(String contractID_Product_DeliveryUnits) {
	this.contractID_Product_DeliveryUnits = contractID_Product_DeliveryUnits;
}
public String getLastUpdateTime() {
	return lastUpdateTime;
}
public void setLastUpdateTime(String lastUpdateTime) {
	this.lastUpdateTime = lastUpdateTime;
}
public String getContractID_Name() {
	return contractID_Name;
}
public void setContractID_Name(String contractID_Name) {
	this.contractID_Name = contractID_Name;
}
public boolean getContractID_Area_Is_Tradable() {
	return contractID_Area_Is_Tradable;
}
public void setContractID_Area_Is_Tradable(boolean contractID_Area_Is_Tradable) {
	this.contractID_Area_Is_Tradable = contractID_Area_Is_Tradable;
}

public String getContractID_Product() {
	return contractID_Product;
}
public void setContractID_Product(String contractID_Product) {
	this.contractID_Product = contractID_Product;
}
public String getContractID_Area_State() {
	return contractID_Area_State;
}
public void setContractID_Area_State(String contractID_Area_State) {
	this.contractID_Area_State = contractID_Area_State;
	this.setContractID_Area_Is_Tradable(isContractTradable(this.getContractID_Area_State(),this.getContractID_Area_Phase())); 
}
public String getContractID_Area_Phase() {
	return contractID_Area_Phase;
}
public void setContractID_Area_Phase(String contractID_Area_Phase) {
	this.contractID_Area_Phase = contractID_Area_Phase;
	this.setContractID_Area_Is_Tradable(isContractTradable(this.getContractID_Area_State(),this.getContractID_Area_Phase()));
}

public String getContractId() {
	return contractId;
}
public void setContractId(String contractId) {
	this.contractId = contractId;
}
public String getDlvryAreaId() {
	return dlvryAreaId;
}
public void setDlvryAreaId(String dlvryAreaId) {
	this.dlvryAreaId = dlvryAreaId;
}
public String getRevisionNo() {
	return revisionNo;
}
public void setRevisionNo(String revisionNo) {
	this.revisionNo = revisionNo;
}
public float getLastPx() {
	return lastPx;
}
public void setLastPx(float lastPx) {
	this.lastPx = lastPx;
}
public float getLastQty() {
	return lastQty;
}
public void setLastQty(float lastQty) {
	this.lastQty = lastQty;
}
public float getTotalQty() {
	return totalQty;
}
public void setTotalQty(float totalQty) {
	this.totalQty = totalQty;
}
public String getLastTradeTime() {
	return lastTradeTime;
}
public void setLastTradeTime(String lastTradeTime) {
	this.lastTradeTime = lastTradeTime;
}
public String getHighPx() {
	return highPx;
}
public void setHighPx(String highPx) {
	this.highPx = Globals.getPriceWithDecimals(highPx);
}
public String getLowPx() {
	return lowPx;
}
public void setLowPx(String lowPx) {
	this.lowPx = Globals.getPriceWithDecimals(lowPx);
}
public int getNbActiveOrders() {
	return nbActiveOrders;
}
public void setNbOrders(int nbActiveOrders) {
	this.nbActiveOrders = nbActiveOrders;
}
public int getSpread() {
	return spread;
}
public void setSpread(int spread) {
	this.spread = spread;
}
public int getDepthBid_NbOrders() {
	return depthBid_NbOrders;
}
public void setDepthBid_NbOrders(int depthBid_NbOrders) {
	this.depthBid_NbOrders = depthBid_NbOrders;
}
public int getDepthAsk_NbOrders() {
	return depthAsk_NbOrders;
}
public void setDepthAsk_NbOrders(int depthAsk_NbOrders) {
	this.depthAsk_NbOrders = depthAsk_NbOrders;
}
// Determines if a contact is tradable
public boolean isContractTradable(String state,String  phase) {
	if (state.contentEquals("ACTI") &&  (phase.contentEquals("CONT")) || phase.contentEquals("SDAT")) {
		return true;
	}
	else return false;
}
public float getfBestBid() {
	return fBestBid;
}
public void setfBestBid(float fBestBid) {
	this.fBestBid = fBestBid;
}
public float getfBestAsk() {
	return fBestAsk;
}
public void setfBestAsk(float fBestAsk) {
	this.fBestAsk = fBestAsk;
}
public String getsBestBid() {
	return sBestBid;
}
public void setsBestBid(String sBestBid) {
	this.sBestBid = sBestBid;
}
public String getsBestAsk() {
	return sBestAsk;
}
public void setsBestAsk(String sBestAsk) {
	this.sBestAsk = sBestAsk;
}
}
