import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

public class ThrottlingDataList {
	public CopyOnWriteArrayList<ThrottlingStatus> throttlingDataList = new CopyOnWriteArrayList<>();
	boolean onGoingCooldown = false;

	public void Add(ThrottlingStatus throttlingStatus, ControlBoard controlBoardFrame) {
		// determine if short cooldown started
		if (throttlingStatus.Short_OmtCount != null & !"".contentEquals(throttlingStatus.Short_OmtCount) 
				&& throttlingStatus.Short_L1 != null & !"".contentEquals(throttlingStatus.Short_L1)) {
			int short_L1 = Integer.parseInt(throttlingStatus.Short_L1);
			int short_OmtCount = Integer.parseInt(throttlingStatus.Short_OmtCount);
			
			if ("RESTRICTED".contentEquals(throttlingStatus.Short_status) && short_OmtCount >= short_L1) onGoingCooldown = false;
			
			if ("RESTRICTED".contentEquals(throttlingStatus.Short_status) && short_OmtCount < short_L1 && !onGoingCooldown) {
				throttlingStatus.cooldownTheoreticalStart = "1";
				onGoingCooldown = true;
				controlBoardFrame.AddText("Cooldown start", controlBoardFrame.textAreaMessages);
			}
		}
		else throttlingStatus.cooldownTheoreticalStart = "0";
		
		// exit cooldown when status not RESTRICTED anymore
		if (
			("NO_RESTRICTION".contentEquals(throttlingStatus.Short_status) || "WARNING".contentEquals(throttlingStatus.Short_status))
					&& onGoingCooldown
			) {
			onGoingCooldown = false;
			controlBoardFrame.AddText("Cooldown end", controlBoardFrame.textAreaMessages);
			throttlingStatus.cooldownTheoreticalStart = "2"; // different value to display a different color
		}

		this.throttlingDataList.add(throttlingStatus);
	}
}
