import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.swing.JOptionPane;

public class UsersList {
	private CopyOnWriteArrayList<User> usersList = new CopyOnWriteArrayList();
	ControlBoard controlBoardFrame;
	
	private final static String FILE_USERS_LIST_NAME = "All Users.csv";
	private final static String NEW_LINE_SEPARATOR ="\n";
	private final static String CSV_SEPARATOR =";";
	private final static String FILE_USERS_LIST_HEADER = 
														"User Id"+CSV_SEPARATOR
														+ "Login Id"+CSV_SEPARATOR
														+ "User Name"+CSV_SEPARATOR
														+ "User Code"+CSV_SEPARATOR
														+ "Email"+CSV_SEPARATOR
														+ "State"+CSV_SEPARATOR
														+ "Default BG"+CSV_SEPARATOR
														+ "Member Id"+CSV_SEPARATOR
														+ "Member Name"+CSV_SEPARATOR
														+ "Revision No"+CSV_SEPARATOR
														+ "Assigned BG" + CSV_SEPARATOR
														+ "User Roles" 
														+ NEW_LINE_SEPARATOR;
	//
	// constructor
	public UsersList(ControlBoard controlBoardFrame) {
		this.controlBoardFrame = controlBoardFrame;
	}
	
	// *********************
	// add user
	// *********************
	public void AddUser(User user) {
		this.usersList.add(user);
	}
	
	// ***************************************************
	// *** WriteOrderBooksListCSVFile
	// ***************************************************	
	public void WriteCSVFile() throws Exception {
		try {
	         File f = new File(FILE_USERS_LIST_NAME);
	         if(!f.exists()) {
	            f.createNewFile();
	         }
	         
			FileWriter fileWriter = new FileWriter(FILE_USERS_LIST_NAME);
			
			if(f.length() == 0) fileWriter.append(FILE_USERS_LIST_HEADER);
				
			for (User next : usersList) {
				String row = 	next.userId + CSV_SEPARATOR
								+ next.loginId + CSV_SEPARATOR
								+ next.userName + CSV_SEPARATOR
								+ next.usrCode + CSV_SEPARATOR
								+ next.mailAddress + CSV_SEPARATOR
								+ next.state + CSV_SEPARATOR
								+ next.defaultBG + CSV_SEPARATOR  
								+ next.mbrId + CSV_SEPARATOR
								+ next.mbrName + CSV_SEPARATOR
								+ next.revisionNo + CSV_SEPARATOR
								+ next.assignedBGList + CSV_SEPARATOR
								+ next.userRoles
								+ NEW_LINE_SEPARATOR;
				fileWriter.append(row);
				}	
			
			fileWriter.flush();
			fileWriter.close();				
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			String msg = "the " + FILE_USERS_LIST_NAME + " file cannot be accessed : please check it is well closed."; 
			JOptionPane.showMessageDialog(controlBoardFrame, msg);
			
		}
	}
}
