// -------------------------------------------------------------------------------------------------------------------------------------

// Dear API client,

// We kindly remind you that this sample data is provided to you for information and trial purpose only.                

// You shall make use according to our General Conditions applicable to EPEX SPOT Information Product that you expressly accepted.     

// Therefore, you are not entitled to access and use it for External Usage, including commercial purposes.                

// Moreover, in no case should EPEX SPOT be held liable for the content of this data.                           

// Kind regards,

// Your EPEX SPOT Market Data Team

// -------------------------------------------------------------------------------------------------------------------------------------

// maj 2
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.security.GeneralSecurityException;
import java.security.KeyStore;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.ZoneId;
import java.time.ZoneOffset;
import java.time.ZonedDateTime;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Properties;
import java.util.Random;
import java.util.UUID;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import java.util.function.Supplier;
import java.util.logging.Level;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManagerFactory;
import javax.swing.DebugGraphics;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;

import com.rabbitmq.client.AMQP;
import com.rabbitmq.client.AuthenticationFailureException;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import com.rabbitmq.client.DeliverCallback;
import com.rabbitmq.client.ShutdownListener;
import com.rabbitmq.client.ShutdownSignalException;
import com.rabbitmq.client.MessageProperties;

//import XML related packages
import org.w3c.dom.*;

import javax.xml.parsers.*;
import org.xml.sax.*;

public class SampleCode {

	// retrieve connection parameters from the config.properties file
	private sampleGetPropertyValues properties = new sampleGetPropertyValues();

	// please use that user only if you have connectivity issues with your own ADV
	// SIMU API user provided by market operators
	private String userName = "";
	private String password = "";
	private String rabbitHost1 = "";
	private String rabbitHost2 = "";
	private String rabbitVHost = "";
	private int rabbitPort = 0;
	private String certPassword = "";
	private String certPath = "";
	private String applicationID = "";
	private String processBroadcast = "";
	private String manageOrderBooks = "";
	public String sentMsgContentEncoding = "";
	private String orderGeneration = "";
	private int adminRetrieveOrdersPastDaysShift = 0;
	private String adminRetrieveOrdersPast = "";
	private String throttlingActivated = "";
	private String marketAnimation = "";
	private String fillEmptyOrderBooks = "";
	public String throttlingStatusReqIntervalMillisec;
	private String sendThrottlingStatusReqAfterEachOrder;

	private int nbOfOrdersConfigFile = 0;
	private String orderGenerationIntervalMillisec = "";
	private String randomIntervalBetweenOrders = "";
	private int nbOfOrdersPerBasket = 1;
	private String basketListExecInst = "";
	int intOrderGenerationIntervalMillisec = 5000;
	private int nbResponses = 0;
	private String disconnectAction = "";
	private String throttlingMemberAction = "";
	private String throttlingUserAction = "";
	private String privateResponseQueueNameSuffix = "";
	public String loginReqLoop = "";
	public String logoutsBetweenLogins = "";
	public String waitingTimeBetweenLoginsMillisec = "";
	private String userPasswordChange ="false";
	int throttlingStatusReqNb = 0;

	// AMQP channels
	Channel requestChannel = null;
	Channel responseChannel = null;

	// queues
	private static String RESPONSE_QUEUE = "";
	private static String REQUEST_EXCHANGE = "";
	public static String BROADCAST_QUEUE = "";
	private static final String ROUTING_KEY_INQUIRY = "m7.request.inquiry";
	private static final String ROUTING_KEY_INQUIRY_THROTTLING = "m7.request.inquiry.throttling"; // M7 6.12
	private static final String ROUTING_KEY_MANAGEMENT = "m7.request.management";
	private boolean autoAck = true;
	private boolean exclusive = true;
	private boolean autoDelete = true;

	// AMQP message
	AMQP.BasicProperties.Builder headers = null;

	// AMQP connection
	public AMQPConnection amqpConnection = null;
	private int connectionLossNb = 0;

	// Login/Logout
	private String currentSessionId = "";
	private String memberId = "";
	private String memberName = "";
	private String userId = "";
	private String userCode = "";
	private int loginReqAttemptNb = 0;
	private int logoutReqAttemptNb = 0;
	private boolean bWaitingForLogoutReport = false;

	// Log
	private static final String MESSAGE_ENCODING = "UTF-8";
	public Log appLog = null;

	private SimpleDateFormat sdf = new SimpleDateFormat("E yyy/MM/dd HH:mm:ss.SSS");
	private SimpleDateFormat sdfTime = new SimpleDateFormat("HH:mm:ss.SSS");
	private SimpleDateFormat sdfStats = new SimpleDateFormat("yyy/MM/dd HH:mm:ss.SSS");
	private SimpleDateFormat sdfStatsWithDash = new SimpleDateFormat("yyy-MM-dd HH:mm:ss.SSS");
	private SimpleDateFormat sdfUTCWithDash = new SimpleDateFormat("yyy-MM-dd'T'HH:mm:ss.SSS'Z'");
	private SimpleDateFormat sdfPlayers = new SimpleDateFormat("yyy/MM/dd HH:mm:ss.SSS");

	// dates
	String hourPattern = "HH:mm:ss.SSS";
	String pattern = "yyyy-MM-dd";

	// GUI
	ControlBoard controlBoardFrame;

	private String responseQueue = null;
	JTable statsTable = null;
	JTable playersTable = null;
	JTable orderBooksTable = null;
	JTable ordersTable = null;
	JTable ThrottlingTable = null;
	JTextField durationTextField = null;
	JTextField commentTextField = null;
	JTextField commentTextPlayers = null;
	JTextField commentTextOrderBooks = null;
	JTextField commentTextOrders = null;
	JTextField commentTextThrottling = null;
	WindowOGStartStop windowOrderGenerationControl = null;

	int MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS = 120;

	DrawMarketLoad loadChart = null;
	DrawEmptyObkFrame emptyObkChart = null;
	ThrottlingDataChartFrame throttlingDataChart_ShortRule = null;
	ThrottlingDataChartFrame throttlingDataChart_LongRule = null;
	
	int iThrottlingData_Short_OW = 0; // short observation window/period

	// delivery areas
	DeliveryAreaList deliveryAreaList;
	
	// users
	UsersList usersList;

	// products
	// delivery areas
	ProductList productList;
	// contact management
	private String tradableContractId = "NOT_FOUND";

	// order management
	String orderRequest = "";
	int orderNb = 0;
	String userDefaultBalancingGroup = "";
	
	// trades
	TradesList tradesList = null;
	
	// login durations
	LoginDurationsList loginDurationsList = null; 

	// OMT activity calculation: Total means local + remote (XBID) orders
	private static int broadcastNb = 0;
	private static long UserOrderEventsNbM7 = 0; // local + remote/XBID orders events initiated by the user (versus the
													// system)
	private static int UserOrderEventsNb_M7_EPEXOrderGenerator = 0; // corresponding to a specific BG used by EPEX to
																	// generate orders in test
	private static int UserOrderEventsNb_Remote_EPEXOrderGenerator = 0;
	private static float projectionUserOrderEventsLocal_EPEX_OG = 0;
	private static float projectionUserOrderEventsTotal_EPEX_OG = 0;
	private static float projectionUserOrderEventsRemote_EPEX_OG = 0;
	private static String EPEX_ORDER_GENERATOR_BG = "11XTM1-TM------1";
	private static int UserOrderEventsNbRemote = 0;
	private static int UserOrderEventsNbLocal = 0;

	private static int UserOrderEventsNb_Local_EPEXOrderGenerator = 0;

	private static float EPEX_OG_vs_Total_M7_Order_Ratio = 0;
	private static float EPEX_Local_OG_vs_Market_Local_Order_Ratio = 0; // share of EPEX local OMTs amongst the total
																		// OMT activity (local can be a local product on
																		// the XBID areas OR GB OR CH)
	private static float EPEX_Remote_OG_vs_Market_Remote_Order_Ratio = 0; // share of XBID local OMTs amongst the total
																			// OMT activity
	private static float EPEX_Remote_vs_Total_Order_Ratio = 0; // within the EPEX OMT activity: ratio between remote and
																// total (local + remote) orders
	private static float Market_Remote_vs_Total_Order_Ratio = 0;

	private static int tradeEventsNbRemote = 0;
	private static int tradeEventsNbTotal = 0;
	private static int tradeEventsUnknownContract = 0;

	private static float projectionUserOrderEventsLocal = 0;
	private static float projectionUserOrderEventsRemote = 0;
	private static float projectionUserOrderEventsTotal = 0;

	private static float projectionTradeEventsLocal = 0;
	private static float projectionTradeEventsTotal = 0;
	private static float projectionTradeEventsRemote = 0;

	String formattedProjectionUserOrderEventsTotal = "";
	String formattedProjectionUserOrderEventsLocal = "";
	String formattedProjectionUserOrderEventsRemote = "";
	String formattedprojectionUserOrderEventsTotal_EPEX_OG = "";
	String formattedprojectionTradeEventsTotal = "";

	private int nbofXBIDPublicTradeSlot1 = 0;
	private int nbofXBIDPublicTradeSlot2 = 0;
	private int nbofXBIDPublicTradeSlot3 = 0;
	public static String NOT_FOUND = "NOT_FOUND";

	private static int totalOMTcount_approximation_DayD = 0;

	private String ThrottlingStatusResp = "";
	private int memberThrottlingStatusRespShortOMTCount = 0;
	private int memberThrottlingStatusRespLongOMTCount = 0;
	private String throttlingTimestamp = "";
	// private String throttlingStatus = "";

	// Throttling
	ThrottlingStatus throttlingStatus = new ThrottlingStatus(controlBoardFrame);
	Thread tThrottling;

	// M7 heartbeats
	private static final int HEARTBEAT_LOSS_INTERVAL = 20;
	int m7HeartbeatNb = 0;
	long broadcastListeningStart = 0;
	long applicationStartNanoTime = 0;
	long applicationStartMillisecondsTime = 0;
	Instant applicationStartTimeInstant = null;
	long previous_M7HearbeatReceptionTime = 0;
	int nbOfM7HeartbeatLosses = 0;
	double m7HeartbeatDifference = 0;
	String m7HeartbeatDifferenceString = null;

	boolean contractInfoReportOnGoingProcessing = true; // block the processing of broadcasts which require to know
														// Contract IDs until the response to the initial Contract Info
														// Report is known
	boolean accountInfoReportOnGoingProcessing = true;
	boolean allMembersRespOnGoingProcessing = true;
	boolean allOrderBooksMsgOnGoingProcessing = true;
	boolean fullOrderCapturegOnGoingProcessing = false;
	boolean AreaInfoReportOnGoingProcessing = false;

	// Routing keys
	RoutingKeysList routingKeysList = null;
	RoutingKeysList missingRoutingKeysList = null;

	// requests responses
	RequestResponseList request_responseList = null;
	private final boolean RESP_MANDATORY_TO_START = true;
	private final boolean RESP_OPTIONAL_TO_START = false;

	// broadcasts
	BroadcastList broadcastList = null;
	GUI_Panel broadcast_GUI_Panel = null;
	GUI_Panel contract_GUI_Panel = null;

	// market players for order stats
	OrderPlayersList orderPlayersList = null;

	// order books
	OrderBooksList orderBooksList = null;
	EmptyOrderBooksList emptyOrderBooksList = null;
	int orderNbFillOBK = 0;
	int nbErrResp = 0;
	int MAX_OBK_ROWS = 7000;
	int MAX_ORDER_ROWS = 10000;

	// total OMT
	int nbOMTBeforeStart = 0;
	Globals global = null;

	// format
	NumberFormat format = NumberFormat.getNumberInstance();

	// 6.12 features
	boolean bThrottlingEnabled = false;

	// admin or trader user / app execution mode
	boolean adminMode = false;

	// sync requests and responses
	int contractWaitLoop = 0;
	
	// log and GUI text messages
	String msg = "";

	// CSV files
	private final static String FILE_STATS_NAME = "Stats for Graph.csv";
	private final static String FILE_PLAYERS_DETAILS_NAME = "User Order Events Players Details.csv";
	private final static String NEW_LINE_SEPARATOR = "\n";
	private final static String CSV_SEPARATOR = ";";
	private final static String FILE_STATS_HEADER = "Time" + CSV_SEPARATOR + "Projection 24H Orders TOTAL"
			+ CSV_SEPARATOR + "Projection 24H Orders Local" + CSV_SEPARATOR + "Projection 24H Orders Remote"
			+ CSV_SEPARATOR + "Orders TOTAL" + CSV_SEPARATOR + "Orders Local" + CSV_SEPARATOR + "Orders Remote"
			+ CSV_SEPARATOR + NEW_LINE_SEPARATOR;

	private final static String FILE_PLAYERS_LIST_HEADER = "Start Time" + CSV_SEPARATOR + "Last Update" + CSV_SEPARATOR
			+ "Member ID" + CSV_SEPARATOR + "Member Name" + CSV_SEPARATOR + "BG" + CSV_SEPARATOR + "Total"
			+ CSV_SEPARATOR + "Local" + CSV_SEPARATOR + "Remote" + CSV_SEPARATOR + "Total vs Market ratio"
			+ CSV_SEPARATOR + "Local vs Market ratio" + CSV_SEPARATOR + "Projection 24h Total" + CSV_SEPARATOR
			+ "Projection 24h Local" + CSV_SEPARATOR + "Projection 24h Remote" + NEW_LINE_SEPARATOR;

	FileWriter statsFileWriter = null;

	// optional features
	boolean submitHistoricalOrder = false;
	List<Order> orderList = null;
	List<OrderBeingProcessed> orderBeingProcessedByM7List = null;
	OrdersList ordersList = new OrdersList(ordersTable, commentTextOrders, MAX_ORDER_ROWS);
	ThrottlingDataList throttlingDataList = new ThrottlingDataList();

	// Contract list to be initialized with Contract Info Req Response + contract
	// broadcasts
	static ContractList contractList = null;

	// BG Member data
	BG_Member_List bgMemberList;
	MembersList membersList = new MembersList();

	// ****************************
	// SampleCode
	// ****************************
	private SampleCode() throws Exception {

		// initialization to be done only at app launch 
		applicationStartNanoTime = System.nanoTime();
		applicationStartMillisecondsTime = System.currentTimeMillis();
		applicationStartTimeInstant = Instant.now();
		
		// log all messages - all API messages will be logged for demo purposes
		appLog = new Log("Log.txt");
		appLog.logger.setLevel(Level.FINE);
		appLog.logger.info(sdf.format(new Date()) + "ms ; Sample app start");
		
		// initialize variables and read config parameters (at app launch time and at shutdown time)
		Init();
		Init_Files();
		
		// GUI creation
		CreateGUI();

		// Globals variables
		global = new Globals(controlBoardFrame);
		
		// establish a technical connection with one of the two API end points (see  DFS180 Client Failover)
		BROADCAST_QUEUE = "m7.broadcastQueue." + userName;
		
		// 	RESPONSE_QUEUE 	= "m7.private.responseQueue." + userName + "." + UUID.randomUUID();
		// MANDATORY CHANGE with 6.13 : private response queue new naming convention + max 10 private response queues!
		RESPONSE_QUEUE 	= "m7.private.responseQueue." + userName + "." + privateResponseQueueNameSuffix; // queue<1-10>
		REQUEST_EXCHANGE= "m7.requestExchange." + userName;

		amqpConnection = openNewAMQPConnection();

		try {
			postAMQPConnectionActions(amqpConnection.connection);

		} catch (InterruptedException e) {
			e.printStackTrace();
			controlBoardFrame.AddText(e.toString(), controlBoardFrame.textAreaConnection);
		} catch (IOException e) {
			e.printStackTrace();
			controlBoardFrame.AddText(e.toString(), controlBoardFrame.textAreaConnection);
		}
	}

	// **********************************
	// postAMQPConnectionActions
	// **********************************
	public void postAMQPConnectionActions(Connection conn) throws InterruptedException, IOException {
		long start_time = System.nanoTime();

		// add a shutdown listener to catch AMQP (dis)connections issues
		conn.addShutdownListener(new ShutdownListener() {
			public void shutdownCompleted(ShutdownSignalException cause) {

				connectionLossNb++;
				Globals.AMQPConnectionLossNb++;
				
				controlBoardFrame.initConnection(null);
				controlBoardFrame.connectionLoss();

				clear_Lists_Shutdown();
				
				m7HeartbeatNb = 0; // reset the nb of M7 heartbeats to avoid detecting a false heartbeat loss
				currentSessionId = "";
				memberId = "";
				userId = "";
				
				Globals.bBroadcastProcessingCanStart = false;
				if ("true".contentEquals(adminRetrieveOrdersPast))
					Globals.Init(); // reset all counts when counting historical orders in case of a disconnection,
									// because the whole request process will restart

				// clear the players activity table
				orderPlayersList.cleanGUITable(playersTable, playersTable.getRowCount(), playersTable.getColumnCount());

				msg = "CONNECTION LOSS #" + connectionLossNb
						+ " !!! Shutdown listener: AMQP Connection Interrupted !!! Cause: '" + cause + "' reason : '"
						+ cause.getReason() + "'";
				
				controlBoardFrame.AddText("", controlBoardFrame.textAreaConnection);
				controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);

				// refresh Graph
				if (adminRetrieveOrdersPastDaysShift == 0)	loadChart.repaint();

				// close the AMQP connection is still opened
				if (conn != null) {
					if (conn.isOpen()) {
						try {
							conn.close();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
							msg = "Connection was still open : tried to close it : resulted in error: " + e.toString();
							appLog.logger.info(msg);
							controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
						}
					}
				}

				// wait for 10 seconds before trying to establish a new connection
				// an exponential back off mechanism should be implemented (gradually wait for
				// more and more seconds until stabilizing at 60 seconds - see API Package API
				// presentation slides content)
				try {
					Thread.sleep(10000);
				} catch (InterruptedException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				msg = "Attempt to establish a new AMQP connection";
				appLog.logger.info(msg);
				controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);

				try {
					// restart the app now a new AMQP connection has been created
					amqpConnection = new AMQPConnection(userName, password, rabbitHost1, rabbitHost2,
							rabbitPort, rabbitVHost, certPath, certPassword, applicationID, controlBoardFrame, appLog);
					amqpConnection.ConnectWithClientFailover(controlBoardFrame);
					postAMQPConnectionActions(amqpConnection.connection);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					msg = e.toString();
					controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					msg = e.toString();
					controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
				}
			}
		});

		// create the request & response channels
		requestChannel = conn.createChannel();
		responseChannel = conn.createChannel();

		// create 1st the private response queue you need for that connection:
		// RESPONSE_QUEUE = "m7.private.responseQueue." + userName + "." +
		// UUID.randomUUID();
		try {
			// Declare your private response queue as durable in order to survive a broker restart. 
			// note: A durable queue only means that the queue definition will survive a server restart, not the messages in it.
			responseQueue = responseChannel.queueDeclare(RESPONSE_QUEUE, 
														 false, // durable
														 true,  // exclusive
														 true,  // auto delete
														 new HashMap<>()).getQueue();
		} catch (Exception e) {
			msg = "Queue : " + RESPONSE_QUEUE + " could not be created : " + e.toString();
			Globals.guiWindowDebug.AddText(msg);
			appLog.logger.severe(msg);
			JOptionPane.showMessageDialog(controlBoardFrame, msg);
		}
		if (responseQueue != null) {
			msg = "Private response queue successfully created: " + responseQueue.toString();
			Globals.guiWindowDebug.AddText(msg);
			appLog.logger.severe(msg);
			controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
		}

		if (!"gzip".contentEquals(sentMsgContentEncoding)) sentMsgContentEncoding ="";
		headers = new AMQP.BasicProperties.Builder().userId(userName).contentType("x-m7/request; version=6.0")
				.headers(Collections.singletonMap("app-version", "0.1")) // your app version
				.appId(applicationID) //
				.replyTo(responseQueue)
				.contentEncoding(sentMsgContentEncoding);
			//	.deliveryMode(MessageProperties.PERSISTENT_TEXT_PLAIN.getDeliveryMode()); //

		// register to the private queue ; messages will then be delivered automatically
		// as they arrive
		System.out.println(" [*] Waiting for messages. To exit close the GUI");

		// **************************
		// Response DELIVERY CALLBACK
		// **************************
		DeliverCallback responseDeliverCallback = (consumerTag, delivery) -> {

			String correlationID = delivery.getProperties().getCorrelationId();

			nbResponses++;
			AMQPMessage message = new AMQPMessage(request_responseList, "RESPONSE");

			// search for a request with the same correlation Id and indicate the response
			// was received
			// before the message is unzipped (can be long)
			request_responseList.updateRequestWithResponseTime(correlationID, delivery.getProperties().getType(),
					Globals.REQ_STATE_RECEIVED);
			try {
				request_responseList.updateGUITable(controlBoardFrame.request_response_GUI_Panel);
			} catch (Exception e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
				String error = "catching error: " + e2.toString();
				appLog.logger.severe(error);
			}

			controlBoardFrame.updateBroadcastProcessingStatus();

			// unzip the message if required
			message.processMessage(delivery, appLog, "RESPONSE");

			Globals.guiWindowDebug
					.AddText("====> response #" + nbResponses + " found : START of responseDeliverCallback "
							+ message.type + " correlation ID = " + message.correlationId);

			//appLog.logger.warning("<= received response : correlation id: " + correlationID + " "
			//		+ message.amqpProperties + " \n" + message.xmlMessagePayload);
			Globals.guiWindowDebug
					.AddText(" response = " + message.amqpProperties + " \n=" + message.xmlMessagePayload);

			//System.out.println(message.clientReceptionTime + " " + message.AMQPSendingTime + " " + message.type + " "
			//		+ message.routingKeyName + " " + message.sequenceNo + " " + message.xmlMessagePayload);

			try {
				// add the new response to the table
				request_responseList.AddRequestResponse("RESPONSE", message.contentEncoding , message.clientReceptionTime,
						message.AMQPSendingTime, message.type, message.routingKeyName, message.correlationId,
						message.xmlMessagePayload, false);
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
				Globals.guiWindowDebug.AddText(e1.toString());
				appLog.logger.severe(e1.toString());
			}

			// update the GUI response table
			try {
				request_responseList.updateGUITable(controlBoardFrame.request_response_GUI_Panel);
			} catch (Exception e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
				String error = "catching error: " + e2.toString();
				appLog.logger.severe(error);
			}

			try {
				request_responseList.WriteCSVFile();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				msg = "Error writing request_reponseList to a file : " + e.toString();
				Globals.guiWindowDebug.AddText(msg);
				this.appLog.logger.warning(msg);
			}

			String errorMsg = "";

			// In case of a successful login the response is a User Report message
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.UserRprt")) {
				// example:
				// <Usr sessionId="1615536330410" mbrName="Test Member 001" usrId="1243"
				// revisionNo="11" name="Test Trader (Sales)" usrCode="TRD014" mbrId="TM001"
				// defaultAcctId="11XTM1-TM------3"
				// state="ACTI"><AssgAcctId>11XTM1-TM------2</AssgAcctId><AssgAcctId>11XTM1-TM------3</AssgAcctId><AssgAcctId>11XTM2-TM------1</AssgAcctId><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole></Usr></UserRprt>
				
				this.parseUserRprt(message);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,	Globals.REQ_STATE_PROCESSED);
			}

			// In case of a successful logout you receive a LogoutReport
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.LogoutRprt")) {
				errorMsg = "*** SUCCESSFULLY LOGGED OUT of M7 ***";
				// store the session Id given in the User Report
				// example:
				// <?xml version="1.0" encoding="UTF-8" standalone="yes"?><LogoutRprt
				// xmlns="http://www.deutsche-boerse.com/m7/v6" usrId="1243"
				// sessionId="1615536330410" forced="false" ><StandardHeader
				// marketId="EPEX"/></LogoutRprt>

				// clear the current session ID
				bWaitingForLogoutReport = false;
				currentSessionId = "";
				controlBoardFrame.LoggedOut();
				controlBoardFrame.AddText("Logged out\n", controlBoardFrame.textAreaConnection);
				if ("false".contentEquals(logoutsBetweenLogins)) amqpConnection.closeConnection("following a Logout Report");
				
				try {
					Thread.sleep(5000);
				} catch (InterruptedException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);

				if ("false".contentEquals(logoutsBetweenLogins)) System.exit(0);
			}
			// ***********************************************
			// response = Market State Report
			// ***********************************************

			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.MktStateRprt")) {
				parseMktStateRprt(message);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
			}
			
			// ***********************************************
			// response = All Users Response
			// ***********************************************

			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.AllUsersResp")) {
				parseAllUsersResp(message);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,	Globals.REQ_STATE_PROCESSED);
			}		
			
			// ***********************************************
			// response = PblcTradeConfResp: count trades
			// ***********************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.PblcTradeConfRprt")) {

				appLog.logger.fine(sdf.format(new Date()) + "ms " + "*** PblcTradeConfRprt detected : "
						+ message.xmlMessagePayload);
				Globals.guiWindowDebug.AddText("*** PblcTradeConfRprt detected : " + message.xmlMessagePayload);

				// count trades
				DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
				DocumentBuilder builder;
				try {
					builder = docFactory.newDocumentBuilder();

					// Create a Document from a file or stream
					StringBuilder xmlStringBuilder = new StringBuilder();
					xmlStringBuilder.append(message.xmlMessagePayload);

					ByteArrayInputStream input = new ByteArrayInputStream(
							xmlStringBuilder.toString().getBytes("UTF-8"));
					Document document = null;
					try {

						document = builder.parse(input);
						document.getDocumentElement().normalize();

						// Extract the root element
						// Element root = document.getDocumentElement();

						NodeList nodeList = document.getElementsByTagName("PblcTradeConf");
						Globals.guiWindowDebug.AddText("nodeList =" + nodeList.toString());

						// update the count that corresponds to the correlation ID
						nbofXBIDPublicTradeSlot1 = nodeList.getLength();

						// display the count of trades corresponding to the request
						Globals.guiWindowDebug.AddText(" nbofXBIDPublicTradeSlot1 = " + nbofXBIDPublicTradeSlot1);
						Globals.guiWindowDebug.AddText("Nb of XBID public trades found between 00:00 and 07:00 UTC ="
								+ nbofXBIDPublicTradeSlot1);

					} catch (SAXException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();

					}

				} catch (ParserConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				msg = "*** end of Public Trade Conf Report parsing: took "
						+ (System.nanoTime() - start_time) / 1e6 + " ms";
				appLog.logger.fine(msg);
				controlBoardFrame.textAreaOwnTrades.append(msg);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
			}
			// ********************************************************************
			// response = Ack Response
			// ********************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.AckResp")) {
				ordersList.updateOrder_AckResp_CorrelationId(message.correlationId); // trace at order level that an Ack was received
				if (bThrottlingEnabled) {
					Globals.guiWindowDebug.AddText("update throttling data with AckResp");
					throttlingStatus.addNewThrottlingData(bThrottlingEnabled, "AckResp", message.clientReceptionTime,
							"", message.correlationId, windowOrderGenerationControl.strategy, "1", "0", "0", ordersList,
							throttlingDataChart_ShortRule, throttlingDataList);
					request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,	Globals.REQ_STATE_PROCESSED);
				}
			}
			// ********************************************************************
			// response = Error Response
			// ********************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.ErrResp")) {
				appLog.logger.warning("ERROR RESPONSE received : correlation id = " + message.correlationId);
				appLog.logger.warning("Correlation id = " + message.correlationId + " : " + message.amqpProperties);
				appLog.logger.warning("Correlation id = " + message.correlationId + " : " + message.xmlMessagePayload);
				
				Globals.guiWindowDebug.AddText(message.xmlMessagePayload);
				// guiWindowErrorResponse.AddText(sdfStats.format(new Date()) + " Correlation
				// Id:" + message.correlationId + " " + message.xmlMessagePayload);
				msg = "RESPONSE Correlation Id:" + message.correlationId + " " + message.xmlMessagePayload;
				controlBoardFrame.AddText(msg, controlBoardFrame.textAreaErrors);

				throttlingStatus.addNewThrottlingData(bThrottlingEnabled, "ErrResp", message.clientReceptionTime, "",
						message.correlationId, windowOrderGenerationControl.strategy, "0", "0", "1", ordersList,
						throttlingDataChart_ShortRule, throttlingDataList);

				// update the order table with the error Text
				String s = message.xmlMessagePayload;
				String prefix = "Error err=\"";
				s = s.substring(s.indexOf(prefix) + prefix.length());
				String[] result = s.split("\"");
				String errTxt = result[0];
				// get errCode
				prefix = "errCode=\"";
				s = s.substring(s.indexOf(prefix) + prefix.length());
				String[] resulterrCode = s.split("\"");
				String errCode = resulterrCode[0];

				String ErrStringForOrderTable = "Error " + errCode + ": " + errTxt;
				ordersList.updateOrderErrorResponse_CorrelationId(message.correlationId, ErrStringForOrderTable);  // trace at order level that an Error was received, with the Error Response text
				ordersList.unlock_Order(message.correlationId);
			}

			// ********************************************************************
			// response = All Members Report : upload received members in a list
			// ********************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.AllMbrsResp")) {
				createMembersList(message, membersList);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
			}
			// ********************************************************************
			// response = Account Info Report : upload received BG-Member couples in a list
			// ********************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.AcctInfoRprt")) {
				createBGMemberList(message, bgMemberList);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
			}

			// ********************************************************************
			// response = Area Info Report : upload received areas in a list
			// ********************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.DlvryAreaInfoRprt")) {
				parseAreaInfoReport(message, deliveryAreaList);
				deliveryAreaList.updateGUITable(controlBoardFrame.deliveryAreas_GUI_Panel);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
			}
			// ********************************************************************
			// response = Product Info Report : upload received product in a list
			// ********************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.ProdInfoRprt")) {
				parseProductInfoReport(message, productList);
				productList.updateGUITable(controlBoardFrame.products_GUI_Panel);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
				productList.WriteCSVFile();
			}
			
			// ********************************************************************
			// response = Contract Info Report: upload received contracts in a list
			// ********************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.ContractInfoRprt")) {
				try {
					parseContractInfoReport(message, Globals.guiWindowDebug);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					msg = "Error rparseContractInfoReport: " + e.toString();
					Globals.guiWindowDebug.AddText(msg);
					appLog.logger.severe(msg);
					JOptionPane.showMessageDialog(controlBoardFrame, msg);
				}
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
			}
			// ***********************************************************************************************
			// response = Public Order Books Response: upload order books (contract Id +
			// Area Id combinations)
			// ***********************************************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.PblcOrdrBooksResp")) {
				msg = "PblcOrdrBooksResp received";
				appLog.logger.fine(msg);
				Globals.guiWindowDebug.AddText(msg);
				if ("true".contentEquals(manageOrderBooks))  {
					// process the manage
					parseOrderBookMessage("RESPONSE", message, orderBooksList);
					// orderBooksList.updateGUITable( controlBoardFrame.orderBooks_GUI_Panel); //
					// now done directly in orderBooksList
					request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
							Globals.REQ_STATE_PROCESSED);
				}
			}
			// ********************************************************************************************
			// as of 6.12 response = Throttling Status Response: display updated data in a
			// dedicated panel
			// ********************************************************************************************
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.ThrottlingStatusResp")) {

				// message.clientReceptionTime = sdfTime.format(new Date());
				msg = "<= Received reponse: Correlation Id : " + message.correlationId + " "
						+ message.routingKeyName + " " + message.xmlMessagePayload + " " + message.amqpProperties;
				Globals.guiWindowDebug.AddText(msg);
				appLog.logger.warning(msg);

				// parse the message to extract values and display the response in the
				// indicators panel + update values in the throttling table
				memberThrottlingStatusRespShortOMTCount = 0;
				memberThrottlingStatusRespLongOMTCount = 0;
				throttlingTimestamp = "";
				ThrottlingStatusResp = message.xmlMessagePayload;

			/*	String keyWord = "<ThrottlingMemberStatus";
				String tempString = ThrottlingStatusResp;
				tempString = tempString.substring(tempString.indexOf(keyWord));
				tempString = tempString.replaceAll(">", ">\n");
				tempString = tempString.replaceAll("</ThrottlingMemberStatus>", "");
				tempString = tempString.replaceAll("</ThrottlingStatusResp>", "");
				ThrottlingStatusResp = tempString; */

				parseThrottlingStatusReponse(message);
				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,	Globals.REQ_STATE_PROCESSED);
				// loadChart.repaint(); // already done in the statistics part
				calculateOrdersAndTradesStatistics();
			}
			// ********************************************************************************************
			// FullOrdrCaptureResp for admins
			// ********************************************************************************************

			// count Order Exe Report to monitor the environment workload with an admin user
			if (message.type.equals("com.deutscheboerse.m7.trading.api.v6.FullOrdrCaptureResp")) {

				// nbOMTBeforeStart = nbOMTBeforeStart + countOMTOrderExeReport(message,
				// ordersList);

				/*
				 * msg = "nbOMTBeforeStart = "+ nbOMTBeforeStart; System.out.println(msg);
				 * guiWindowMsgReport.AddText(msg);
				 */
				int nbOMTinMessage = 0;
				calculateOrdersAndTradesStatistics();

				/*
				 * ParseXMLMessageRunnable parseXMLMessagerunnable = new
				 * ParseXMLMessageRunnable(controlBoardFrame, "FullOrdrCaptureResp",message, bgMemberList,
				 * orderPlayersList,ordersList, EPEX_ORDER_GENERATOR_BG, playersTable,
				 * commentTextPlayers, guiWindowMsgReport, appLog);
				 * 
				 * Thread threadParseMessage = new Thread(parseXMLMessagerunnable);
				 * 
				 * msg = "Starting thread... correlation = "+ message.correlationId;
				 * guiWindowMsgReport.AddText(msg); System.out.println(msg);
				 * threadParseMessage.start();
				 */

				try {
					nbOMTinMessage = parseOrderExeReport(message, ordersList, false);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					msg = "ERROR parse Order Exe Report RESPONSE : " + e.toString();
					appLog.logger.severe(msg);
					Globals.guiWindowDebug.AddText(msg);
					JOptionPane.showMessageDialog(controlBoardFrame, msg);
				}

				calculateOrdersAndTradesStatistics();
				fullOrderCapturegOnGoingProcessing = false; // enable to switch to the next request so that order events
															// can be processed with the right order

				msg = "\tCorrelation ID = " + message.correlationId + " FullOrdrCaptureResp processed, found: "
						+ nbOMTinMessage + " OMTs";
				// guiWindowMsgReport.AddText(msg);
				controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
				appLog.logger.info(msg);
				System.out.println(msg);

				request_responseList.updateRequestWithResponseTime(message.correlationId, message.type,
						Globals.REQ_STATE_PROCESSED);
			}

			// Globals.guiWindowDebug.AddText("<==== END of responseDeliverCallback");

		};

		// be ready to consume any incoming message in the private response queue
		responseChannel.basicConsume(responseQueue, autoAck, responseDeliverCallback, consumerTag -> {
		});

		// *********************************
		// Requests to be sent when starting
		// *********************************
		// Build login request
		String throttlingMemberActionString = "";
		String throttlingUserActionString = "";
		// add the throttling order deactivation attribute if working on the internal
		// acute environment
		if (bThrottlingEnabled) {
			// throttlingMemberAction = " throttlingMemberAction=\"HIBE_MBR_ORDERS\"";
			throttlingMemberActionString = " throttlingMemberAction=\"" + throttlingMemberAction + "\"";
			throttlingUserActionString = " throttlingUserAction=\"" + throttlingUserAction + "\"";
		}
		appLog.logger.fine("throttling Member Action='" + throttlingMemberAction + "'");
		appLog.logger.fine("throttling User Action='" + throttlingUserAction + "'");

		String loginMessage = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<LoginReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" user=\"" + userName
				+ "\" force=\"true\" disconnectAction=\"" + disconnectAction + "\"" + throttlingUserActionString
				+ throttlingMemberActionString + ">" + "<StandardHeader marketId=\"EPEX\"/>"
				+ "<clientData clientDataString =\"test sample client\"/>"
				+ "</LoginReq>";

		appLog.logger.info(loginMessage);
		Globals.guiWindowDebug.AddText(loginMessage);

		controlBoardFrame.AddText(loginMessage, controlBoardFrame.textAreaConnection);

		// trigger the Log in req loop in requested 
		do {
			
			// track the login sending time
			String loginSendingTime = sdfTime.format(new Date());
			Long loginSendingTime_Long = System.nanoTime();
			// Publish login request
			loginReqAttemptNb++;
			sendRequest(ROUTING_KEY_INQUIRY, "LoginReq", "LOGIN_" + connectionLossNb + "_"+ loginReqAttemptNb, loginMessage, RESP_MANDATORY_TO_START);
			
			// 1st log in : need to wait for the User report to be received to get a current Session ID
			// after a logout request wait for the logout report to be received
			while ("".contentEquals(currentSessionId)) {
				Thread.sleep(10);
			}
			
			// calculate the time for a successful login
			String loginDuration_Sec_String = String.format("%.3f",(System.nanoTime() - loginSendingTime_Long) / 1e9);
			controlBoardFrame.AddText("Time to log in: " + loginDuration_Sec_String + " seconds.", controlBoardFrame.textAreaConnection);
			
			LoginDuration loginDuration = new LoginDuration(loginSendingTime, loginDuration_Sec_String, logoutsBetweenLogins);
			//(loginDuration);
			loginDurationsList.loginDurationsList.add(loginDuration);
			loginDurationsList.WriteCSVFile();
			
			if ("true".contentEquals(loginReqLoop)) {
				if (loginReqAttemptNb < 36) logoutsBetweenLogins = "true";
				else logoutsBetweenLogins = "false";
			}
		
			// logout between 2 login requests if requested in the config file
			if ("true".contentEquals(logoutsBetweenLogins)) {
				// Publish login request
				this.Logout();
			}
			else if ("true".contentEquals(loginReqLoop)) currentSessionId = ""; // there will not be any logout to clear the session Id
			while (bWaitingForLogoutReport) {
				Thread.sleep(1000);
				System.out.println("waiting for logout report");
			}
			Thread.sleep(Integer.parseInt(waitingTimeBetweenLoginsMillisec)); 
		} while ("true".contentEquals(loginReqLoop));
		
		msg = "currentSessionId=" + currentSessionId + " ";
		controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
		
		boolean bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);

		msg = "admin mode = " + adminMode + " currentSessionId=" + currentSessionId + " ";
		controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
		
		// start sending periodic Throttling Status Requests
		if (bThrottlingEnabled) {
			appLog.logger.info("starting ThreadPeriodicThrottlingStatusReq");
			Runnable rThrottling = new ThreadPeriodicThrottlingStatusReq(this, amqpConnection); 
			tThrottling = new Thread(rThrottling);
			tThrottling.start();			
		}
		
		// monitor the nb of empty order books (if broadcasts are processed and if not retrieving orders from the past (as an admin)
		if ("true".contentEquals(processBroadcast) && !"true".contentEquals(adminRetrieveOrdersPast) ) {
			appLog.logger.info("starting ThreadUpdateOrderBooksGUI");
			Runnable rObkGUI = new ThreadUpdateOrderBooksGUI(orderBooksList, emptyObkChart, emptyOrderBooksList, controlBoardFrame.orderBooks_GUI_Panel, appLog); 
			Thread thread_ObkGUI = new Thread(rObkGUI);
			thread_ObkGUI.start();		
		}
		// SendModifyAllOrders("DELE");

		// change the password if requested?
		 if ("true".contentEquals(userPasswordChange)) {
				String changePasswordMessage = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
						+ "<ChgPwdReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" currentPwd=\"Test0202\" newPwd=\"Test0101\" >"
						+ "<StandardHeader marketId=\"EPEX\"/>" + "</ChgPwdReq>";
				
				// Publish login request
				sendRequest(ROUTING_KEY_MANAGEMENT, "ChgPwdReq", "CHANGE_PWD_" + connectionLossNb, changePasswordMessage, RESP_OPTIONAL_TO_START);			 
		 }


		/*
		 * <?xml version="1.0" encoding="UTF-8"?> <MsgReq
		 * xmlns="http://www.deutsche-boerse.com/m7/v6" acctId="MDTEX-BG1------X"
		 * startDate="2021-09-29T11:36:00.563Z" endDate="2021-09-29T11:37:12.563Z"
		 * type="ALL"> <StandardHeader marketId="EPEX"/> </MsgReq>
		 */

		// get PUBLIC AND PRIVATE messages from the last 10 minutes

		SimpleDateFormat simpleDateFormat = new SimpleDateFormat(pattern);
		String currentDate = simpleDateFormat.format(new Date());

		SimpleDateFormat simpleHourFormat = new SimpleDateFormat(hourPattern);
		String currentTimeUTCFormat = simpleHourFormat.format(new Date());

		// get current date hour minus 10 minutes
		Calendar calendar = Calendar.getInstance();
		// calendar.add(Calendar.MINUTE, -240);
		// String minusTenMnsTime = simpleHourFormat.format(calendar.getTime()); // get
		// yesterday

		/*
		 * String MessageReq ="<?xml version=\"1.0\" encoding=\"UTF-8\"?> " +
		 * "<MsgReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" acctId=\""+
		 * balancingGroup + "\" " + "startDate=\"" + currentDate+"T" + minusTenMnsTime +
		 * "Z"+ "\" endDate=\"" + currentDate +"T"+currentTimeUTCFormat + "Z" +
		 * "\" type=\"ALL\"" + ">" + "<StandardHeader marketId=\"EPEX\"/>" +
		 * "</MsgReq>";
		 */

		/*
		 * appLog.logger.info("MessageReq= "+MessageReq);
		 * Globals.guiWindowDebug.AddText("MessageReq= "+MessageReq);
		 * 
		 * requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_INQUIRY, true,
		 * false, headers.correlationId("MESSAGE_REQ").build(), MessageReq.getBytes());
		 */

		// retrieve all delivery areas, to be able to translate the EIC code (in
		// Contract Info Reports) into a "functional name"
		// retrieve the list of all BG - Member couples
		String sDlvryAreaInfoReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<DlvryAreaInfoReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + "</DlvryAreaInfoReq>";

		appLog.logger.info("DlvryAreaInfoReq= " + sDlvryAreaInfoReq);
		Globals.guiWindowDebug.AddText("DlvryAreaInfoReq= " + sDlvryAreaInfoReq);

		sendRequest(ROUTING_KEY_INQUIRY, "DlvryAreaInfoReq", "DELIVERY_AREA_INFO_REQ_"+connectionLossNb, sDlvryAreaInfoReq,
				RESP_MANDATORY_TO_START);
		bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);
		
		String sProdInfoReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<ProdInfoReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + "</ProdInfoReq>";

		appLog.logger.info("ProdInfoReq= " + sProdInfoReq);
		Globals.guiWindowDebug.AddText("DlvryAreaInfoReq= " + sProdInfoReq);

		sendRequest(ROUTING_KEY_INQUIRY, "ProdInfoReq", "PROD_INFO_REQ_"+connectionLossNb, sProdInfoReq,
				RESP_MANDATORY_TO_START);
		bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);
		
		if (adminMode) { // retrieve necessary data to relate Order Exe Report BG to member names
			// retrieve the list of all Member
			String ReqMembers = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
					+ "<AllMbrsReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\">"
					+ "<StandardHeader marketId=\"EPEX\"/>" + "</AllMbrsReq>";

			appLog.logger.info("ReqMembers= " + ReqMembers);
			Globals.guiWindowDebug.AddText("ReqMembers= " + ReqMembers);

			sendRequest(ROUTING_KEY_INQUIRY, "AllMbrsReq", "ALL_MEMBERS_REQ_"+connectionLossNb, ReqMembers, RESP_MANDATORY_TO_START);
		} else { // initialize the Members and Member/BG table with just the connected member/bg (data extracted from User Report)
			membersList.AddMember(memberId, memberName, "ACTI", appLog);
			membersList.WriteMembersListCSVFile();
		}
		// retrieve the list of all BG - Member couples
		String ReqAccountInfo = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<AcctInfoReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\">" + "<StandardHeader marketId=\"EPEX\"/>"
				+ "</AcctInfoReq>";

		appLog.logger.info("ReqAccountInfo= " + ReqAccountInfo);
		Globals.guiWindowDebug.AddText("ReqAccountInfo= " + ReqAccountInfo);

		boolean bRespToBGReq;
		if (adminMode)
			bRespToBGReq = RESP_MANDATORY_TO_START;
		else
			bRespToBGReq = RESP_OPTIONAL_TO_START;

		sendRequest(ROUTING_KEY_INQUIRY, "AcctInfoReq", "ACCOUNT_INFO_REQ_"+connectionLossNb, ReqAccountInfo, bRespToBGReq);
		bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);
		
		// retrieve the users list
		String mbrIdPart=""; // mandatory for traders
		if (!adminMode)  mbrIdPart = "<mbrId>" + memberId + "</mbrId>";
		String ReqAllUsersReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<AllUsersReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\">" + "<StandardHeader marketId=\"EPEX\"/>"
				+ mbrIdPart
				+ "</AllUsersReq>";

		appLog.logger.info("AllUsersReq= " + ReqAllUsersReq);
		Globals.guiWindowDebug.AddText("AllUsersReq= " + ReqAllUsersReq);

		sendRequest(ROUTING_KEY_INQUIRY, "AllUsersReq", "ALL_USERS_REQ_"+connectionLossNb, ReqAllUsersReq, RESP_OPTIONAL_TO_START);
		bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);


		// inquiry request example: Retrieve Public Order Book content
		/*
		 * String ReqOrderBookMessage ="<?xml version=\"1.0\" encoding=\"UTF-8\"?> " +
		 * "<PblcOrdrBooksReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" contractType=\"ALL\" openCloseInd=\"O\">"
		 * + "<StandardHeader marketId=\"EPEX\"/>" +
		 * " <prodName>XBID_Hour_Power</prodName>" +
		 * " <prodName>Intraday_Hour_Power</prodName>" +
		 * " <dlvryAreaId>10YDE-ENBW-----N</dlvryAreaId>" + "</PblcOrdrBooksReq>";
		 * 
		 * appLog.logger.info("ReqOrderBookMessage= "+ReqOrderBookMessage);
		 * Globals.guiWindowDebug.AddText("ReqOrderBookMessage= "+ReqOrderBookMessage);
		 * 
		 * requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_INQUIRY, true,
		 * false, headers.correlationId("PblcOrdrBooksReq").build(),
		 * ReqOrderBookMessage.getBytes());
		 */

		// inquiry request example: ReqContractInfoRequest contentString pattern =
		// "MM-dd-yyyy";

		simpleDateFormat = new SimpleDateFormat(pattern);
		String todayDate = simpleDateFormat.format(new Date()); // get current day

		calendar = Calendar.getInstance();

		// get yesterday
		calendar.add(Calendar.DAY_OF_YEAR, -1);
		String yesterdayDate = simpleDateFormat.format(calendar.getTime()); // get yesterday

		// get Today - 2 days
		calendar.add(Calendar.DAY_OF_YEAR, -1);
		String dayBeforeYesterdayDate = simpleDateFormat.format(calendar.getTime()); // get yesterday - 1

		// get tomorrow"
		calendar.add(Calendar.DAY_OF_YEAR, +3);
		String tomorrowDate = simpleDateFormat.format(calendar.getTime()); // get tomorrow
		// back to today
		calendar.add(Calendar.DAY_OF_YEAR, -1);

		String listOfProducts = productList.BuildXMLActiveProductsList();
		
		appLog.logger.info("listOfProducts = " + listOfProducts);
		Globals.guiWindowDebug.AddText("listOfProducts = " + listOfProducts);
		
		String ReqContractInfoRequest ="";

		// request contracts for delivery D-1
		// only required if retrieving orders or trades from the past (possible up to
		// current day - 6 days)

		/*
		 * String ReqContractInfoRequest ="<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
		 * +
		 * "<ContractInfoReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" startDate=\""
		 * + dayBeforeYesterdayDate + "T22:00:00.000Z\" endDate=\"" + yesterdayDate +
		 * "T22:00:00.000Z\">" + "<StandardHeader marketId=\"EPEX\"/>" + listOfProducts
		 * + "</ContractInfoReq>";
		 * 
		 * appLog.logger.info("ReqContractInfoRequest= "+ReqContractInfoRequest);
		 * Globals.guiWindowDebug.AddText("ReqContractInfoRequest= "
		 * +ReqContractInfoRequest);
		 * 
		 * sendRequest(ROUTING_KEY_INQUIRY, "ContractInfoReq",
		 * "CONTRACT_INFO_REQ_D_minus_1_"+connectionLossNb, ReqContractInfoRequest,
		 * RESP_MANDATORY_TO_START);
		 */
		// request contracts for delivery D (note should be adapted to DST changes to
		// automatically switch from 22:00 to 23:00 during Summer time)
		String ReqContractInfoRequestToday="";
		ReqContractInfoRequestToday = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<ContractInfoReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" startDate=\"" + yesterdayDate
				+ "T22:00:00.000Z\" endDate=\"" + todayDate + "T22:00:00.000Z\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + listOfProducts + "</ContractInfoReq>";

		appLog.logger.info("ReqContractInfoRequest= " + ReqContractInfoRequestToday);
		Globals.guiWindowDebug.AddText("ReqContractInfoRequest= " + ReqContractInfoRequestToday);

		sendRequest(ROUTING_KEY_INQUIRY, "ContractInfoReq", "CONTRACT_INFO_REQ_TODAY_"+connectionLossNb, ReqContractInfoRequestToday,
				RESP_MANDATORY_TO_START);
		
		//Thread.sleep(5000);
		// request contracts for delivery D+1
		String ReqContractInfoRequestTomorrow = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<ContractInfoReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" startDate=\"" + todayDate
				+ "T22:00:00.000Z\" endDate=\"" + tomorrowDate + "T23:00:00.000Z\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + listOfProducts + "</ContractInfoReq>";

		appLog.logger.info("ReqContractInfoRequestTomorrow= " + ReqContractInfoRequestTomorrow);
		Globals.guiWindowDebug.AddText("ReqContractInfoRequestTomorrow= " + ReqContractInfoRequestTomorrow);

		sendRequest(ROUTING_KEY_INQUIRY, "ContractInfoReq", "CONTRACT_INFO_REQ_TOMORROW_"+connectionLossNb,
				ReqContractInfoRequestTomorrow, RESP_MANDATORY_TO_START
				);
		bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);

		contractInfoReportOnGoingProcessing = true; // for further sync

		// collect all public trades since last 00:00 CET/CEST
		/*
		 * shortListOfProducts = " <prodName>XBID_Hour_Power" +
		 * remoteProductSuffix+"</prodName>" +
		 * " <prodName>Intraday_Hour_Power</prodName>" +
		 * " <prodName>XBID_Quarter_Hour_Power" + remoteProductSuffix+"</prodName>" +
		 * " <prodName>Intraday_Quarter_Hour_Power</prodName>" +
		 * " <prodName>XBID_Half_Hour_Power" + remoteProductSuffix+"</prodName>" +
		 * " <prodName>Intraday_Half_Hour_Power</prodName>"; String ReqXBIDPublicTrades
		 * ="<?xml version=\"1.0\" encoding=\"UTF-8\"?> " +
		 * "<PblcTradeConfReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" startDate=\""
		 * + yesterdayDate + "T22:00:00.000Z\" endDate=\"" + todayDate +
		 * "T05:00:00.000Z\">" + "<StandardHeader marketId=\"EPEX\"/>" +
		 * shortListOfProducts + "</PblcTradeConfReq>";
		 * 
		 * appLog.logger.info("ReqXBIDPublicTrades= "+ReqXBIDPublicTrades);
		 * Globals.guiWindowDebug.AddText("ReqXBIDPublicTrades= "+ReqXBIDPublicTrades);
		 * 
		 * requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_INQUIRY, true,
		 * false, headers.correlationId("ReqXBIDPublicTrades_1").build(),
		 * ReqXBIDPublicTrades.getBytes());
		 */

		// collect all public order books
		/*
		 * <?xml version="1.0" encoding="UTF-8"?> <PblcOrdrBooksReq
		 * xmlns="http://www.deutsche-boerse.com/m7/v6" contractType="ALL">
		 * <StandardHeader marketId="EPEX"/> <prodName>Intraday_Hour_Power</prodName>
		 * <prodName>XBID_Hour_Power</prodName>
		 * <dlvryAreaId>10YDE-RWENET---I</dlvryAreaId> </PblcOrdrBooksReq>
		 */

		String PblcOrdrBooksReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<PblcOrdrBooksReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" contractType=\"ALL\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + listOfProducts + "</PblcOrdrBooksReq>";

		appLog.logger.info("PblcOrdrBooksReq= " + PblcOrdrBooksReq);
		Globals.guiWindowDebug.AddText("PblcOrdrBooksReq= " + PblcOrdrBooksReq);

		boolean bObkReqMandatory = RESP_OPTIONAL_TO_START;
		// if (fillEmptyOrderBooks.contentEquals("true"))
		
		if ("false".contentEquals(manageOrderBooks)) bObkReqMandatory = RESP_OPTIONAL_TO_START;
		else bObkReqMandatory = RESP_MANDATORY_TO_START;
		
		sendRequest(ROUTING_KEY_INQUIRY, "PblcOrdrBooksReq", "PUBLIC_OBK_REQ_"+connectionLossNb, PblcOrdrBooksReq, bObkReqMandatory);
		bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);

		if (adminMode && "true".contentEquals(adminRetrieveOrdersPast)) {

			// start by getting all previous mandatory responses
			bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);

			// calculate the right dates
			// get the day in the past corresponding to adminRetrievePastOrdersDaysShift in
			// the config file
			calendar.add(Calendar.DAY_OF_YEAR, -adminRetrieveOrdersPastDaysShift);
			String D_Date = simpleDateFormat.format(calendar.getTime());
			calendar.add(Calendar.DAY_OF_YEAR, -1);
			String D_Minus_1_Date = simpleDateFormat.format(calendar.getTime());
			// back to current day
			calendar.add(Calendar.DAY_OF_YEAR, +1 + adminRetrieveOrdersPastDaysShift);

			for (int hour = 0; hour < 23; hour = hour + 2) {

				int UTChourDelta = -1;
				int request_UTC_Hour = 0;
				String requestDate = D_Date;

				// wait for the previous request response, if any, to be completely processed
				// before sending the next request

				while (fullOrderCapturegOnGoingProcessing == true) {
					Thread.sleep(5000);
					System.out.println("computing : fullOrderCapturegOnGoingProcessing = true");
				}
				;

				boolean bWinter = true;

				if (hour == 0) {
					requestDate = D_Minus_1_Date;
					if (bWinter)
						request_UTC_Hour = 23;
					else
						request_UTC_Hour = 22;
				} else if (hour == 1) {
					if (bWinter) {
						requestDate = D_Date;
						request_UTC_Hour = 0;
					} else {
						requestDate = D_Minus_1_Date;
						request_UTC_Hour = 23;
					}
				} else // hour >=2
				{
					requestDate = D_Date;
					if (bWinter)
						request_UTC_Hour = hour - 1;
					else
						request_UTC_Hour = hour - 2;
				}

				String FullOrdrCaptureReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
						+ "<FullOrdrCaptureReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" startDate=\""
						+ requestDate + "T" + String.format("%02d", request_UTC_Hour) + ":00:00.000Z\">"
						+ "<StandardHeader marketId=\"EPEX\"/>" + "</FullOrdrCaptureReq>";

				msg = "FullOrdrCaptureReq= " + FullOrdrCaptureReq;
				appLog.logger.warning("FullOrdrCaptureReq= " + FullOrdrCaptureReq);
				Globals.guiWindowDebug.AddText("FullOrdrCaptureReq= " + FullOrdrCaptureReq);

				msg = "FullOrdrCaptureReq sent: date=" + requestDate + " request_UTC_Hour=" + request_UTC_Hour;
				controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);

				String correlationId = "FULL_ORDER_CAPTURE_REQ H" + String.format("%02d", request_UTC_Hour) + "_"+ connectionLossNb;

				sendRequest(ROUTING_KEY_INQUIRY, "FullOrdrCaptureReq", correlationId, FullOrdrCaptureReq,
						RESP_MANDATORY_TO_START);

				fullOrderCapturegOnGoingProcessing = true;
			}
			msg = "*** end of Full Order Capture requests ***";
			controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
		}
		// before describing how to deal with responses (to requests sent above),
		// implement what to do with broadcast messages

		// *************
		// BROADCASTS
		// *************

		Channel broadcastChannel = conn.createChannel();

		// guiWindowBroadcasts.AddText(sdf.format(new Date()) + "ms "+ "start of
		// startBroadcastListener");

		// DO NOT declare the broadcast queue, it is declare automatically when the user successfully logs in
		// broadcastChannel.queueDeclare(BROADCAST_QUEUE, autoAck, autoAck, autoAck, null);

		// *********************************
		// Broadcast DELIVER CALLBACK: automatically called when a broadcast msg arrives
		// in the broadcast queue (see broadcast channel consumer declaration below)
		// Ideally messages should be consumed, stored and only then processed
		// *********************************
		DeliverCallback broadcastDeliverCallback = (consumerTag, delivery) -> {

			if (delivery.getProperties().getType() != null) {
				if (delivery.getProperties().getType().contains("OrdrExeRprt")) {
					Globals.guiWindowDebug.AddText("");
					Globals.guiWindowDebug
							.AddText("====> received OrdrExeRprt broadcast: " + delivery.getEnvelope().getRoutingKey());
					//appLog.logger.info("====> received OrdrExeRprt broadcast: " + delivery.getEnvelope().getRoutingKey());
					Globals.guiWindowDebug.AddText("");
				}
			}

			broadcastNb++;
			AMQPMessage broadcastMsg = new AMQPMessage(request_responseList, "BROADCAST");
			String logMessage = "";

			while (!Globals.bBroadcastProcessingCanStart) {
				msg = "BROADCAST waiting to be processed: Waiting for all mandatory responses to be received";
				Globals.guiWindowDebug.AddText(msg);
				//appLog.logger.info(msg);
				try {
					Thread.sleep(2000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					JOptionPane.showMessageDialog(controlBoardFrame, "catching error: "+ e.toString());
				}
			}

			// set the focus on the Broadcast Tab when the 1t broadcast arrives
			if (broadcastNb == 1)
				controlBoardFrame.tabbedPane.setSelectedIndex(2);

			// get the message decompressed and extract key info
			broadcastMsg.processMessage(delivery, appLog, "BROADCAST");

			if (broadcastMsg.type != null && "true".contentEquals(processBroadcast)) { // only M7 heartbeat message have
																						// a null Type
				// log and display info
				// logMessage = sdf.format(new Date()) + "====> broadcast #"+ broadcastNb +"
				// found:"+ message.type + " correlation Id = " + message.correlationId;
				// guiWindowBroadcasts.AddText(logMessage);
				// appLog.logger.info(logMessage);
				broadcastMsg.clientReceptionTime = sdfTime.format(new Date());

				String msgTypeName = broadcastMsg.type;
				msgTypeName = msgTypeName.substring(msgTypeName.lastIndexOf("com.deutscheboerse.m7.trading.api.v6."));
				msg = msgTypeName + " broadcast  #" + broadcastNb + " RK= " + broadcastMsg.routingKeyName + " : "
						+ broadcastMsg.sequenceNo;
				appLog.logger.fine(msg);
				msg = broadcastMsg.amqpProperties + " " + broadcastMsg.xmlMessagePayload;
				appLog.logger.fine(msg);
				// guiWindowBroadcasts.AddText(sdf.format(new Date()) + msg);

				// add the new broadcast to the table
//				System.out.println(broadcastMsg.clientReceptionTime + " " + broadcastMsg.AMQPSendingTime + " "
//						+ broadcastMsg.type + " " + broadcastMsg.routingKeyName + " " + broadcastMsg.sequenceNo + " "
//						+ broadcastMsg.xmlMessagePayload);

				broadcastList.AddBroadcast(broadcastMsg.clientReceptionTime, broadcastMsg.AMQPSendingTime,
						broadcastMsg.type, broadcastMsg.correlationId, broadcastMsg.routingKeyName,
						broadcastMsg.sequenceNo, broadcastMsg.xmlMessagePayload);

				// update the broadcast GUI
				try {
					broadcastList.updateGUITable(controlBoardFrame.broadcast_GUI_Panel);
				} catch (Exception e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					String sError = "catching error in ThreadUpdateOrderBooksGUI: " + e1.toString();
					appLog.logger.severe(sError);
				}
				// write broadcasts in a csv file
				try {
					broadcastList.WriteCSVFile();
				} catch (Exception e) {
					e.printStackTrace();
					msg = "error writing broadcasts List: " + e.toString();
					appLog.logger.info(msg);
				}

				// update the routingKeysList
				
				  routingKeysList.UpdateRoutingKeysList(broadcastMsg.routingKeyName,Integer.
				  parseInt(broadcastMsg.sequenceNo),broadcastMsg.type,missingRoutingKeysList,
				  controlBoardFrame); routingKeysList.updateGUITable(controlBoardFrame.RK_Gaps_GUI_Panel);
				  
				 
				// functional errors
				// ********************************************************************
				// Error Response
				// ********************************************************************
				if (broadcastMsg.xmlMessagePayload.indexOf("ErrResp") > 0) {
					nbErrResp++;
					Globals.guiWindowDebug.AddText(broadcastMsg.xmlMessagePayload);
					if (broadcastMsg.type.equals("com.deutscheboerse.m7.trading.api.v6.ErrResp")) {
						msg = "BROADCAST: Correlation Id:" + broadcastMsg.correlationId + " "
								+ broadcastMsg.xmlMessagePayload;
						controlBoardFrame.AddText(msg, controlBoardFrame.textAreaErrors);
					}

					appLog.logger.warning("ErrResp: Correlation Id " + broadcastMsg.correlationId + " : "
							+ broadcastMsg.xmlMessagePayload);

					// update the order table with the error Text
					String s = broadcastMsg.xmlMessagePayload;
					String prefix = "Error err=\"";
					s = s.substring(s.indexOf(prefix) + prefix.length());
					String[] result = s.split("\"");
					String errTxt = result[0];

					// get errCode
					prefix = "errCode=\"";
					s = s.substring(s.indexOf(prefix) + prefix.length());
					String[] resulterrCode = s.split("\"");
					String errCode = resulterrCode[0];

					String ErrStringForOrderTable = "Error " + errCode + ": " + errTxt;
					ordersList.updateOrderErrorResponse_CorrelationId(broadcastMsg.correlationId,
							ErrStringForOrderTable);

					// in case of a fill in order book bug leading to many error Responses, limit
					// the impact
					if (adminMode == true && nbErrResp > 1000) {
						appLog.logger.severe("too many Error Responses : " + nbErrResp + " : EXIT");
						System.exit(0);
					}
					
					ordersList.unlock_Order(broadcastMsg.correlationId);
				}

				// message reports
				if (broadcastMsg.xmlMessagePayload.indexOf("MsgRprt") > 0) {
					System.out.println("MsgRprt: " + broadcastMsg.xmlMessagePayload);
					// Globals.guiWindowDebug.AddText(broadcastMsg.xmlMessagePayload);
					parseMsgReport(broadcastMsg);
				}

				// count Order Exe Report to monitor the environment workload with an admin user
				if (broadcastMsg.xmlMessagePayload.indexOf("OrdrExeRprt") > 0) {

					msg = "Correlation Id : " + broadcastMsg.correlationId + " " + broadcastMsg.routingKeyName
							+ " seq nb: " + Integer.parseInt(broadcastMsg.sequenceNo) + " "
							+ broadcastMsg.xmlMessagePayload;
					Globals.guiWindowDebug.AddText(msg);
					appLog.logger.warning(msg);
					try {
						parseOrderExeReport(broadcastMsg, ordersList, true);
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
						msg = "ERROR parse Order Exe Report BROADCAST : " + e.toString();
						appLog.logger.severe(msg);
						Globals.guiWindowDebug.AddText(msg);
						JOptionPane.showMessageDialog(controlBoardFrame, msg);
					}

					// ***
					/*
					 * UserOrderEventsNbRemote = UserOrderEventsNbRemote +
					 * StringUtils.countMatches(message.xmlMessagePayload, "remoteOrdrId=");
					 * 
					 * // local actually means total here (XBID + non XBID) UserOrderEventsNbM7 =
					 * UserOrderEventsNbM7 + StringUtils.countMatches(message.xmlMessagePayload,
					 * "<Ordr ");
					 */

					calculateOrdersAndTradesStatistics();
				}

				else if (broadcastMsg.type.indexOf("TradeCaptureRprt") > 0) {
					
//				    <Trade tradeId="62307013" state="ACTI" contractId="983354" qty="100" px="12000" execTime="2022-03-22T04:47:02.525Z" revisionNo="1" 
//					preArranged="false" contractPhase="CONT" decomposed="false" remoteTradeId="25692012" selfTrade="false">
//				      <Buy clearingAcctType="P" dlvryAreaId="10YDE-RWENET---I" acctId="11XTM2-TM------1" ordrId="313282766"
//					txt="Order Generation contract QT23:30-T23:45_XB LOAD #76_18:09:09.903" aggressorIndicator="U" usrCode="TRD018" 
//					clOrdrId="LOAD #76_18:09:09.903-1" mbrId="TM002" remoteOrdrId="140944304"/>
//				    </Trade>

					// parse the XML message to count local and XBID/remote trades
					DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
					DocumentBuilder builder;

					try {
						builder = docFactory.newDocumentBuilder();

						// Create a Document from the XML payload
						StringBuilder xmlStringBuilder = new StringBuilder();
						xmlStringBuilder.append(broadcastMsg.xmlMessagePayload);

						ByteArrayInputStream input = new ByteArrayInputStream(
						xmlStringBuilder.toString().getBytes("UTF-8"));
						Document document = null;
						document = builder.parse(input);
						document.getDocumentElement().normalize();

						NodeList nodeTradeList = document.getElementsByTagName("Trade");

						// if there are trade nodes
						if (nodeTradeList != null && nodeTradeList.getLength() > 0) {
							// for each Contract node
							for (int tradeItr = 0; tradeItr < nodeTradeList.getLength(); tradeItr++) {
								Node node = nodeTradeList.item(tradeItr);

								if (node.getNodeType() == Node.ELEMENT_NODE) {
									Element eElement = (Element) node;
									Trade currentTrade = new Trade();

									NamedNodeMap nodeMap = eElement.getAttributes();
									// extract values from attributes
									for (int i = 0; i < nodeMap.getLength(); i++) {
										Node node2 = nodeMap.item(i);
										String nodeName = node2.getNodeName();
										String nodeValue = node2.getNodeValue();

										if (nodeName.contentEquals("tradeId")) {
											currentTrade.tradeId= nodeValue;
										}
										if (nodeName.contentEquals("contractId")) {
											currentTrade.contractId = nodeValue;
											Contract contract = new Contract();
											contract = contractList.FindContractIdInfo_Contract(currentTrade.contractId, Globals.guiWindowDebug);
											currentTrade.product = contract.getProd();
											currentTrade.contractName = contract.getName();
										}
										if (nodeName.contentEquals("state")) {
											currentTrade.state = nodeValue;
										}
										if (nodeName.contentEquals("revisionNo")) {
											currentTrade.revisionNo = nodeValue;
										}
										if (nodeName.contentEquals("qty")) {
											currentTrade.quantity = nodeValue;
										}
										if (nodeName.contentEquals("px")) {
											currentTrade.price = nodeValue;
										}
										if (nodeName.contentEquals("execTime")) {
											currentTrade.price = nodeValue;
										}
										if (nodeName.contentEquals("preArranged")) {
											currentTrade.preArranged = nodeValue;
										}
										if (nodeName.contentEquals("remoteTradeId")) {
											currentTrade.remoteTradeId = nodeValue;
										}
										if (nodeName.contentEquals("selfTrade")) {
											currentTrade.selfTrade = nodeValue;
										}
										if (nodeName.contentEquals("contractPhase")) {
											currentTrade.contractPhase = nodeValue;
										}
										
									}
									String isXBIDContract = contractList.IsXBIDContract(currentTrade.contractId);

									if ("LOCAL".contentEquals(isXBIDContract)) {
										tradeEventsNbTotal++;
									} else if ("XBID".contentEquals(isXBIDContract)) {
										tradeEventsNbRemote++;
										tradeEventsNbTotal++;
									} else if (NOT_FOUND.contentEquals(isXBIDContract)) {
										tradeEventsUnknownContract++;
										tradeEventsNbTotal++;
										Globals.guiWindowDebug.AddText("!!! Contract Type could not be found : contract ID="
														+ currentTrade.contractId);
										Globals.guiWindowDebug.AddText("!!! Contract Type could not be found : contract ID="
														+ currentTrade.contractId);
									}
									
									// buy side
									NodeList nodeBuyList = document.getElementsByTagName("Buy");

									// if there are trade nodes
									if (nodeBuyList != null && nodeBuyList.getLength() > 0) {
										// for each buy node
										for (int buyItr = 0; buyItr < nodeBuyList.getLength(); buyItr++) {
											Node nodeBuy = nodeBuyList.item(buyItr);

											if (nodeBuy.getNodeType() == Node.ELEMENT_NODE) {
												Element eElementBuy = (Element) nodeBuy;

												NamedNodeMap nodeMapBuy = eElementBuy.getAttributes();
												// extract values from attributes
												for (int j = 0; j < nodeMapBuy.getLength(); j++) {
													Node node2 = nodeMapBuy.item(j);
													String nodeName = node2.getNodeName();
													String nodeValue = node2.getNodeValue();
													
												    //<Buy clearingAcctType="P" dlvryAreaId="10YDE-RWENET---I" acctId="11XTM2-TM------1" ordrId="313282766" 
													// txt="" aggressorIndicator="U" usrCode="TRD018" clOrdrId="LOAD #76_18:09:09.903-1" mbrId="TM002" remoteOrdrId="140944304"/>
													currentTrade.side = "Buy";
													
													if (nodeName.contentEquals("dlvryAreaId")) {
														currentTrade.deliveryAreaId = nodeValue;
														DeliveryArea area = new DeliveryArea();
														area = deliveryAreaList.GetAreaDetailsFromId(currentTrade.deliveryAreaId); 
														currentTrade.deliveryAreaName = area.dlvryAreaName; 
													}
													if (nodeName.contentEquals("remoteTra")) {
														currentTrade.contractId = nodeValue;
														Contract contract = new Contract();
														contract = contractList.FindContractIdInfo_Contract(currentTrade.contractId, Globals.guiWindowDebug);
														currentTrade.product = contract.getProd();
														currentTrade.contractName = contract.getName();
													}
													if (nodeName.contentEquals("revisionNo")) {
														currentTrade.revisionNo = nodeValue;
													}
													if (nodeName.contentEquals("qty")) {
														currentTrade.quantity = nodeValue;
													}
													if (nodeName.contentEquals("px")) {
														currentTrade.price = nodeValue;
													}
													if (nodeName.contentEquals("execTime")) {
														currentTrade.price = nodeValue;
													}
													if (nodeName.contentEquals("preArranged")) {
														currentTrade.preArranged = nodeValue;
													}
													if (nodeName.contentEquals("acctId")) {
														currentTrade.accountId = nodeValue;
													}
													if (nodeName.contentEquals("txt")) {
														currentTrade.txt = nodeValue;
													}
												
												}
												// end of the buy attributes : create a half trade
												tradesList.UpdateTradesList(currentTrade);
												tradesList.updateGUITable(controlBoardFrame.trades_GUI_Panel);
											}
											
										} // for Buy trade
									}
									// sell side
									NodeList nodeSellList = document.getElementsByTagName("Sell");

									// if there are trade nodes
									if (nodeSellList != null && nodeSellList.getLength() > 0) {
										// for each Sell node
										for (int SellItr = 0; SellItr < nodeSellList.getLength(); SellItr++) {
											Node nodeSell = nodeSellList.item(SellItr);

											if (nodeSell.getNodeType() == Node.ELEMENT_NODE) {
												Element eElementSell = (Element) nodeSell;

												NamedNodeMap nodeMapSell = eElementSell.getAttributes();
												// extract values from attributes
												for (int j = 0; j < nodeMapSell.getLength(); j++) {
													Node node2 = nodeMapSell.item(j);
													String nodeName = node2.getNodeName();
													String nodeValue = node2.getNodeValue();
													
												    //<Sell clearingAcctType="P" dlvryAreaId="10YDE-RWENET---I" acctId="11XTM2-TM------1" ordrId="313282766" 
													// txt="" aggressorIndicator="U" usrCode="TRD018" clOrdrId="LOAD #76_18:09:09.903-1" mbrId="TM002" remoteOrdrId="140944304"/>
													currentTrade.side = "Sell";
													
													if (nodeName.contentEquals("dlvryAreaId")) {
														currentTrade.deliveryAreaId = nodeValue;
														DeliveryArea area = new DeliveryArea();
														area = deliveryAreaList.GetAreaDetailsFromId(currentTrade.deliveryAreaId); 
														currentTrade.deliveryAreaName = area.dlvryAreaName; 
													}
													if (nodeName.contentEquals("remoteTra")) {
														currentTrade.contractId = nodeValue;
														Contract contract = new Contract();
														contract = contractList.FindContractIdInfo_Contract(currentTrade.contractId, Globals.guiWindowDebug);
														currentTrade.product = contract.getProd();
														currentTrade.contractName = contract.getName();
													}
													if (nodeName.contentEquals("revisionNo")) {
														currentTrade.revisionNo = nodeValue;
													}
													if (nodeName.contentEquals("qty")) {
														currentTrade.quantity = nodeValue;
													}
													if (nodeName.contentEquals("px")) {
														currentTrade.price = nodeValue;
													}
													if (nodeName.contentEquals("execTime")) {
														currentTrade.price = nodeValue;
													}
													if (nodeName.contentEquals("preArranged")) {
														currentTrade.preArranged = nodeValue;
													}
													if (nodeName.contentEquals("acctId")) {
														currentTrade.accountId = nodeValue;
													}
													if (nodeName.contentEquals("txt")) {
														currentTrade.txt = nodeValue;
													}
												
												}
												// end of the Sell attributes : create a half trade
												tradesList.UpdateTradesList(currentTrade);
												tradesList.updateGUITable(controlBoardFrame.trades_GUI_Panel);
											}
											
										} // for Sell trade
									}
								}
							} // for each trade
						} // if there are trade nodes
					} catch (ParserConfigurationException | SAXException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

					// ************* END of Trade Capture Report parsing ***************

					// admin receives trades with the buy and sell legs at once : remote appears
					// twice for one trade
					// tradeEventsNbLocal = tradeEventsNbLocal +
					// StringUtils.countMatches(message.xmlMessagePayload, " tradeId");

					calculateOrdersAndTradesStatistics();
				}

				// update the Contract List when receiving a Contract Info Report
				else if (broadcastMsg.type.equals("com.deutscheboerse.m7.trading.api.v6.ContractInfoRprt")) {
					try {
						parseContractInfoReport(broadcastMsg, Globals.guiWindowDebug);
						// JOptionPane.showMessageDialog(controlBoardFrame, "ContractInfoRprt: "+
						// broadcastMsg.xmlMessagePayload);
					} catch (Exception e) {
						e.printStackTrace();
						msg = "Error parseContractInfoReport: " + e.toString();
						Globals.guiWindowDebug.AddText(msg);
						appLog.logger.severe(msg);
						JOptionPane.showMessageDialog(controlBoardFrame, msg);
					}
				}
				// ***********************************************************************************************
				// response = Public Order Books Delta report: upload order books (contract Id +
				// Area Id combinations)
				// ***********************************************************************************************
				if (broadcastMsg.type.equals("com.deutscheboerse.m7.trading.api.v6.PblcOrdrBooksDeltaRprt")) {
					appLog.logger.fine("PblcOrdrBooksDeltaRprt received");
//					int itr = 0;
//					while (Globals.bOrderBookUpdate_Ongoing && itr < 100) {
//						try {
//							Thread.sleep(20);
//						} catch (InterruptedException e) {
//							// TODO Auto-generated catch block
//							e.printStackTrace();
//						}
//						itr++;
//					}
					if ("true".contentEquals(manageOrderBooks)) {
						parseOrderBookMessage("BROADCAST",broadcastMsg, orderBooksList);
					}
				}
			} else { // M7 heartbeat message, Type is null
				if ("true".contentEquals(processBroadcast)) {

					msg = "";
					// in the broadcast is an M7 heartbeat
					if (broadcastMsg.xmlMessagePayload.contains("SYSTEM_ALIVE")) {
						m7HeartbeatNb++;

						long last_M7HeartBeatReceptionTime = System.nanoTime();

						if (m7HeartbeatNb > 1) {
							m7HeartbeatDifference = (last_M7HeartBeatReceptionTime - previous_M7HearbeatReceptionTime)
									/ 1e9;
							m7HeartbeatDifferenceString = String.format("%.2f", m7HeartbeatDifference);

							msg = " Heartbeat #" + m7HeartbeatNb + " RK = " + broadcastMsg.routingKeyName
									+ " : seq No = " + broadcastMsg.sequenceNo + " XML="
									+ broadcastMsg.xmlMessagePayload + " heartbeat interval = "
									+ m7HeartbeatDifferenceString + " ";
							// appLog.logger.info(msg);
							controlBoardFrame.AddText(msg, controlBoardFrame.textAreaM7Hbts);

							// refresh Players stats
							orderPlayersList.refreshPlayersList(UserOrderEventsNbM7, UserOrderEventsNbLocal,
									UserOrderEventsNbRemote);
							// update players' table in the GUI
							orderPlayersList.updateGUITable(playersTable, commentTextPlayers);
							// update obk
							// orderBooksList.updateGUITable( controlBoardFrame.orderBooks_GUI_Panel);
							// update orders
							// ordersList.updateGUITable(ordersTable, commentTextOrders,MAX_ORDER_ROWS);

							try {
								ordersList.updateGUITable(controlBoardFrame.ownOrders_GUI_Panel);
							} catch (Exception e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
								String error = "catching error: " + e.toString();
								appLog.logger.severe(error);
							}

							// more than 3 missed M7 heartbeats in a row (expected every 5 seconds)
							if ((int) m7HeartbeatDifference > HEARTBEAT_LOSS_INTERVAL) {
								nbOfM7HeartbeatLosses++;
								msg = sdf.format(new Date()) + "*** heartbeat loss = " + m7HeartbeatDifferenceString
										+ " > " + HEARTBEAT_LOSS_INTERVAL + " seconds ***";
								appLog.logger.info(msg);

								controlBoardFrame.AddText(msg, controlBoardFrame.textAreaM7Hbts);
							}
							calculateOrdersAndTradesStatistics();
						} else {
							// 1st heartbeat : do not calculate the difference with previous hearbeat
							msg = sdf.format(new Date()) + " Heartbeat #" + m7HeartbeatNb + " XML="
									+ broadcastMsg.xmlMessagePayload;
							// appLog.logger.info(msg);
							controlBoardFrame.AddText(msg, controlBoardFrame.textAreaM7Hbts);

						}
						previous_M7HearbeatReceptionTime = last_M7HeartBeatReceptionTime;
					} else {
						msg = "*** unknown broadcast ***";
						appLog.logger.info(msg);
						// guiWindowBroadcasts.AddText(msg);
					}
				}
			}
		};
		// ************* End of Broadcasts Callback ***************

		broadcastListeningStart = System.currentTimeMillis();

		// be ready to consume broadcast messages using the broadcastDeliverCallback
		// instructions
		try {
			broadcastChannel.basicConsume(BROADCAST_QUEUE, autoAck, broadcastDeliverCallback, consumerTag -> {
			});
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			// guiWindowConnection.AddText(e.toString());
		}

		// *********************************
		// Wait for key responses to be received before actually starting the functional
		// part of the application (order submission, fill in empty obks, collect
		// historical orders for admin, etc.)
		// *********************************
		Thread.sleep(1000);
		bTimeoutReached = WaitForKeyResponses(MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS);
		controlBoardFrame.updateBroadcastProcessingStatus();

		if (bTimeoutReached) {
			int output = JOptionPane.showConfirmDialog(controlBoardFrame,
					"All mandatory responses to start TIMEOUT reached (" + MANDATORY_RESPONSES_TOTAL_TIMEOUT_IN_SECONDS
							+ ") \n The app may not function properly, would you like to continue anyway?",
					"TIMEOUT choice", JOptionPane.YES_NO_OPTION);

			if (output == JOptionPane.NO_OPTION) {
				controlBoardFrame.LoggedOut();
				System.exit(-1);
			} else {
				Globals.bBroadcastProcessingCanStart = true;
				controlBoardFrame.tabbedPane.setSelectedIndex(2);
				controlBoardFrame.updateBroadcastProcessingStatus();
			}
		} else {
			controlBoardFrame.updateBroadcastProcessingStatus();
			controlBoardFrame.tabbedPane.setSelectedIndex(2);
		}
		
		// determine the interval to wait between 2 order actions
		intOrderGenerationIntervalMillisec = Integer.parseInt(orderGenerationIntervalMillisec);
		System.out.println("wait request = " + intOrderGenerationIntervalMillisec);
		// impose a minimum interval to avoid sending orders too frequently
		if (intOrderGenerationIntervalMillisec < 100)
			intOrderGenerationIntervalMillisec = 100;
		
	
		// **********************************
		// Read historical data file
		// **********************************
		if (submitHistoricalOrder == true) {
			// read the historical order file
			orderList = readOrderFile();
			orderBeingProcessedByM7List = new ArrayList<OrderBeingProcessed>();
		}

		// **********************************
		// Animate the market
		// **********************************
		if (adminMode == false && "true".contentEquals(marketAnimation)) {
			controlBoardFrame.AddText("marketAnimation =" + marketAnimation, controlBoardFrame.textAreaConnection);
			marketAnimation_manageOrders();
		}
		// **********************************
		// FILL IN EMPTY ORDER BOOKS example 
		// **********************************
		if (adminMode == false && "true".contentEquals(fillEmptyOrderBooks)) {
			controlBoardFrame.AddText("fillEmptyOrderBooks =" + fillEmptyOrderBooks, controlBoardFrame.textAreaConnection);
			try {
				
				Runnable rObk = new ThreadFillOrderBooks(this, controlBoardFrame, appLog, windowOrderGenerationControl, fillEmptyOrderBooks, orderBooksList, userDefaultBalancingGroup);
				Thread tObk = new Thread(rObk);
				tObk.start();
			
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				msg = "Catch Error: FillInEmptyTradableOrderBooks: " + e.toString();
				appLog.logger.severe(msg);
				Globals.guiWindowDebug.AddText(msg);
				//JOptionPane.showMessageDialog(controlBoardFrame, msg);
			}
		}

		// **********************************
		// Order Generation (basic periodic order submission)
		// **********************************
		if (orderGeneration.contentEquals("true") && adminMode == false) {
			controlBoardFrame.AddText("orderGeneration =" + orderGeneration, controlBoardFrame.textAreaConnection);

			Globals.guiWindowDebug.AddText("ORDER GENERATION: new iteration orderNb = " + orderNb);
			
			// wait for a tradable contract ID to be identified
//			int WAIT_ITR_MAX = 100;
//			int itrWait = 0;
//			while ("NOT_FOUND".contentEquals(tradableContractId) && itrWait < WAIT_ITR_MAX) {
//				Thread.sleep(100);
//				itrWait++;
//				Globals.guiWindowDebug.AddText(orderNb + " orders already submitted : Waiting for a tradable contacts");
//			}
			appLog.logger.info("orderNb = " + orderNb + " nbOfOrdersConfigFile = " + nbOfOrdersConfigFile);
			// guiWindowBroadcasts.AddText("orderNb = " + orderNb + " nbOfOrdersConfigFile =
			// "+ nbOfOrdersConfigFile);

			intOrderGenerationIntervalMillisec = Integer.parseInt(orderGenerationIntervalMillisec);

			// impose a minimum interval to avoid sending orders too frequently
			if (intOrderGenerationIntervalMillisec < 100)
				intOrderGenerationIntervalMillisec = 100;
			System.out.println("wait between 2 order requests (ms) = " + intOrderGenerationIntervalMillisec);
			

			// sendThrottlingStatusReq();
			// Thread.sleep(1000);

			// by default declare the OMT strategy as active ("sending OMT"). This will be
			// cancelled later if conditions are not met anymore
			boolean bsubmitOrderAccordingToAutomatedStrategy = true;
			windowOrderGenerationControl.setStrategyStatusTo_SendingOMT();

			// prepare a new sell order (sell orders with positive price to avoid bothering
			// with a trading limits decrease)
			Order sellOrder = new Order();
			long orderSubmissionNewCycleStartTime = System.nanoTime();
			boolean TPexceeded = false;

			// enable to enter the loop even if 0 order submission are requested in the
			// config file, so that Throttling status requests are sent anyway
			// && !tradableContractId.contains("NOT_FOUND")
			// while ((orderGeneration.contentEquals("true") || bThrottlingEnabled) &&
			// (nbOfOrdersConfigFile == 0 ||orderNb != nbOfOrdersConfigFile)) {
			while (("true".contentEquals(orderGeneration))
					&& (nbOfOrdersConfigFile == 0 || orderNb != nbOfOrdersConfigFile)) {

				// track the start of the sequence to determine at the end the required time to
				// wait to cope with the required waiting time in the config file
				// "orderGenerationIntervalMillisec"
				long loopStartTime = System.nanoTime();

				System.out.println("Reference start for waiting time calculation: " + sdf.format(new Date()));

				// sendThrottlingStatusReq();

				if (windowOrderGenerationControl.orderGeneration_ON && "true".contentEquals(orderGeneration)) {

					if (orderNb == 0)
						orderSubmissionNewCycleStartTime = System.nanoTime();

					// strategies:
					if (bThrottlingEnabled) {
						while (throttlingStatus.Short_observationWindow.contentEquals("")) {
							Thread.sleep(100);
						}
						int shortOW = Integer.valueOf(iThrottlingData_Short_OW);
						int shortL1 = Integer.valueOf(throttlingStatus.Short_L1);
						int shortL2 = Integer.valueOf(throttlingStatus.Short_L2);
						int nbOMTShortOW = ordersList.countUserOMTduringPeriod(shortOW);
						int shortTolerancePeriodMs = Integer.valueOf(throttlingStatus.Short_tolerance) * 1000;
						String shortStatus = throttlingStatus.Short_status;

						// determine if TP exceeded
						int elapsedTimeSinceLastCycleMs = (int) ((System.nanoTime() - orderSubmissionNewCycleStartTime)
								/ 1e6);
						if (elapsedTimeSinceLastCycleMs >= (shortTolerancePeriodMs
								- 3 * intOrderGenerationIntervalMillisec))
							TPexceeded = true;
						else
							TPexceeded = false;

						if (!"NOT_FOUND".contentEquals(tradableContractId)) { // if there is a tradable contract, try to
																			// submit an order with the scnearios logic
							if (windowOrderGenerationControl.strategy.contains("#0")) {
								// "#0. Manual / Never stops automatically"
								// do not stop order submission
								System.out.println("Strategy #0: orderNb = " + orderNb + " nbOfOrdersConfigFile="
										+ nbOfOrdersConfigFile);
								if (orderNb == nbOfOrdersConfigFile)
									bsubmitOrderAccordingToAutomatedStrategy = false;
								else
									bsubmitOrderAccordingToAutomatedStrategy = true;
							} else if (windowOrderGenerationControl.strategy.contains("#1")) {
								// "#1. Stay under the radar: 0 < OMT < L1
								// only submit a new order if this new order would not lead to reaching L1
								if (nbOMTShortOW >= (shortL1 - 1)) {
									bsubmitOrderAccordingToAutomatedStrategy = false;
								} else {
									if (shortStatus.contentEquals("NO_RESTRICTION") && nbOMTShortOW == 0)
										bsubmitOrderAccordingToAutomatedStrategy = true;
								}
								// System.out.println("strategy =" + windowOrderGenerationControl.strategy + "
								// Short OW = " + shortOW + " seconds" + " short L1 = " + shortL1 + " nb OMT = "
								// + nbOMTShortOW);
							} else if (windowOrderGenerationControl.strategy.contains("#2")) {
								// "#2. SHORT: Hit L1 and back off until OMT = 0"
								if (nbOMTShortOW >= (shortL1)) {
									bsubmitOrderAccordingToAutomatedStrategy = false;
								} else {
									if (shortStatus.contentEquals("NO_RESTRICTION") && nbOMTShortOW == 0)
										bsubmitOrderAccordingToAutomatedStrategy = true;
								}
							} else if (windowOrderGenerationControl.strategy.contains("#3a")) {
								// #3a. SHORT: Optimize (L1 < OMT < L2), never exceed TP"
								if (bsubmitOrderAccordingToAutomatedStrategy == true) {
									if (shortStatus.contentEquals("WARNING") && (nbOMTShortOW >= (shortL2 - 1))
											|| TPexceeded) {
										bsubmitOrderAccordingToAutomatedStrategy = false;
										if (nbOMTShortOW >= (shortL2 - 1)) {
											msg = "nbOMTShortOW=" + nbOMTShortOW + ": stop orders generation";
											controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
										}
										if (TPexceeded) {
											msg = " TPexceeded =" + TPexceeded + ": stop orders generation";
											controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
										}

										System.out.println("stop orders bsubmitOrderAccordingToAutomatedStrategy = "
												+ bsubmitOrderAccordingToAutomatedStrategy + " TPexceeded ="
												+ TPexceeded);
									}
								} else { // order generation restart conditions
									msg = "\t- assessing restart conditions: shortStatus= " + shortStatus
											+ " nbOMTShortOW=" + nbOMTShortOW + " TPexceeded=" + TPexceeded;
									controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
									System.out.println("assessing restart conditions: shortStatus= " + shortStatus
											+ " nbOMTShortOW=" + nbOMTShortOW + " TPexceeded=" + TPexceeded);

									if (shortStatus.contentEquals("WARNING") && (nbOMTShortOW <= (shortL1 + 1))
											&& !TPexceeded) {
										bsubmitOrderAccordingToAutomatedStrategy = true;

										msg = "bouncing on L1+1: OMT restart";
										controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
										System.out.println(
												"nbOMTShortOW = " + nbOMTShortOW + ": restart orders (bounce on L1+1)");
									} else if (shortStatus.contentEquals("NO_RESTRICTION") && (nbOMTShortOW == 0)) {
										bsubmitOrderAccordingToAutomatedStrategy = true;
										msg = "NO_RESTRICTION + bouncing on 0: OMT restart";
										controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
										orderSubmissionNewCycleStartTime = System.nanoTime();

										msg = "restart orders nbOMTShortOW = " + nbOMTShortOW + " shortStatus="
												+ shortStatus;
										System.out.println(msg);
										controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);
									}
								}
							} else if (windowOrderGenerationControl.strategy.contains("#3b")) {
								// "#3b. SHORT: Optimize (L1 < OMT < L2) until RESTRICTED"
								if (nbOMTShortOW >= (shortL2 - 1) || shortStatus.contentEquals("RESTRICTED")) {
									bsubmitOrderAccordingToAutomatedStrategy = false;
								} else {
									if (nbOMTShortOW == (shortL1 + 2) || shortStatus.contentEquals("NO_RESTRICTION"))
										bsubmitOrderAccordingToAutomatedStrategy = true;
								}
							} else if (windowOrderGenerationControl.strategy.contains("#4")) {
								// "#4. SHORT: RESTRICTED - hit L2 and back off until release"
								//
								if (nbOMTShortOW >= (shortL2)) {
									bsubmitOrderAccordingToAutomatedStrategy = false;
								} else {
									if (shortStatus.contentEquals("NO_RESTRICTION"))
										bsubmitOrderAccordingToAutomatedStrategy = true;
								}
							} else if (windowOrderGenerationControl.strategy.contains("#5")) {
								// add 2 orders after being throttled
								int nbErrorsInShortOW = ordersList.countErrRespduringPeriod(shortOW);
								if ((shortStatus.contentEquals("RESTRICTED")) && (nbErrorsInShortOW >= 2)) { //
									bsubmitOrderAccordingToAutomatedStrategy = false;
								} else {
									if (shortStatus.contentEquals("NO_RESTRICTION"))
										bsubmitOrderAccordingToAutomatedStrategy = true;
								}
							} else if (windowOrderGenerationControl.strategy.contains("#6")) {
								// decide randomly to submit the order request or not
								Random randomSubmissionR = new Random();
								int rangeHigh;

								// when RESTRICTED privilege to NOT submit orders so that the release can happen
								// (OMT decrease)
								if (shortStatus.contentEquals("RESTRICTED"))
									rangeHigh = 4;
								else
									rangeHigh = 2;

								int bRandomSubmission = randomSubmissionR.nextInt(rangeHigh);
								if (bRandomSubmission == 0)
									bsubmitOrderAccordingToAutomatedStrategy = true;
								else
									bsubmitOrderAccordingToAutomatedStrategy = false;
							}
							if (bsubmitOrderAccordingToAutomatedStrategy == true) {
								windowOrderGenerationControl.setStrategyStatusTo_SendingOMT();
								;
							} else {
								windowOrderGenerationControl.setStrategyStatusTo_WaitingForAutoRestart();
							}
						} // no contract to trade right now
						else {
							msg = "No tradable contract found : no order submission";
							Globals.guiWindowDebug.AddText(msg);
							appLog.logger.warning(msg);
						}

					}
					// if order generation is requested
					if (bsubmitOrderAccordingToAutomatedStrategy && orderGeneration.contentEquals("true")
							&& nbOfOrdersConfigFile > 0) {
						windowOrderGenerationControl.setOrderGenerationON();
						// orderNb ++; => moved at submit order level
						
						generateAndSubmitNewOrder("RANDOM_MODE", "RANDOM_SIDE","LOAD", orderNb, 120, 5, 130, 5);
					}
					
				}

				waitForRemainingTimeBetweenTwoOrderEvents(loopStartTime);
			}
			if(orderGeneration.contentEquals("true") || marketAnimation.contentEquals("true") || fillEmptyOrderBooks.contentEquals("true")) {
				if (bThrottlingEnabled)
					msg = "orderNb = " + orderNb + ": The app submitted the requested nb of Orders " + nbOfOrdersConfigFile
							+ " : now just sending Throttling Status Requests";
				else
					msg = "orderNb = " + orderNb + ":The app submitted the requested nb of Orders " + nbOfOrdersConfigFile;
				appLog.logger.info(msg);
				JOptionPane.showMessageDialog(controlBoardFrame, msg);	
			}

		}

		// ************************************************************
		// * read a Historical Order file and ubmit orders accordingly
		// ************************************************************
		if (submitHistoricalOrder == true) {
			// for each order in the list, submit the order

			int nbSubmittedOrders = 0;
			for (Order next : orderList) {

				Globals.guiWindowDebug
						.AddText("  nbSubmittedOrders = " + nbSubmittedOrders + " *** Order List :" + next.Display());
				String orderContractID = ""; // targetContractID;
				// String orderRequest="";
				String substituteAction = "";
				substituteAction = next.action;

				// Globals.guiWindowDebug.AddText("searching for : orderTransactionTime='" +
				// next.orderTransactionTime + "' product='" + next.product + "'
				// deliveryStart='"+ next.deliveryStart + "' deliveryEnd ='"+
				// next.deliveryEnd+"'");
				// Globals.guiWindowDebug.AddText("A. contractList display = " +
				// contractList.Display(guiWindow));
				orderContractID = contractList.FindContractId(next.orderTransactionTime, next.product,
						next.deliveryStart, next.deliveryEnd, Globals.guiWindowDebug);
				Globals.guiWindowDebug
						.AddText(sdf.format(new Date()) + " Contract Id to be used = '" + orderContractID + "'");
				if (orderContractID.contentEquals("")) {
					Globals.guiWindowDebug.AddText(
							sdf.format(new Date()) + " could not find contract : trying with the equivalent product");
					// switch local / XBID equivalent product

					// hourly product
					if (next.product.contentEquals("XBID_Hour_Power_EPEX")) {
						next.product = "Intraday_Hour_Power";
					} else if (next.product.contentEquals("Intraday_Hour_Power")) {
						next.product = "XBID_Hour_Power_EPEX";
					}
					// Quarter hour
					else if (next.product.contentEquals("XBID_Quarter_Hour_Power_EPEX")) {
						next.product = "Intraday_Quarter_Hour_Power";
					} else if (next.product.contentEquals("Intraday_Quarter_Hour_Power")) {
						next.product = "XBID_Quarter_Hour_Power_EPEX";
					}
					// half hour
					else if (next.product.contentEquals("XBID_Half_Hour_Power_EPEX")) {
						next.product = "Intraday_Half_Hour_Power";
					} else if (next.product.contentEquals("Intraday_Half_Hour_Power")) {
						next.product = "XBID_Half_Hour_Power_EPEX";
					}
					orderContractID = contractList.FindContractId(next.orderTransactionTime, next.product,
							next.deliveryStart, next.deliveryEnd, Globals.guiWindowDebug);
					Globals.guiWindowDebug
							.AddText(sdf.format(new Date()) + " Contract Id to be used = '" + orderContractID + "'");
				}
				// Thread.sleep(30000);
				// for action != "A" (creation) create orders if they do not exist yet
				/*
				 * if (next.action.contentEquals("A") == false) {
				 * Globals.guiWindowDebug.AddText(" action not A : action = " + next.action); if
				 * (next.m7OrderId.contentEquals("")) { // if the order has never been submitted
				 * by this replay tool (ie. there was no A record before) substituteAction =
				 * "A"; Globals.guiWindowDebug.AddText(" Order " + next.fileOrderId +
				 * " : Action = " + next.action + " forcing action = "+ substituteAction); }
				 * else substituteAction = next.action; }
				 */
				// send the order only if it still exist in M7 (if it did not reach a final
				// State/Action : fully matched, deleted)
				if (next.action.contentEquals("FEXE") == false) {

					nbSubmittedOrders++;

					if (substituteAction.contentEquals("A")) {
						String tempSide = next.side;
						if (tempSide.equals("Buy")) {
							tempSide = "BUY";
						} else {
							tempSide = "SELL";
						}

						orderRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
								+ "<OrdrEntry xmlns=\"http://www.deutsche-boerse.com/m7/v6\">"
								+ "<StandardHeader marketId=\"EPEX\"/>" + "<OrdrList>" + " <Ordr "
								+ " clearingAcctType=\"P\"" + " acctId=\"11XTM2-TM------1\"" + " prod=\"" + next.product
								+ "\"" + " contractId=\"" + orderContractID + "\"" + " side=\"" + tempSide + "\""
								+ " px=\"" + next.price.replaceAll("\\.", "") + "\"" + " qty=\""
								+ next.quantity.replaceAll("\\.", "") + "00\"" + " ordrExeRestriction=\"NON\""
								+ " txt=\"Test sample CREATION: file order ID = " + next.fileOrderId + "\""
								+ " dlvryAreaId=\"10YDE-RWENET---I\"" + " clOrdrId=\"" + next.fileOrderId + "\""
								+ " type=\"O\" validityRes=\"GFS\" state=\"ACTI\" aot=\"true\"/>" + "</OrdrList>"
								+ "</OrdrEntry>";
					} else { // action code is not 'A': must be a request for an order which has already been
								// submitted

						// check if another record for the same order is not being processed / wait
						// until processed (until the Order Exe Report was received, to get the right
						// revisionNo)
						waitUntilOrderHasBeenProcessedByM7(orderBeingProcessedByM7List, next.fileOrderId,
								Globals.guiWindowDebug);

						/*
						 * while (next.m7OrderId.contentEquals("")) {
						 * Globals.guiWindowDebug.AddText(sdf.format(new Date())
						 * +" Order Change : order #" + nbSubmittedOrders + " file Order ID = " +
						 * next.fileOrderId+ " => m7OrderId empty"); Thread.sleep(2000); }
						 */
						if (substituteAction.contentEquals("C")) {

							orderRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
									+ "<OrdrModify xmlns=\"http://www.deutsche-boerse.com/m7/v6\" ordrModType=\"MODI\">"
									+ "<StandardHeader marketId=\"EPEX\"/>" + "<OrdrList>" + " <Ordr " + " ordrId=\""
									+ next.m7OrderId + "\"" + " px=\"" + next.price.replaceAll("\\.", "") + "\""
									+ " qty=\"" + next.quantity.replaceAll("\\.", "") + "00\"" + " revisionNo=\""
									+ next.m7RevisionNo + "\"" + " txt=\"Test sample CHANGE: file order ID = "
									+ next.fileOrderId + "\""
									+ " type=\"O\" validityRes=\"GFS\" state=\"ACTI\" aot=\"true\"/>" + "</OrdrList>"
									+ "</OrdrModify>";

						} else if (substituteAction.contentEquals("D")) {

							orderRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
									+ "<OrdrModify xmlns=\"http://www.deutsche-boerse.com/m7/v6\" ordrModType=\"DELE\">"
									+ "<StandardHeader marketId=\"EPEX\"/>" + "<OrdrList>" + " <Ordr " + " ordrId=\""
									+ next.m7OrderId + "\"" + " px=\"" + next.price.replaceAll("\\.", "") + "\""
									+ " qty=\"" + next.quantity.replaceAll("\\.", "") + "00\"" + " revisionNo=\""
									+ next.m7RevisionNo + "\"" + " txt=\"Test sample DELETION: file order ID = "
									+ next.fileOrderId + "\""
									+ " type=\"O\" validityRes=\"GFS\" state=\"ACTI\" aot=\"true\"/>" + "</OrdrList>"
									+ "</OrdrModify>";

						} else if (substituteAction.contentEquals("H")) { // Hibernation

							orderRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
									+ "<OrdrModify xmlns=\"http://www.deutsche-boerse.com/m7/v6\" ordrModType=\"DEAC\">"
									+ "<StandardHeader marketId=\"EPEX\"/>" + "<OrdrList>" + " <Ordr " + " ordrId=\""
									+ next.m7OrderId + "\"" + " px=\"" + next.price.replaceAll("\\.", "") + "\""
									+ " qty=\"" + next.quantity.replaceAll("\\.", "") + "00\"" + " revisionNo=\""
									+ next.m7RevisionNo + "\""
									// + " revisionNo=\"" + "2"+ "\""
									+ " txt=\"Test sample HIBERNATION: file order ID = " + next.fileOrderId + "\""
									+ " type=\"O\" validityRes=\"GFS\" state=\"ACTI\" aot=\"true\"/>" + "</OrdrList>"
									+ "</OrdrModify>";

						}

						else { // X (deleted by M7), I (new slice of an iceberg order), P (partially matched),
								// M (fully matched) : nothing to do, corresponds to an M7 action
							appLog.logger.info(sdf.format(new Date()) + " ERROR : unknown action code = '"
									+ substituteAction + "'");
							Globals.guiWindowDebug.AddText(sdf.format(new Date()) + " ERROR : unknown action code = '"
									+ substituteAction + "'");
						}
					}
					appLog.logger.info(sdf.format(new Date()) + " Order #" + nbSubmittedOrders + " Order request = "
							+ orderRequest);
					Globals.guiWindowDebug.AddText(sdf.format(new Date()) + " Order #" + nbSubmittedOrders
							+ " Order request = " + orderRequest);

					// submit the order with correlationId = initial order ID in the historical
					// order file
					// so that it is possible when receiving later the related Order Exe Report to
					// associate this submission with the order Id sent back by M7 and to track it
					// in the Order List
					// note: if another order matches our own order then the correlation ID will be
					// the one of the aggressor order : only rely on routing keys to identify own
					// orders (for Orde Exe Report : Balancing groups)
					next.hasBeenSentToM7 = true;

					OrderBeingProcessed currentOrderToBeProcessed = new OrderBeingProcessed(next.fileOrderId);
					orderBeingProcessedByM7List.add(currentOrderToBeProcessed);

					// displayOrderBeingProcessedList(orderBeingProcessedByM7List, guiWindow);

					requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_MANAGEMENT, true, false,
							headers.correlationId(next.fileOrderId).build(), orderRequest.getBytes());

					// Thread.sleep(1000);
				}
			}
		}

		Globals.guiWindowDebug
				.AddText("**** End of main actions, waiting to keep the broadcast listening process up ****");

		// sleep for 24 hours: listen for broadcasts and calculate counts for 24 hours
		Thread.sleep(1000 * 60 * 60 * 24);

		Globals.guiWindowDebug.AddText("End: closing the AMQP connection");
		System.out.println("End: connection closed");
		conn.close();
	}

	// ************************************************************
	// FillInEmptyTradableOrderBooks
	// Submit a buy and sell order for each tradable empty order book
	// ************************************************************
	public void FillInEmptyTradableOrderBooks() {
		
		appLog.logger.info("fillEmptyOrderBooks = " + fillEmptyOrderBooks + ", nb of order books = "
				+ orderBooksList.getNbOrderBooks());
		orderNbFillOBK = 0;
		String BGFillObk = userDefaultBalancingGroup;
		int nbObkScan = 0;
		
		int nbEmptyObk = orderBooksList.nbTradableOrderBooks;
		int nbEmptyTradableObk = orderBooksList.nbEmptyTradableOrderBooks;
		float ratioEmptyObk = ((float) nbEmptyTradableObk / (float) nbEmptyObk) * 100;

		msg = "Initial empty Order books situation : " +  nbEmptyTradableObk + " / " + nbEmptyObk + " (" + String.format("%.0f%%", ratioEmptyObk) + ")";

		appLog.logger.info(msg);
		controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
		//JOptionPane.showMessageDialog(controlBoardFrame, msg);
		
		// infinite loop when logged in as a trader if indicated in config file to fill
		// in empty order books
		// JOptionPane.showMessageDialog(controlBoardFrame, "fillEmptyOrderBooks:
		// windowOrderGenerationControl.orderGeneration_ON = "+
		// windowOrderGenerationControl.orderGeneration_ON);
		// && windowOrderGenerationControl.orderGeneration_ON
		
		if (adminMode == false && fillEmptyOrderBooks.contentEquals("true")) {
			int initialNbEmptyObk = orderBooksList.getNbEmptyTradableOrderBooks();			
		}
		while (adminMode == false && fillEmptyOrderBooks.contentEquals("true")) {

			// OrdersList ordersList = new OrdersList();
			nbObkScan++;
			appLog.logger.info("nbObkScan = " + nbObkScan);
						
			// wait until there is one tradable obk without any active order:

			// go through the obk list and fill in all tradable obk without any active
			// order: add a buy and sell order
			int obkNbInList = 0;
			int currentNbEmptyObk = 0;
			
			ListIterator<OrderBook> list_Iter = orderBooksList.orderBooksList.listIterator(); 
			while (list_Iter.hasNext()) {
				OrderBook orderBookItr = list_Iter.next();
					
				obkNbInList++;
				currentNbEmptyObk = orderBooksList.getNbEmptyTradableOrderBooks();
				appLog.logger.fine("Going through the obk list : obk #"+obkNbInList);
				
				// efficiency: do not submit twice in a row orders on the same contract (send to one area: if there is some capacity then connected areas will receive the order as a cross border order for that contract)
				String previousContractId ="" ;
				
				windowOrderGenerationControl.setStrategy(0); // set to systematic order sending
				
				// only process tradable order books without any active order
				if (!"NOT_FOUND".contains(orderBookItr.getContractID_Name()) && orderBookItr.getContractID_Area_Is_Tradable()
						&& orderBookItr.getNbActiveOrders() == 0  && windowOrderGenerationControl.orderGeneration_ON
						&& !"10YLV-1001A00074".contentEquals(orderBookItr.getDlvryAreaId())) { // temporary config issue in ASIM
					
					// && (!orderBookItr.getContractId().contentEquals(previousContractId))
					previousContractId = orderBookItr.getContractId();
					// orderNbFillOBK < 7 &&
					// appLog.logger.severe("Empty obk found #" + obkNbInList+ ": " +
					// orderBookItr.getContractId() + " " + orderBookItr.getContractID_Name() + " " +
					// orderBookItr.getDlvryAreaId() + " initial nb of empty obk = " + initialNbEmptyObk + "
					// current nb ="+ currentNbEmptyObk);

					long previousOrderEntryTime = System.nanoTime();

					// buy order
					orderNbFillOBK++;
					Order buyOrder = new Order();
					// buyOrder.correlationId = start_time+"_FILL#"+orderNbFillOBK;
					buyOrder.correlationId = "LOAD_BUY__FILL_OBK#" + orderNb + "_" + sdfTime.format(new Date());
					buyOrder.clientOrderId = buyOrder.correlationId;
					buyOrder.side = "BUY";
					buyOrder.state = "ACTI";
					buyOrder.BalancingGroup = BGFillObk;
					buyOrder.product = orderBookItr.getContractID_Product();
					buyOrder.contractId = orderBookItr.getContractId();
					buyOrder.contractName = orderBookItr.getContractID_Name();
					buyOrder.deliveryAreaId = orderBookItr.getDlvryAreaId();
					buyOrder.executionRestriction = "NON";
					// type: O for limit Orders, B for User Defined Blocks
					if ("false".contentEquals(orderBookItr.getContractID_Product_Predefined())) {
						buyOrder.executionRestriction = "AON";
						buyOrder.type = "B";
					} else {
						buyOrder.type = "O";
					}
					// random price in a range
					Random randomP = new Random();
					buyOrder.price = randomP.nextInt(5) + 130 + "00";
					buyOrder.quantity = randomP.nextInt(50) + 100 + "000";
					buyOrder.text = "Fill Order Book Order #" + buyOrder.clientOrderId + " contract = "
							+ orderBookItr.getContractID_Name() + " " + buyOrder.deliveryAreaId + " " + BGFillObk
							+ " empty tradable obk = " + orderBooksList.nbEmptyTradableOrderBooks;

					this.submitOrder(buyOrder);

					// sell order
					orderNbFillOBK++;
					Order sellOrder = new Order();
					sellOrder.correlationId = "LOAD_SELL_FILL_OBK#" + orderNb + "_" + sdfTime.format(new Date());
					sellOrder.clientOrderId = sellOrder.correlationId;
					sellOrder.side = "SELL";
					sellOrder.state = "ACTI";
					sellOrder.BalancingGroup = BGFillObk;
					sellOrder.product = orderBookItr.getContractID_Product();
					sellOrder.contractId = orderBookItr.getContractId();
					sellOrder.contractName = orderBookItr.getContractID_Name();
					sellOrder.deliveryAreaId = orderBookItr.getDlvryAreaId();
					sellOrder.executionRestriction = "NON";
					// type: O for limit Orders, B for User Defined Blocks
					if ("false".contentEquals(orderBookItr.getContractID_Product_Predefined())) {
						sellOrder.executionRestriction = "AON";
						sellOrder.type = "B";
					} else {
						sellOrder.type = "O";
					}
					// random price in a range
					sellOrder.price = Integer.valueOf(buyOrder.price) + 100 + "";
					sellOrder.quantity = randomP.nextInt(50) + 100 + "000";
					sellOrder.text = "Fill Order Book Order #" + sellOrder.clientOrderId + " contract = "
							+ orderBookItr.getContractID_Name() + " " + sellOrder.deliveryAreaId + " " + BGFillObk
							+ " empty obk = " + orderBooksList.nbEmptyTradableOrderBooks;

					this.submitOrder(sellOrder);
					

					// appLog.logger.severe("Submitting buy and sell orders : contract " +
					// orderBookItr.getContractID_Name() + " area = " + orderBookItr.getDlvryAreaId() + " qty = " +
					// randomQty + " price = " + randomPrice + " ExeRes =" + ExeRes + " Text="+
					// text);

					waitForRemainingTimeBetweenTwoOrderEvents(previousOrderEntryTime);

					if (orderNbFillOBK > 100000) {
						appLog.logger.warning(" nb of orders to fill in empty obk too high: " + orderNbFillOBK + " : EXIT");
						System.exit(0);
					}
				} else {
					// .contentEquals("NOT_FOUND") &&
					msg = "Order book #" + obkNbInList + ":" + orderBookItr.getContractID_Name()
					+ " does not require any order : not empty (" + orderBookItr.getNbActiveOrders()
					+ " orders) or not tradable: orderBookItr.getContractID_Area_Is_Tradable()="
					+ orderBookItr.getContractID_Area_Is_Tradable() + " orderBooksList.getNbEmptyTradableOrderBooks()="
					+ orderBooksList.getNbEmptyTradableOrderBooks();
					//appLog.logger.info(msg);
				}
				// appLog.logger.severe("nbObkScan = "+ nbObkScan + " obkNbInList = " +
				// obkNbInList + " initialNbEmptyObk = " + initialNbEmptyObk + " current
				// orderBooksList.getNbEmptyTradableOrderBooks()="+
				// orderBooksList.getNbEmptyTradableOrderBooks());
			} // loop on all order books in orderBooksList
			appLog.logger.severe("No more empty tradable order books in orderBooksList: obkNbInList = " + obkNbInList);
			appLog.logger.severe("end of obk scan iteration #" + nbObkScan);
		} // infinite loop

	}

	// ************************************************************
	// * SendThrottlingStatusReq
	// ************************************************************
	public int waitForRemainingTimeBetweenTwoOrderEvents(long previousOrderEventTime) {

		// determine the remaining time to wait to stick to the requested order
		// generation interval orderGenerationIntervalMillisec in config file:
		int elpasedTimeDuringCurrentIterationMs = (int) ((System.nanoTime() - previousOrderEventTime) / 1e6);

		msg = "(wait) elpasedTimeDuringCurrentIterationMs=" + elpasedTimeDuringCurrentIterationMs
				+ " calculation = " + ((System.nanoTime() - previousOrderEventTime) / 1e6) + " intOrderGenerationIntervalMillisec = "+intOrderGenerationIntervalMillisec;
		//System.out.println(msg);
		appLog.logger.fine(msg);

		int remainingTimeToWait_Milliseconds = intOrderGenerationIntervalMillisec - elpasedTimeDuringCurrentIterationMs;
		if (remainingTimeToWait_Milliseconds < 0) {
			// waiting time already exceeded : no need to wait
			msg = "NO time to wait since elapsed time = "
					+ (elpasedTimeDuringCurrentIterationMs - intOrderGenerationIntervalMillisec) + "ms";
			//System.out.println(msg);
			appLog.logger.fine(msg);
		} else { // wait for the remaining time
			msg = "time to wait = " + remainingTimeToWait_Milliseconds + "ms";
			//System.out.println(msg);
			appLog.logger.fine(msg);
			try {
				Random randomTime = new Random();
				int waitMs = 0;
				if ("true".contentEquals(randomIntervalBetweenOrders)) { // set up in the config file
					waitMs = randomTime.nextInt(remainingTimeToWait_Milliseconds)+100; // wait at least for 100 ms
				}
				else waitMs = remainingTimeToWait_Milliseconds;
				
				Thread.sleep(waitMs);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Globals.guiWindowDebug.AddText(e.toString());
			}
		}
		return remainingTimeToWait_Milliseconds;
	}

	// ************************************************************
	// * SendMarketStateReq
	// ************************************************************
	public void SendMarketStateReq() {
		// retrieve the market state
		String sMktStateReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<MktStateReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\">" + "<StandardHeader marketId=\"EPEX\"/>"
				+ "</MktStateReq>";

		appLog.logger.info("MktStateReq= " + sMktStateReq);
		Globals.guiWindowDebug.AddText("MktStateReq= " + sMktStateReq);

		sendRequest(ROUTING_KEY_INQUIRY, "MktStateReq", "MARKET_STATE_REQ_"+connectionLossNb, sMktStateReq, RESP_OPTIONAL_TO_START);
	}

	// ************************************************************
	// * SendDeteleAllOrders
	// ************************************************************
	public void SendModifyAllOrders(String ordrModType) {
		
		// retrieve the market state
		String sModifyAllOrdrsReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<ModifyAllOrdrs xmlns=\"http://www.deutsche-boerse.com/m7/v6\" usrId=\"" + userId + "\""
				+ " ordrModType=\"" + ordrModType + "\"" + " inclPreArranged=\"true\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + "</ModifyAllOrdrs>";

		appLog.logger.info("sModifyAllOrdrsReq= " + sModifyAllOrdrsReq);
		Globals.guiWindowDebug.AddText("sModifyAllOrdrsReq= " + sModifyAllOrdrsReq);

		sendRequest(ROUTING_KEY_MANAGEMENT, "ModifyAllOrdrs", "MODIFY_ALL_ORDERS_" + ordrModType + "_"+connectionLossNb, sModifyAllOrdrsReq,
				RESP_OPTIONAL_TO_START);
	}

	
	// **************************************************
	// Initialize variables and files before creating the GUI
	// ***************************************************
	public void Init() {

		contractList = new ContractList(appLog, controlBoardFrame);

		// delivery areas list
		deliveryAreaList = new DeliveryAreaList(controlBoardFrame);
		
		// users
		usersList = new UsersList(controlBoardFrame);
		
		// BG member 
		bgMemberList = new BG_Member_List(controlBoardFrame, membersList);
		
		// products list
		productList = new ProductList(controlBoardFrame);
		
		// list of requests responses
		request_responseList = new RequestResponseList(controlBoardFrame, appLog);

		// list of broadcasts
		broadcastList = new BroadcastList(controlBoardFrame);

		// creation the list of routing key for the gap detection mechanism
		routingKeysList = new RoutingKeysList();
		missingRoutingKeysList = new RoutingKeysList();

		// creation of the list of Orders Market players for stats
		orderPlayersList = new OrderPlayersList();

		// create the list of order books
		orderBooksList = new OrderBooksList(deliveryAreaList, contractList);
		emptyOrderBooksList = new EmptyOrderBooksList(appLog);
		
		// trades list 
		tradesList = new TradesList();
		
		// when measuring login duration
		loginDurationsList = new LoginDurationsList(controlBoardFrame, appLog); 

		// retrieve connection parameters from the config.properties file

		try {
			properties.getPropValues();
			userName = properties.userName;
			password = properties.password;
			rabbitHost1 = properties.rabbitHost1;
			rabbitHost2 = properties.rabbitHost2;
			rabbitVHost = properties.rabbitVHost;
			rabbitPort = properties.rabbitPort;
			certPassword = properties.certPassword;
			certPath = properties.certPath;
			applicationID = properties.applicationID;
			processBroadcast = properties.processBroadcast;
			manageOrderBooks = properties.manageOrderBooks;
			sentMsgContentEncoding = properties.sentMsgContentEncoding;
			adminRetrieveOrdersPast = properties.adminRetrieveOrdersPast;
			adminRetrieveOrdersPastDaysShift = Integer.parseInt(properties.adminRetrieveOrdersPastDaysShift);
			orderGeneration = properties.orderGeneration;
			marketAnimation = properties.marketAnimation;
			fillEmptyOrderBooks = properties.fillEmptyOrderBooks;
			nbOfOrdersConfigFile = properties.nbOfOrders;
			orderGenerationIntervalMillisec = properties.orderGenerationIntervalMillisec;
			randomIntervalBetweenOrders = properties.randomIntervalBetweenOrders;
			nbOfOrdersPerBasket = properties.nbOfOrdersPerBasket;
			basketListExecInst = properties.basketListExecInst;
			throttlingActivated = properties.throttlingActivated;
			throttlingStatusReqIntervalMillisec = properties.throttlingStatusReqIntervalMillisec;
			sendThrottlingStatusReqAfterEachOrder = properties.sendThrottlingStatusReqAfterEachOrder;
			disconnectAction = properties.disconnectAction;
			throttlingUserAction = properties.throttlingUserAction;
			throttlingMemberAction = properties.throttlingMemberAction;
			userPasswordChange = properties.userPasswordChange;
			privateResponseQueueNameSuffix = properties.privateResponseQueueNameSuffix;
			loginReqLoop = properties.loginReqLoop;
			logoutsBetweenLogins = properties.logoutsBetweenLogins;
			waitingTimeBetweenLoginsMillisec = properties.waitingTimeBetweenLoginsMillisec;

			// enforce parameters consistency
			if (adminRetrieveOrdersPast.contentEquals("true"))
				processBroadcast = "false"; // main activity already too consuming to process broadcasts
			else {
				processBroadcast = "true";
				adminRetrieveOrdersPastDaysShift = 0;
			}

			if (throttlingActivated.contentEquals("true"))
				bThrottlingEnabled = true;
			else bThrottlingEnabled = false;

		} catch (IOException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
			// guiWindowConnection.AddText(e2.toString());
			Globals.guiWindowDebug.AddText(e2.toString());
		}
	}

	// **************************************************
	// Initialize variables and files before creating the GUI
	// ***************************************************
	public void Init_Files() throws SecurityException, IOException {
		// create other functional required files
		File f = new File(FILE_STATS_NAME);
		if (f.exists()) {
			f.delete();
		}
		FileWriter statsFileWriter = new FileWriter(FILE_STATS_NAME);
		statsFileWriter.append(FILE_STATS_HEADER);
		statsFileWriter.flush();
		statsFileWriter.close();

		f = new File(FILE_PLAYERS_DETAILS_NAME);
		if (f.exists()) {
			f.delete();
		}
		FileWriter playersEventsDetailsWriter = new FileWriter(FILE_PLAYERS_DETAILS_NAME);
		playersEventsDetailsWriter.append(FILE_PLAYERS_LIST_HEADER);
		playersEventsDetailsWriter.flush();
		playersEventsDetailsWriter.close();

		throttlingStatus.deleteThrottlingStatusResponsesCSVFile();
		throttlingStatus.WriteThrottlingStatusResponsesCSVFile_Header();
	}
	// **************************************************
	// Remove all values in lists that must be rebuilt in case of a connection lost (design choice for this sample app)
	// ***************************************************
	public void clear_Lists_Shutdown() {
		contractList.contractList.clear();
		contractList.updateGUITable(controlBoardFrame.contract_GUI_Panel);

		// creation the list of routing key for the gap detection mechanism
		routingKeysList.routingKeysList.clear();
		routingKeysList.updateGUITable(controlBoardFrame.RK_Gaps_GUI_Panel);
		missingRoutingKeysList.routingKeysList.clear();

		// create the list of order books
		orderBooksList.orderBooksList.clear();
		emptyOrderBooksList.emptyOrderBooksList.clear();
	}
	
	
	// **************************************************
	// Wait a minimum (e.g. 30 seconds) for key response messages before going any
	// further
	// returns true if timeout exceeded
	// ***************************************************
	public boolean WaitForKeyResponses(int nbSecTimeout) {
		boolean bTimeOutReached = false;
		// wait for contracts responses to arrive:
		// check if the request "RTT" for a given msg and correlation ID is still
		// "Waiting"

		int waitLoop = 0;
		// loop while still waiting for a mandatory response, until a timeout
		while (request_responseList.StillWaitingForMandatoryResponses() && waitLoop < nbSecTimeout) {
			msg = "Waiting for all mandatory response to arrive (" + waitLoop + ")";
			Globals.guiWindowDebug.AddText(msg);
			appLog.logger.info(msg);
			try {
				Thread.sleep(1000);
				waitLoop++;
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Globals.guiWindowDebug.AddText(e.toString());
			}
		}

		if (waitLoop == nbSecTimeout) {
			bTimeOutReached = true;
		}
		return bTimeOutReached;
	}

	// **********************************************************************************************************************
	// Animate the market by sending random order and then applying random actions
	// (hibernate, activate, modify, delete, etc.)
	// **********************************************************************************************************************
	public void marketAnimation_manageOrders() throws InterruptedException {

		int nbGeneratedOrders = 1;

		while (true) {

			// give the possibility to stop the order flow by deactivating the periodic order generation GUI button
			if (windowOrderGenerationControl.orderGeneration_ON) {
	
				// find an order to manage
				Order orderToManage = new Order();
				orderToManage = ordersList.findAnOrderToManage();
	
				msg = "orderToManage_CorrelationId = " + orderToManage.correlationId;
				Globals.guiWindowDebug.AddText(msg);
				appLog.logger.fine(msg);
	
				if (orderToManage.correlationId.contentEquals("NOT_FOUND")) {
					// if no order to manage could be found, create an order
					msg = "The list of orders is empty : submitting a random order";
					appLog.logger.fine(msg);
					generateAndSubmitNewOrder("RANDOM_MODE", "RANDOM_SIDE","MARKET_ANIMATION", nbGeneratedOrders, 120, 5, 130, 5);
					nbGeneratedOrders++;
				} else {
					// an order could be found: determine an action to perform to this correlation Id
					// privilege order price modifications
					
					msg = "The list of orders is NOT empty : determining randomly n action to do with existing orders OR submit a new order.";
					appLog.logger.fine(msg);
					
					String orderModificationType = "TBD";
					
					Random randomAction = new Random();
					int ACTION_RANDOM_NB_TOP_OF_RANGE = 50;
					int randomActionNb = randomAction.nextInt(ACTION_RANDOM_NB_TOP_OF_RANGE) + 1; // generation a random int between 1 and ACTION_RANDOM_NB_TOP_OF_RANGE included 
					
					if (randomActionNb == 0) { // activate / hibernate
						if (orderToManage.action.contains("HIB")) { // UHIB or SHIB or AHIB: the order is hibernated
							// activate
							orderModificationType = "ACTI";
							orderToManage.text = "Market animation: activated";
							orderToManage.text = "MARKET_ANIMATION ACTIVATION: randomActionNb=" + randomActionNb;
						} else { // deactivate
							orderModificationType = "DEAC";
							orderToManage.text = "Market animation: hibernated";
							orderToManage.text = "MARKET_ANIMATION HIBERNATION: randomActionNb=" + randomActionNb;
						}
					} else if (randomActionNb > 0 && randomActionNb <= 5) { // new order entry
						orderModificationType = "NEW_ORDER";
						orderToManage.text = "MARKET_ANIMATION NEW ENTRY: randomActionNb=" + randomActionNb;
					} else if (randomActionNb > 5 && randomActionNb < ACTION_RANDOM_NB_TOP_OF_RANGE) 
					{ // modify price or qty
						orderModificationType = "MODI";
						
						Random randomPriceOrQty = new Random();
						int priceOrQty = randomPriceOrQty.nextInt(2);
						priceOrQty = 1;
						if (priceOrQty == 0)	{
							String previousPrice = orderToManage.price;
	
							// randomly increase or decrease the price
							Random randomPriceDirection = new Random();
							int priceDirection = randomPriceDirection.nextInt(2);
							int priceChangeFactor = randomPriceDirection.nextInt(2) + 1;
							int priceDelta = 0;
	
							if (priceDirection == 0)
								priceDelta = -10;
							else
								priceDelta = 10;
	
							orderToManage.price = Integer.toString(Integer.parseInt(orderToManage.price) + priceDelta * priceChangeFactor);
							orderToManage.text = "MARKET_ANIMATION MODI price increase: previous price = " + previousPrice
									+ " new price =" + orderToManage.price + " randomActionNb="+ randomActionNb;
							}
						else
							{
							String sPreviousQty = orderToManage.quantity;
							int iPreviousQty = Integer.parseInt(orderToManage.quantity);
							if (iPreviousQty > 100) {
								orderToManage.quantity = Integer.toString(iPreviousQty - 100);
								orderToManage.text = "MARKET_ANIMATION MODI qty decrease: previous qty = " + sPreviousQty
									+ " new qty=" + orderToManage.quantity + " randomActionNb=" + randomActionNb;
							} 
							else orderToManage.text = "MARKET_ANIMATION MODI qty too low: left unchanged"; 
							}
					} 
					else orderModificationType = "DELE";
									
					msg = "randomActionNb = "  + randomActionNb + " orderModificationType = " + orderModificationType;
					appLog.logger.fine(msg);
					
					Globals.guiWindowDebug.AddText("randomActionNb = " + randomActionNb + "  : execute action " + orderModificationType);
					if (orderModificationType.contentEquals("NEW_ORDER")) {
						generateAndSubmitNewOrder("RANDOM_MODE", "RANDOM_SIDE","MARKET_ANIMATION", nbGeneratedOrders, 120, 5, 130, 5); 
						nbGeneratedOrders++;
					} else
						modifyOrder(orderToManage, orderModificationType);
				}
				
				// send a Throttling Status Req immediately after the order sending, if requested and only for testing purposes
				if ("true".contentEquals(sendThrottlingStatusReqAfterEachOrder)) this.sendThrottlingStatusReq();
				
				Random randomTime = new Random();
				int waitMs = 0;
				if ("true".contentEquals(randomIntervalBetweenOrders)) {
					waitMs = randomTime.nextInt(intOrderGenerationIntervalMillisec)+100; // wait at least for 100 ms
				}
				else waitMs = intOrderGenerationIntervalMillisec;
				Thread.sleep(waitMs);
			}
		}
	}

	// *******************************************************
	// generateAndSubmitNewOrder
	// submit a new random order
	// *******************************************************
	public void generateAndSubmitNewOrder(String generationMode, String sideMode, String textPrefix, int orderNb, int buyPriceBasis, int buyPriceDelta, int sellPriceBasis, int sellPriceDelta) {
		// sideMode = BUY, SELL, RANDOM_SIDE
		
		int priceBasis = 0;
		int priceDelta = 0;

		String msg = " generateAndSubmitNewOrder: determine a new order to be submitted";
		appLog.logger.fine(msg);
		
		Order order = new Order();
		Contract tradableContract = new Contract();
		
		// common part
		// sample order
		order.correlationId = textPrefix + "#" + orderNb + "_" + sdfTime.format(new Date());
		order.clientOrderId = order.correlationId;

		Random randomSide = new Random();
		String side = "";
		if ("RANDOM_SIDE".contentEquals(sideMode)) {
			int intSide = randomSide.nextInt(2);
			if (intSide == 0)
				side = "BUY";
			else
				side = "SELL";
			order.side = side;			
		}
		else order.side = sideMode;
		
		order.state = "ACTI";
		order.BalancingGroup = userDefaultBalancingGroup;

		// random price in a range
		if ("BUY".contentEquals(order.side)) {
			priceBasis = buyPriceBasis;
			priceDelta = buyPriceDelta;
		}
		else {
			priceBasis = sellPriceBasis;
			priceDelta = sellPriceDelta;
		}
		Random randomP = new Random();			
		order.price = randomP.nextInt(priceDelta) + priceBasis + "00"; // if priceBasis = 500 and delta = 4 : price = between 500 and 554 /GBP
		
		// quantity
		order.quantity = randomP.nextInt(50) + 100 + "000"; // between 100 and 149
	

		if ("RANDOM_MODE".contentEquals(generationMode)) {
			// pick up a random tradable contract and area combination
			tradableContract = contractList.pickUp_Tradable_Contract(controlBoardFrame);
			if (tradableContract != null) {
				order.contractId = tradableContract.getContractId();
				order.product = tradableContract.getProd();
				order.contractName = tradableContract.getName();
				order.deliveryAreaId = tradableContract.getChosenAreaToTrade();
				order.executionRestriction = "NON";
				order.deliveryStart = tradableContract.getDlvryStart();
				order.deliveryEnd = tradableContract.getDlvryEnd();
				
				// type: O for limit Orders, B for User Defined Blocks
				if (tradableContract.getPredefined().contentEquals("false")) {
					order.executionRestriction = "AON";
					order.type = "B";
				} else {
					order.type = "O";
				}
				order.text = textPrefix + "#" + orderNb + " contract ID " + order.contractId+ " : "  + order.contractName 
							+ " area=" + order.deliveryAreaId + " "+ order.correlationId;
			}
			else {
				msg = "tradableContract is null";
				JOptionPane.showMessageDialog(controlBoardFrame, msg);
			}


		/*
		 * // wait for a tradable contract ID to be identified while
		 * (tradableContractId.contentEquals("NOT_FOUND")) try { Thread.sleep(100); }
		 * catch (InterruptedException e) { // TODO Auto-generated catch block
		 * e.printStackTrace(); }
		 */


		this.submitOrder(order);
		}
		else if ("USER_DEFINED_BLOCK".contentEquals(generationMode)) {
			order.product = "XBID_Hour_Power";
			order.deliveryAreaId = "10YDE-RWENET---I";
			order.executionRestriction = "AON";
			
			// send UDB for tomorrow after 3pm, once hourly contracts for the next day are open
			SimpleDateFormat simpleDateFormat = new SimpleDateFormat(pattern); // get first part of the delivery start and end 
			String todayDate = simpleDateFormat.format(new Date()); // get current day
			Calendar calendar = Calendar.getInstance();
			calendar.add(Calendar.DAY_OF_YEAR, +1); 
			String tomorrowDate = simpleDateFormat.format(calendar.getTime()); // get yesterday
			
			Instant instant = Instant.now();
			int currentHourUTC = instant.atZone(ZoneOffset.UTC).getHour();

			if (currentHourUTC >= 14) { // UTC
				Random randomHour= new Random();
				int randomStartHour= randomHour.nextInt(21)+2;
				order.deliveryStart = tomorrowDate + "T" + (randomStartHour) + ":00:00.000Z";
				order.deliveryEnd   = tomorrowDate + "T" + (randomStartHour + 2) + ":00:00.000Z";
			}
			else {
				order.deliveryStart = todayDate + "T" + (currentHourUTC + 3) + ":00:00.000Z";
				order.deliveryEnd   = todayDate + "T" + (currentHourUTC + 4) + ":00:00.000Z";	
			}
			

			order.type = "B"; // UDB order
			order.contractId = ""; // to be ignored when building the order request
			order.text = "UDB " + textPrefix + "#" + orderNb + " contract ID " + order.contractId+ " : "  + order.contractName
						+ " area=" + order.deliveryAreaId + " "+ order.correlationId;
			this.submitOrder(order);	
		} 
		else {} // not yet supported
	}

	// **************************************************
	// calculateStatistics
	// ***************************************************
	public void calculateOrdersAndTradesStatistics() {
		long elapsedSec = (long) ((System.nanoTime() - applicationStartNanoTime) / 1e9);

		// 24h forecast : calculate what the nb of orders and trades done since the app
		// launch would give over a 24h period
		if (elapsedSec > 0) {
			// overall OMT user order events
			projectionUserOrderEventsTotal = (UserOrderEventsNbM7 * 3600 * 24) / elapsedSec;
			projectionUserOrderEventsLocal = (UserOrderEventsNbLocal * 3600 * 24) / elapsedSec;
			projectionUserOrderEventsRemote = (UserOrderEventsNbRemote * 3600 * 24) / elapsedSec;

			projectionTradeEventsTotal = (tradeEventsNbTotal * 3600 * 24) / elapsedSec;
			projectionTradeEventsRemote = (tradeEventsNbRemote * 3600 * 24) / elapsedSec;

			// same thing for the EPEX order generator:
			projectionUserOrderEventsTotal_EPEX_OG = (UserOrderEventsNb_M7_EPEXOrderGenerator * 3600 * 24) / elapsedSec;
			projectionUserOrderEventsRemote_EPEX_OG = (UserOrderEventsNb_Remote_EPEXOrderGenerator * 3600 * 24)
					/ elapsedSec;
			projectionUserOrderEventsLocal_EPEX_OG = (UserOrderEventsNb_Local_EPEXOrderGenerator * 3600 * 24)
					/ elapsedSec;

			// EPEX order activity share per order contract type (total M7 = local + remote)
			EPEX_OG_vs_Total_M7_Order_Ratio = ((float) UserOrderEventsNb_M7_EPEXOrderGenerator
					/ (float) UserOrderEventsNbM7) * 100;
			EPEX_Local_OG_vs_Market_Local_Order_Ratio = ((float) UserOrderEventsNb_Local_EPEXOrderGenerator
					/ (float) UserOrderEventsNbLocal) * 100;
			EPEX_Remote_OG_vs_Market_Remote_Order_Ratio = ((float) UserOrderEventsNb_Remote_EPEXOrderGenerator
					/ (float) UserOrderEventsNbRemote) * 100;

			// Market remote share
			EPEX_Remote_vs_Total_Order_Ratio = ((float) UserOrderEventsNb_Remote_EPEXOrderGenerator
					/ (float) UserOrderEventsNb_M7_EPEXOrderGenerator) * 100;
			Market_Remote_vs_Total_Order_Ratio = ((float) UserOrderEventsNbRemote / (float) UserOrderEventsNbM7) * 100;

			formattedProjectionUserOrderEventsTotal = String.format("%1$" + 12 + "s",
					format.format(Math.ceil(projectionUserOrderEventsTotal)));
			formattedProjectionUserOrderEventsLocal = String.format("%1$" + 12 + "s",
					format.format(Math.ceil(projectionUserOrderEventsLocal)));
			formattedProjectionUserOrderEventsRemote = String.format("%1$" + 12 + "s",
					format.format(Math.ceil(projectionUserOrderEventsRemote)));
			formattedprojectionUserOrderEventsTotal_EPEX_OG = String.format("%1$" + 12 + "s",
					format.format(Math.ceil(projectionUserOrderEventsTotal_EPEX_OG)));
			formattedprojectionTradeEventsTotal = String.format("%1$" + 12 + "s",
					format.format(Math.ceil(projectionTradeEventsTotal)));

			String throttlingSuffix = "";
			if (bThrottlingEnabled == true)
				throttlingSuffix = "\n\n" + ThrottlingStatusResp; // throttlingTimestamp + " Status=" + throttlingStatus
																	// + "short OMT=" +
																	// memberThrottlingStatusRespShortOMTCount + " Long
																	// OMT = " + memberThrottlingStatusRespLongOMTCount+
																	// "\n ";

			msg = " Elapsed time since app launch : " + (int) Math.ceil(elapsedSec / (60 * 60)) + " hours (="
					+ (int) Math.ceil(elapsedSec / 60) + " mn =" + (int) Math.ceil(elapsedSec) + " seconds)" + "\n"
					+ String.format("%1$-" + 35 + "s", "- User Order events TOTAL ") + " = "
					+ String.format("%1$" + 10 + "s", UserOrderEventsNbM7) + " (EPEX = "
					+ String.format("%1$-" + 10 + "s", UserOrderEventsNb_M7_EPEXOrderGenerator) + " : "
					+ String.format("%.1f%%", EPEX_OG_vs_Total_M7_Order_Ratio) + ")" + "\t(24 hour = "
					+ formattedProjectionUserOrderEventsTotal + " ; EPEX ="
					+ format.format(Math.ceil(projectionUserOrderEventsTotal_EPEX_OG)) + ") " + "\n"
					+ String.format("%1$-" + 35 + "s", "- User Order events Local ") + "= "
					+ String.format("%1$" + 10 + "s", UserOrderEventsNbLocal) + " (EPEX = "
					+ String.format("%1$-" + 10 + "s", UserOrderEventsNb_Local_EPEXOrderGenerator) + " : "
					+ String.format("%.1f%%", EPEX_Local_OG_vs_Market_Local_Order_Ratio) + ")" + "\t(24 hour = "
					+ formattedProjectionUserOrderEventsLocal + " ; EPEX ="
					+ format.format(Math.ceil(projectionUserOrderEventsLocal_EPEX_OG)) + ")" + "\n"
					+ String.format("%1$-" + 35 + "s", "- User Order events XBID  ") + "= "
					+ String.format("%1$" + 10 + "s", UserOrderEventsNbRemote) + " (EPEX = "
					+ String.format("%1$-" + 10 + "s", UserOrderEventsNb_Remote_EPEXOrderGenerator) + " : "
					+ String.format("%.1f%%", EPEX_Remote_OG_vs_Market_Remote_Order_Ratio) + ")" + "\t(24 hour = "
					+ formattedProjectionUserOrderEventsRemote + " ; EPEX ="
					+ format.format(Math.ceil(projectionUserOrderEventsRemote_EPEX_OG)) + ")" + "\n\n"
					+ "- Remote/Total ratio = " + String.format("%.1f%%", Market_Remote_vs_Total_Order_Ratio)
					+ " (EPEX = " + String.format("%.1f%%", EPEX_Remote_vs_Total_Order_Ratio) + ")" + "\n\n "
					+ String.format("%1$-" + 20 + "s", "- Trades M7   ") + " = "
					+ String.format("%1$-" + 10 + "s", tradeEventsNbTotal) + "(24 hour = "
					+ format.format(Math.ceil(projectionTradeEventsTotal)) + ")" + "\n "
					+ String.format("%1$-" + 20 + "s", "- Trades XBID") + "= "
					+ String.format("%1$-" + 10 + "s", tradeEventsNbRemote) + "(24 hour = "
					+ format.format(Math.ceil(projectionTradeEventsRemote)) + ")"
					+ "\n\n - Trades Unknown Contract type = " + tradeEventsUnknownContract
					+ "\n - Nb of detected Gaps = " + routingKeysList.getNbGaps()
					+ "\n - Last interval beween 2 M7 heartbeats = " + m7HeartbeatDifferenceString + " seconds"
					+ "\n - Nb of M7 heartbeat losses = " + nbOfM7HeartbeatLosses
					+ "\n - Nb of AMQP connection losses = " + connectionLossNb + throttlingSuffix;

			String statsTime = sdfStats.format(new Date());
			// appLog.logger.info( statsTime + msg);
			// guiWindowBroadcasts.AddText(msg);
			// guiWindowCount.AddTextStaticPlace(msg);

			// TOTAL orders
			int row = 0;

			String sDuration = " Elapsed time since app launch : " + (int) Math.ceil(elapsedSec / (60 * 60))
					+ " hours (=" + (int) Math.ceil(elapsedSec / 60) + " mn =" + (int) Math.ceil(elapsedSec)
					+ " seconds)";

			durationTextField.setText(statsTime + " " + sDuration);
			// appLog.logger.info("Elapsed time ="+ sDuration);

			String commentStats = "Remote/Total ratio = " + String.format("%.1f%%", Market_Remote_vs_Total_Order_Ratio)
					+ " (EPEX = " + String.format("%.1f%%", EPEX_Remote_vs_Total_Order_Ratio) + ")";
			commentTextField.setText(commentStats);

			// {"User Order Event TYPE", "ELAPSED TIME", "MARKET", "EPEX", "EPEX %", "24h
			// MARKET PROJECTION","24h EPEX PROJECTION" };
			statsTable.setValueAt("TOTAL M7 (local+remote)", row, 0);
			statsTable.setValueAt(UserOrderEventsNbM7, row, 1);
			statsTable.setValueAt(String.format("%1$" + 10 + "s", UserOrderEventsNb_M7_EPEXOrderGenerator), row, 2);
			statsTable.setValueAt(String.format("%.1f%%", EPEX_OG_vs_Total_M7_Order_Ratio), row, 3);
			statsTable.setValueAt(formattedProjectionUserOrderEventsTotal, row, 4);
			statsTable.setValueAt((int) projectionUserOrderEventsTotal_EPEX_OG, row, 5);
			statsTable.setValueAt(tradeEventsNbTotal, row, 6);
			statsTable.setValueAt((int) projectionTradeEventsTotal, row, 7);

			// appLog.logger.info("**** elapsedSec = " + elapsedSec + "
			// projectionUserOrderEventsTotal =" + projectionUserOrderEventsTotal + "
			// formattedProjectionUserOrderEventsTotal = " +
			// formattedProjectionUserOrderEventsTotal + "
			// formattedProjectionUserOrderEventsLocal="+
			// formattedProjectionUserOrderEventsLocal + "
			// UserOrderEventsNbRemote"+UserOrderEventsNbRemote);

			if (projectionUserOrderEventsTotal < 0)
				appLog.logger.info("projectionUserOrderEventsTotal<0 " + projectionUserOrderEventsTotal);
			if (formattedProjectionUserOrderEventsTotal.contains("-"))
				appLog.logger
						.info("formattedProjectionUserOrderEventsTotal<0 " + formattedProjectionUserOrderEventsTotal);
			if (formattedProjectionUserOrderEventsLocal.contains("-"))
				appLog.logger
						.info("formattedProjectionUserOrderEventsLocal<0 " + formattedProjectionUserOrderEventsLocal);
			if (formattedProjectionUserOrderEventsRemote.contains("-"))
				appLog.logger
						.info("formattedProjectionUserOrderEventsRemote<0 " + formattedProjectionUserOrderEventsRemote);

			// nb of OMT before since 00:00 UTC
			row++;
			statsTable.setValueAt("Order events before start: D-" + adminRetrieveOrdersPastDaysShift, row, 0);
			statsTable.setValueAt(nbOMTBeforeStart, row, 1);

			// local orders
			row++;
			statsTable.setValueAt("Local", row, 0);
			statsTable.setValueAt(UserOrderEventsNbLocal, row, 1);
			statsTable.setValueAt(String.format("%1$-" + 10 + "s", UserOrderEventsNb_Local_EPEXOrderGenerator), row, 2);
			statsTable.setValueAt(String.format("%.1f%%", EPEX_Local_OG_vs_Market_Local_Order_Ratio), row, 3);
			statsTable.setValueAt(formattedProjectionUserOrderEventsLocal, row, 4);
			statsTable.setValueAt((int) projectionUserOrderEventsLocal_EPEX_OG, row, 5);
			statsTable.setValueAt(tradeEventsNbTotal - tradeEventsNbRemote, row, 6);
			statsTable.setValueAt((int) (projectionTradeEventsTotal - projectionTradeEventsRemote), row, 7);

			// remote orders
			row++;
			statsTable.setValueAt("Remote", row, 0);
			statsTable.setValueAt(UserOrderEventsNbRemote, row, 1);
			statsTable.setValueAt(String.format("%1$-" + 10 + "s", UserOrderEventsNb_Remote_EPEXOrderGenerator), row,
					2);
			statsTable.setValueAt(String.format("%.1f%%", EPEX_Remote_OG_vs_Market_Remote_Order_Ratio), row, 3);
			statsTable.setValueAt(formattedProjectionUserOrderEventsRemote, row, 4);
			statsTable.setValueAt((int) projectionUserOrderEventsRemote_EPEX_OG, row, 5);
			statsTable.setValueAt(tradeEventsNbRemote, row, 6);
			statsTable.setValueAt((int) projectionTradeEventsRemote, row, 7);

			// other info
			row++;
			// row++;
			// Remote / total ratio
			statsTable.setValueAt("Remote/Total ratio", row, 0);
			statsTable.setValueAt(String.format("%.1f%%", Market_Remote_vs_Total_Order_Ratio), row, 1);
			statsTable.setValueAt(String.format("%.1f%%", EPEX_Remote_vs_Total_Order_Ratio), row, 2);

			// Nb of Gaps
			row++;
			// row++;
			statsTable.setValueAt("Detected Gaps", row, 0);
			statsTable.setValueAt(routingKeysList.getNbGaps(), row, 1);

			// Nb of M7 heartbeat losses
			row++;
			statsTable.setValueAt("M7 heartbeat losses", row, 0);
			statsTable.setValueAt(nbOfM7HeartbeatLosses, row, 1);

			// Nb of AMQP connection losses
			row++;
			statsTable.setValueAt("AMQP connection losses", row, 0);
			statsTable.setValueAt(nbOfM7HeartbeatLosses, row, 1);

			// Last interval beween 2 M7 heartbeats
			row++;
			statsTable.setValueAt("Interval beween 2 M7 heartbeats", row, 0);
			statsTable.setValueAt(m7HeartbeatDifferenceString, row, 1);

			// nb of empty order books
			row++;
			statsTable.setValueAt("Nb of empty obks", row, 0);
			int nbEmptyObk = orderBooksList.nbTradableOrderBooks;
			int nbEmptyTradableObk = orderBooksList.nbEmptyTradableOrderBooks;
			float ratioEmptyObk;
			if (nbEmptyObk>0) ratioEmptyObk = ((float) nbEmptyTradableObk / (float) nbEmptyObk) * 100;
			else ratioEmptyObk = 0;

			statsTable.setValueAt(nbEmptyTradableObk + " / " + nbEmptyObk + " (" + String.format("%.0f%%", ratioEmptyObk) + ")", row,	1);

			// nb of submitted orders to fill in empty order books
			row++;
			statsTable.setValueAt("Nb of orders sent to fill obk", row, 0);
			statsTable.setValueAt(orderNbFillOBK, row, 1);

			// nb of ErrResp (most likely due to order actions)
			row++;
			statsTable.setValueAt("Nb of Error Responses", row, 0);
			statsTable.setValueAt(nbErrResp, row, 1);

			// update Stats file
			UpdateStatsFile(statsTime, UserOrderEventsNbM7, (int) projectionUserOrderEventsTotal,
					UserOrderEventsNbLocal, (int) projectionUserOrderEventsLocal, UserOrderEventsNbRemote,
					(int) projectionUserOrderEventsRemote);

			if (adminRetrieveOrdersPastDaysShift == 0)
				loadChart.repaint();
		} else {
			msg = "ERROR : elapsedSec ZERO OR NEGATIVE = " + elapsedSec + " applicationStartNanoTime = "
					+ applicationStartNanoTime;
			appLog.logger.warning(sdf.format(new Date()) + msg);
			// .AddText(msg);
			Globals.guiWindowDebug.AddText(msg);
		}
	}

	// ***************************************************
	// *** parseContractInfoReport
	// ***************************************************
	public void parseContractInfoReport(AMQPMessage message, GUIWindow guiWindow) throws Exception {
		long start_time = System.nanoTime();

		appLog.logger.info(sdf.format(new Date()) + "ms " + message.xmlMessagePayload);
		guiWindow.AddText(message.xmlMessagePayload);

		contractInfoReportOnGoingProcessing = true;

		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeContractList = document.getElementsByTagName("Contract");
				guiWindow.AddText(" nb contracts in XML message = " + nodeContractList.getLength());

				// if there are contract nodes
				if (nodeContractList != null && nodeContractList.getLength() > 0) {
					// for each Contract node
					for (int contractItr = 0; contractItr < nodeContractList.getLength(); contractItr++) {
						Node node = nodeContractList.item(contractItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;
							Contract currentContract = new Contract();

							NamedNodeMap nodeMap = eElement.getAttributes();
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();

								if (nodeName.contentEquals("contractId")) {
									currentContract.setContractId(nodeValue);
								}
								if (nodeName.contentEquals("prod")) {
									currentContract.setProd(nodeValue);
								}
								if (nodeName.contentEquals("name")) {
									currentContract.setName(nodeValue);
									appLog.logger
											.fine(sdf.format(new Date()) + "ms " + " =======>  contract " + nodeValue);
								}
								if (nodeName.contentEquals("longName")) {
									currentContract.setLongName(nodeValue);
								}
								if (nodeName.contentEquals("dlvryStart")) {
									currentContract.setDlvryStart(nodeValue);
								}
								if (nodeName.contentEquals("dlvryEnd")) {
									currentContract.setDlvryEnd(nodeValue);
								}
								if (nodeName.contentEquals("predefined")) {
									currentContract.setPredefined(nodeValue);
								}
								if (nodeName.contentEquals("revisionNo")) {
									currentContract.setRevisionNo(nodeValue);
								}
								if (nodeName.contentEquals("state")) {
									currentContract.setState(nodeValue);
								}
								if (nodeName.contentEquals("tradingPhase")) {
									currentContract.setTradingPhase(nodeValue);
								}
								if (nodeName.contentEquals("duration")) {
									currentContract.setDuration(nodeValue);
								}
								if (nodeName.contentEquals("actPoint")) {
									currentContract.setActPoint(nodeValue);
								}
								if (nodeName.contentEquals("expPoint")) {
									currentContract.setExpPoint(nodeValue);
								}
								if (nodeName.contentEquals("delUnits")) {
									currentContract.setDelUnits(nodeValue);
								}
							}

							// go through potential Delivery Areas
							NodeList nodeListArea = eElement.getElementsByTagName("DlvryAreaState");
							// guiWindow.AddText("nodeList DlvryAreaState=" + nodeListArea.toString() + " nb
							// Areas in contract node= " + nodeListArea.getLength());
							// appLog.logger.info(sdf.format(new Date()) + "ms "+"nodeList DlvryAreaState="
							// + nodeListArea.toString() + " nb Areas in contract node= " +
							// nodeListArea.getLength() );

							List<DeliveryArea> contractDeliveryAreaList = new ArrayList<DeliveryArea>();
							// for each DlvryAreaState node
							for (int areaItr = 0; areaItr < nodeListArea.getLength(); areaItr++) {
								Node nodeArea = nodeListArea.item(areaItr);

								Element eElementArea = (Element) nodeArea;
								DeliveryArea currentArea = new DeliveryArea();

								NamedNodeMap nodeMapArea = eElementArea.getAttributes();
								for (int areaAttributeNo = 0; areaAttributeNo < nodeMapArea
										.getLength(); areaAttributeNo++) {
									Node nodeAreaItem = nodeMapArea.item(areaAttributeNo);
									String nodeName = nodeAreaItem.getNodeName();
									String nodeValue = nodeAreaItem.getNodeValue();

									if (nodeName.contentEquals("dlvryAreaId")) {
										currentArea.dlvryAreaId = nodeValue;
										if (deliveryAreaList != null) {
											currentArea.dlvryAreaName = deliveryAreaList
													.GetAreaDetailsFromId(currentArea.dlvryAreaId).dlvryAreaName;
											currentArea.dlvryAreaLongName = deliveryAreaList
													.GetAreaDetailsFromId(currentArea.dlvryAreaId).dlvryAreaLongName;
										} else {
											msg = "Contract Info Report ERROR : deliveryAreaList is null";
											appLog.logger.severe(msg);
											JOptionPane.showMessageDialog(controlBoardFrame, msg);
										}

									}
									if (nodeName.contentEquals("state")) {
										currentArea.state = nodeValue;
									}
									if (nodeName.contentEquals("remoteState")) {
										currentArea.remoteState = nodeValue;
									}
									if (nodeName.contentEquals("tradingPhase")) {
										currentArea.tradingPhase = nodeValue;
									}
									if (nodeName.contentEquals("tradingPhaseStart")) {
										currentArea.tradingPhaseStart = nodeValue;
									}
									if (nodeName.contentEquals("tradingPhaseEnd")) {
										currentArea.tradingPhaseEnd = nodeValue;
									}
									if (nodeName.contentEquals("revisionNo")) {
										currentArea.revisionNo = nodeValue;
									}
								}
								// area completely parsed : added to the list of areas of the current contract
								contractDeliveryAreaList.add(currentArea);
								currentContract.setDeliveryAreaNb(currentContract.getDeliveryAreaNb() + 1);
								currentContract.setDeliveryAreaList(contractDeliveryAreaList);
							}
							contractList.UpdateContractList(currentContract, orderBooksList);

						}
					}
					// wait for the entire message to be parsed before updating the GUI table
					contractList.updateGUITable(controlBoardFrame.contract_GUI_Panel);
					contractInfoReportOnGoingProcessing = false; // all initial contract ID are known now, other
																	// messages can be processed
				}

				// display the content of the built contractList
				// guiWindow.AddText(sdf.format(new Date()) + "ms "+contractList.toString());

				// appLog.logger.info(sdf.format(new Date()) + "ms "+contractList.toString());
				// contractList.WriteCSVFileContractList();

			} catch (SAXException | IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Globals.guiWindowDebug.AddText(e.toString());
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}

		long end_time = System.nanoTime();
		double difference = (end_time - start_time) / 1e6;
		appLog.logger.info(
				sdf.format(new Date()) + "ms " + "*** end of Contract Info Report parsing: took " + difference + " ms");
		guiWindow.AddText("*** end of Contract Info Report parsing and processing: took " + (int) difference + " ms");

		// export all contract info in a CSV file
		contractList.WriteCSVFileContractList();

		// pick up a random tradable contract
		// contractList.FindATradableContractAreaForAProduct("Intraday_Hour_Power",
		// "10YDE-RWENET---I",guiWindow, appLog, false);
//		Contract tradableContract = new Contract();

		// pick up a random tradable contract and area combination
//		tradableContract = contractList.pickUp_Tradable_Contract(controlBoardFrame);
//		tradableContractId = tradableContract.getContractId();
//		String tradableContractInfo = "Contract nb = " + contractList.nbContracts + " FindATradableContractArea for "
//				+ tradableContract.getProd() + ", " + tradableContract.getChosenAreaToTrade() + " contract Id = "
//				+ tradableContract.getContractId() + " : name = " + tradableContract.getName();
//		// controlBoardFrame.textAreaContracts.append(sdf.format(new Date()) + "ms: " +
//		// tradableContractInfo+"\n");
//		controlBoardFrame.contract_GUI_Panel.commentText.setText(tradableContractInfo);
//		appLog.logger.info(tradableContractInfo);
	}

	// ***************************************************
	// *** Update Order Books List
	// *** called when receiving a Public Order Books Response or a Public Order
	// Books Delta Report broadcast
	// ***************************************************
	public void parseOrderBookMessage(String response_OR_broadcast, AMQPMessage message, OrderBooksList orderBooksList) {

		appLog.logger.info("Obk msg: calls updateOrderBooksList"); // + message.xmlMessagePayload);

		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeOrderBook = document.getElementsByTagName("OrdrBook");

				// if there are obk nodes
				// appLog.logger.info("nb order books in the OrdrBook node = "+
				// nodeOrderBook.getLength());
				if (nodeOrderBook != null && nodeOrderBook.getLength() > 0) {
					// for each OrdrBook node (obk "header")
					for (int ObkItr = 0; ObkItr < nodeOrderBook.getLength(); ObkItr++) {
						Node nodeObk = nodeOrderBook.item(ObkItr);

						if (nodeObk.getNodeType() == Node.ELEMENT_NODE) {
							Element eElementObk = (Element) nodeObk;
							OrderBook orderBook = new OrderBook();

							NamedNodeMap nodeMap = eElementObk.getAttributes();
							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {

								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();
								if (nodeName.contentEquals("contractId")) {
									orderBook.setContractId(nodeValue);
								}
								if (nodeName.contentEquals("dlvryAreaId")) {
									orderBook.setDlvryAreaId(nodeValue);
								}
								if (nodeName.contentEquals("revisionNo")) {
									orderBook.setRevisionNo(nodeValue);
								}
								if (nodeName.contentEquals("lastPx")) {
									orderBook.setLastPx(Float.valueOf(nodeValue) / 100);
								}
								if (nodeName.contentEquals("lastQty")) {
									orderBook.setLastQty(Float.valueOf(nodeValue) / 1000);
								}
								if (nodeName.contentEquals("totalQty")) {
									orderBook.setTotalQty(Float.valueOf(nodeValue) / 100);
								}
								if (nodeName.contentEquals("lastTradeTime")) {
									orderBook.setLastTradeTime(nodeValue);
								}
								if (nodeName.contentEquals("highPx")) {
									orderBook.setHighPx(nodeValue);
								}
								if (nodeName.contentEquals("lowPx")) {
									orderBook.setLowPx(nodeValue);
								}

							}

							appLog.logger.fine("parseOrderBookMessage: contract Id = " + orderBook.getContractId() + " area = " + orderBook.getDlvryAreaId()+  " name ="+ orderBook.getContractID_Name());
							// now determine orders stats : best bid/ask, nb of orders etc.
							float f_currentObk_BestBid ;
							float f_currentObk_BestAsk ;

							// for each order book count in nbActiveObkEntries how many active orders are in
							// the obk (qty = 0 means the order exits the obk - because hibernated, deleted,
							// or full matched - qty>0 means an entry in the order book - can be either a
							// new order or a modified order)
							int nbActiveObkEntries = 0;
							
							NodeList nodeList_BuyOrdrList = eElementObk.getElementsByTagName("BuyOrdrList");
							
							// if there is any order on buy side
						if (nodeList_BuyOrdrList != null && nodeList_BuyOrdrList.getLength() > 0) {
							appLog.logger.fine("BuyOrdrList found");
							
							for (int buyItr = 0; buyItr < nodeList_BuyOrdrList.getLength(); buyItr++) {
								Node nodeOrder_BuyOrdrList = nodeList_BuyOrdrList.item(buyItr);

								Element eElement_BuyOrdrList = (Element) nodeOrder_BuyOrdrList;
							
									NodeList nodeList_orderBookEntry = eElement_BuyOrdrList.getElementsByTagName("OrdrBookEntry");
							
									// LinkedList<Order> ordersList = new LinkedList<>();
		
									// for each OrdrBookEntry node (obk "body" part with orders : order ID, qty,
									// price, order entry time
								if (nodeList_orderBookEntry != null && nodeList_orderBookEntry.getLength() > 0) {
									// for each order book entry (for each order)
									for (int orderItr = 0; orderItr < nodeList_orderBookEntry.getLength(); orderItr++) {
										Node nodeOrderBookEntry = nodeList_orderBookEntry.item(orderItr);
		
										Element eElementOBkEnrty = (Element) nodeOrderBookEntry;
										OrderBookEntry currentObkEntry = new OrderBookEntry();
		
										NamedNodeMap nodeMapObkEntry = eElementOBkEnrty.getAttributes();
										for (int obkEntryAttributeNo = 0; obkEntryAttributeNo < nodeMapObkEntry
												.getLength(); obkEntryAttributeNo++) {
											Node nodeObkEntryItem = nodeMapObkEntry.item(obkEntryAttributeNo);
											String nodeName = nodeObkEntryItem.getNodeName();
											String nodeValue = nodeObkEntryItem.getNodeValue();
		
											if (nodeName.contentEquals("ordrId")) {
												currentObkEntry.setOrdrId(nodeValue);
											}
											if (nodeName.contentEquals("qty")) {
												currentObkEntry.setQty(nodeValue);
											}
											if (nodeName.contentEquals("px")) {
												currentObkEntry.setPx(nodeValue);
											}
											if (nodeName.contentEquals("ordrEntryTime")) {
												currentObkEntry.setOrdrEntryTime(nodeValue);
											}
										}
										appLog.logger.fine("currentObkEntry:" + " price = " + currentObkEntry.getPx() + " qty = " + currentObkEntry.getQty());
		
										// only count order with a >0 quantity (zero qty means the order exited the
										// order book)
										if (currentObkEntry.getQty().contentEquals("0"))
											nbActiveObkEntries--;
										else
											nbActiveObkEntries++;
										
										 if (currentObkEntry.getPx() != null && !"".contentEquals(currentObkEntry.getPx())) {
											 // check if current order should become the best bid 
											 if (!"0".contains(currentObkEntry.getQty())) { // if order qty != 0)	
												 OrderBook obkInfo = new OrderBook();
												 obkInfo = orderBooksList.FindObkDetails(orderBook.getContractId(), orderBook.getDlvryAreaId());
												 float previousBestBid = obkInfo.getfBestBid() ;
												 float potentialNewBestBid = Float.valueOf(currentObkEntry.getPx()) /100;
												 
												 appLog.logger.fine("previousBestBid = " + previousBestBid + " potentialNewBestBid = " + potentialNewBestBid);
												 
												 if ( (potentialNewBestBid < previousBestBid) || "".contentEquals(obkInfo.getsBestBid()) ) { // if never initialize : the 1st bid is the best one
													
													 f_currentObk_BestBid = potentialNewBestBid;
													 orderBook.setfBestBid(f_currentObk_BestBid );
													 orderBook.setsBestBid(Float.toString(f_currentObk_BestBid));
													 appLog.logger.fine("new best Bid = " + potentialNewBestBid);
												 }
											 }
										 }
									}
								} // end of order entries processing
							}  // if there are orders entry nodes
						} // end of buy side
						
					NodeList nodeList_SellOrdrList = eElementObk.getElementsByTagName("SellOrdrList");
						
						// if there is any order on Sell side
					if (nodeList_SellOrdrList != null && nodeList_SellOrdrList.getLength() > 0) {
						appLog.logger.fine("SellOrdrList found");
						
						for (int SellItr = 0; SellItr < nodeList_SellOrdrList.getLength(); SellItr++) {
							Node nodeOrder_SellOrdrList = nodeList_SellOrdrList.item(SellItr);

							Element eElement_SellOrdrList = (Element) nodeOrder_SellOrdrList;
						
								NodeList nodeList_orderBookEntry = eElement_SellOrdrList.getElementsByTagName("OrdrBookEntry");
						
								// LinkedList<Order> ordersList = new LinkedList<>();
	
								// for each OrdrBookEntry node (obk "body" part with orders : order ID, qty,
								// price, order entry time
							if (nodeList_orderBookEntry != null && nodeList_orderBookEntry.getLength() > 0) {
								appLog.logger.fine("OrdrBookEntry found");
								
								for (int orderItr = 0; orderItr < nodeList_orderBookEntry.getLength(); orderItr++) {
									Node nodeOrderBookEntry = nodeList_orderBookEntry.item(orderItr);
	
									Element eElementOBkEnrty = (Element) nodeOrderBookEntry;
									OrderBookEntry currentObkEntry = new OrderBookEntry();
	
									NamedNodeMap nodeMapObkEntry = eElementOBkEnrty.getAttributes();
									for (int obkEntryAttributeNo = 0; obkEntryAttributeNo < nodeMapObkEntry
											.getLength(); obkEntryAttributeNo++) {
										Node nodeObkEntryItem = nodeMapObkEntry.item(obkEntryAttributeNo);
										String nodeName = nodeObkEntryItem.getNodeName();
										String nodeValue = nodeObkEntryItem.getNodeValue();
	
										if (nodeName.contentEquals("ordrId")) {
											currentObkEntry.setOrdrId(nodeValue);
										}
										if (nodeName.contentEquals("qty")) {
											currentObkEntry.setQty(nodeValue);
										}
										if (nodeName.contentEquals("px")) {
											currentObkEntry.setPx(nodeValue);
										}
										if (nodeName.contentEquals("ordrEntryTime")) {
											currentObkEntry.setOrdrEntryTime(nodeValue);
										}
									}
									appLog.logger.fine("currentObkEntry:" + " price = " + currentObkEntry.getPx() + " qty = " + currentObkEntry.getQty());
	
									// only count order with a >0 quantity (zero qty means the order exited the
									// order book)
									if (currentObkEntry.getQty().contentEquals("0"))
										nbActiveObkEntries--;
									else
										nbActiveObkEntries++;
									
									 if (currentObkEntry.getPx() != null && !"".contentEquals(currentObkEntry.getPx())) {
										 // check if current order should become the best bid 
										 if (!"0".contains(currentObkEntry.getQty())) { // if order qty != 0)	
											 OrderBook obkInfo = new OrderBook();
											 obkInfo = orderBooksList.FindObkDetails(orderBook.getContractId(), orderBook.getDlvryAreaId());
											 float previousBestAsk = obkInfo.getfBestAsk() ;
											 float potentialNewBestAsk = Float.valueOf(currentObkEntry.getPx()) /100;
											 
											 appLog.logger.fine("previousBestAsk = " + previousBestAsk + " potentialNewBestAsk = " + potentialNewBestAsk);
											 
											 if ( (potentialNewBestAsk < previousBestAsk) || "".contentEquals(obkInfo.getsBestBid() )) { // if never initialize : the 1st bid is the best one
												
												 f_currentObk_BestAsk = potentialNewBestAsk;
												 orderBook.setfBestAsk(f_currentObk_BestAsk );
												 orderBook.setsBestAsk(Float.toString(f_currentObk_BestAsk));
												 appLog.logger.fine("new best Ask = " + potentialNewBestAsk);
											 }
										 }
									 }
											 
								}
							} // end of order entries processing
						}  // if there are orders entry nodes
					} // end of sell side

							// for each orderBook node
							try {
								if (response_OR_broadcast.contentEquals("RESPONSE")) {
								
									orderBooksList.UpdateOrderBooksList( orderBook.getContractId(), orderBook.getDlvryAreaId(),
											  orderBook.getRevisionNo(), 
											  orderBook.getfBestBid(), orderBook.getfBestAsk(),
											  orderBook.getLastPx(), orderBook.getLastQty(),
											  orderBook.getTotalQty(), orderBook.getLastTradeTime(), orderBook.getLowPx(),
											  orderBook.getHighPx(), orderBook.getSpread(),
											  orderBook.getDepthAsk_NbOrders(), orderBook.getDepthBid_NbOrders(),
											  nbActiveObkEntries, contractList, appLog);
								}
								else {
									appLog.logger.fine("UpdateOrderBooksList call: " + orderBook.getContractId() + " name ="+ orderBook.getContractID_Name());
									Runnable r2 = new ThreadUpdateOrderBooksList(controlBoardFrame,
											controlBoardFrame.orderBooks_GUI_Panel, orderBooksList, deliveryAreaList,
											orderBook.getContractId(), orderBook.getDlvryAreaId(),
											orderBook.getRevisionNo(), 
											orderBook.getfBestBid(), orderBook.getfBestAsk(),
											orderBook.getsBestBid(), orderBook.getsBestAsk(),
											orderBook.getLastPx(), orderBook.getLastQty(),
											orderBook.getTotalQty(), orderBook.getLastTradeTime(), orderBook.getLowPx(),
											orderBook.getHighPx(), orderBook.getSpread(), orderBook.getDepthAsk_NbOrders(),
											orderBook.getDepthBid_NbOrders(), nbActiveObkEntries, contractList, appLog);
									Thread t2 = new Thread(r2);
									t2.start();		
									
//									Runnable r3 = new ThreadUpdateOrderBooksGUI(orderBooksList, controlBoardFrame.orderBooks_GUI_Panel);
//									Thread t3 = new Thread(r3);
//									t3.start();	
								}
								 							
							} catch (Exception e) {
								msg = "error in updateOrderBooksList: " + e.toString();
								appLog.logger.severe(msg);
								Globals.guiWindowDebug.AddText(msg);
								//JOptionPane.showMessageDialog(controlBoardFrame, msg);
							}
						} // if (nodeObk.getNodeType() == Node.ELEMENT_NODE)
					}
				}
				try {
					 //if (fillEmptyOrderBooks.contentEquals("false")) 
					orderBooksList.WriteOrderBooksListCSVFile(); 
				} catch (Exception e) {
					e.printStackTrace();
					msg = "catch error writing order Books List: " + e.toString();
					appLog.logger.info(msg);
					Globals.guiWindowDebug.AddText(e.toString());
					// JOptionPane.showMessageDialog(controlBoardFrame, msg);
				}

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				msg = "error in parseOrderBookMessage: " + e.toString();
				appLog.logger.severe(msg);
				JOptionPane.showMessageDialog(controlBoardFrame, msg);
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}
	}

	// ***************************************************
	// *** Update Member List
	// ***************************************************
	public void createMembersList(AMQPMessage message, MembersList membersList) {

		appLog.logger.info(sdf.format(new Date()) + "ms " + "createMembersList" + message.xmlMessagePayload);
		allMembersRespOnGoingProcessing = true;
		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeMember = document.getElementsByTagName("Mbr");

				// if there are contract nodes
				appLog.logger.info("nb BG/member = " + nodeMember.getLength());
				if (nodeMember != null && nodeMember.getLength() > 0) {
					// for each Contract node
					for (int MemberItr = 0; MemberItr < nodeMember.getLength(); MemberItr++) {
						Node node = nodeMember.item(MemberItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;
							Member member = new Member();

							NamedNodeMap nodeMap = eElement.getAttributes();
							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();
								if (nodeName.contentEquals("mbrId")) {
									member.setMemberID(nodeValue);
								}
								if (nodeName.contentEquals("name")) {
									member.setMemberName(nodeValue);
								}
								if (nodeName.contentEquals("state")) {
									member.setMemberState(nodeValue);
								}
							}
							// appLog.logger.info("Couple found : BG = " + bgMember.getBG_AccountID() + "
							// Member ID = " + bgMember.getMemberID());

							int nbMembersList = membersList.AddMember(member.getMemberID(), member.getMemberName(),
									member.getMemberState(), appLog);
							// appLog.logger.info("Member added : list size =" + nbMembersList);
						}
					}
				}
				allMembersRespOnGoingProcessing = false;

			} catch (SAXException | IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				msg = "catch error : " + e.toString();
				appLog.logger.info(msg);
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}
	}

	// ***************************************************
	// *** Update BG Member List
	// ***************************************************
	public void createBGMemberList(AMQPMessage message, BG_Member_List bgMemberList) {

		appLog.logger.info(sdf.format(new Date()) + "ms " + "createBGMemberList" + message.xmlMessagePayload);
		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeBG = document.getElementsByTagName("Acct");

				// if there are BG nodes
				appLog.logger.info("nb BG/member = " + nodeBG.getLength());
				if (nodeBG != null && nodeBG.getLength() > 0) {
					// for each BG node
					for (int BGItr = 0; BGItr < nodeBG.getLength(); BGItr++) {
						Node node = nodeBG.item(BGItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;
							BG_Member bgMember = new BG_Member();

							NamedNodeMap nodeMap = eElement.getAttributes();
							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();
								if (nodeName.contentEquals("acctId")) {
									bgMember.BG_AccountID = nodeValue;
								}
								if (nodeName.contentEquals("name")) {
									bgMember.BG_Name = nodeValue;
								}
								if (nodeName.contentEquals("mbrId")) {
									bgMember.MemberID = nodeValue;
								}
								if (nodeName.contentEquals("preArrangedAvlbl")) {
									bgMember.preArranged_OTC = nodeValue;
								}
								if (nodeName.contentEquals("state")) {
									bgMember.state = nodeValue;
								}
							}
							
							NodeList nodeListAssignedAreas = eElement.getElementsByTagName("dlvryAreaId");

							// for each dlvryAreaId node
							for (int assignedAreas_Itr = 0; assignedAreas_Itr < nodeListAssignedAreas.getLength(); assignedAreas_Itr++) {
								Node nodeAssignedAreas = nodeListAssignedAreas.item(assignedAreas_Itr);

								Element eElementAssignedAreas = (Element) nodeAssignedAreas;

								String assigned_DA = eElementAssignedAreas.getFirstChild().getTextContent();
								DeliveryArea area = deliveryAreaList.GetAreaDetailsFromId(assigned_DA);
								bgMember.assigned_DeliveryAreas.add(area.dlvryAreaName);
								//appLog.logger.info("BG :" + bgMember.BG_AccountID + " : assigne DA : " + assigned_DA);
								}

							NodeList nodeListAssigned_Products = eElement.getElementsByTagName("prodName");

							// for each prodName node
							for (int assigned_Products_Itr = 0; assigned_Products_Itr < nodeListAssigned_Products.getLength(); assigned_Products_Itr++) {
								Node nodeAssignedProducts = nodeListAssigned_Products.item(assigned_Products_Itr);

								Element eElementAssignedProducts = (Element) nodeAssignedProducts;

								String assigned_Product = eElementAssignedProducts.getFirstChild().getTextContent();
								bgMember.assigned_Products.add(assigned_Product);
								//appLog.logger.info("BG :" + bgMember.BG_AccountID + " : assigne product : " + assigned_Product);
								}
							
							int nbBGList = bgMemberList.AddBGMember(bgMember, appLog);
							//appLog.logger.info("BG added : list size =" + nbBGList);
							// go through all assigned Account Ids (Balancing groups/portfolio)
						} // for each BG
					}

				}
				bgMemberList.WriteBGMemberListCSVFile();

			} catch (SAXException | IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				msg = "catch error : " + e.toString();
				appLog.logger.info(msg);
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}
	}


	// **************************************
	// parse User Report (when login is successfull)
	// **************************************
	public void parseUserRprt(AMQPMessage message) {


		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);
			
			// check if the user has the ADMIN_ROLE
			String s = message.xmlMessagePayload;
			if (s.indexOf("ROLE_ADMIN") > 0) {
				adminMode = true;
				windowOrderGenerationControl.setVisible(false);
			}
			controlBoardFrame.AddText("ADMIN Mode = " + adminMode, controlBoardFrame.textAreaConnection);
 
			// parse the message XML payload
			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeUserReport = document.getElementsByTagName("Usr");

				// if there is a Market node
				appLog.logger.info("nb DlvryAreas = " + nodeUserReport.getLength());
				if (nodeUserReport != null && nodeUserReport.getLength() > 0) {
					// for each Market state node (only 1)
					for (int UserReportItr = 0; UserReportItr < nodeUserReport.getLength(); UserReportItr++) {
						Node node = nodeUserReport.item(UserReportItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;

							// <Usr sessionId="1615536330410" mbrName="Test Member 001" usrId="1243"
							// revisionNo="11" name="Test Trader (Sales)" usrCode="TRD014" mbrId="TM001"
							// defaultAcctId="11XTM1-TM------3"
							// state="ACTI">
							// <AssgAcctId>11XTM1-TM------2</AssgAcctId><AssgAcctId>11XTM1-TM------3</AssgAcctId><AssgAcctId>11XTM2-TM------1</AssgAcctId>
							// <UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole>
							// </Usr>
							// </UserRprt>
							
							NamedNodeMap nodeMap = eElement.getAttributes();
							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();
								if (nodeName.contentEquals("sessionId")) {
									currentSessionId = nodeValue;
								}
								if (nodeName.contentEquals("mbrId")) {
									memberId = nodeValue;
								}
								if (nodeName.contentEquals("mbrName")) {
									memberName = nodeValue;
								}
								if (nodeName.contentEquals("defaultAcctId")) {
									userDefaultBalancingGroup = nodeValue;
								}
								if (nodeName.contentEquals("mbrName")) {
									userCode = nodeValue;
								}
								if (nodeName.contentEquals("usrId")) {
									userId = nodeValue;
								}
							}

							Globals.connectedUserName = userName;
							Globals.guiWindowDebug.AddText("userName = " + Globals.connectedUserName + " usrId = " + userId);
							controlBoardFrame.setTitle(controlBoardFrame.getTitle() + " userName = " + Globals.connectedUserName
									+ " usrId = " + userId);

							msg = userName + ": SUCCESSFULLY LOGGED IN M7 " + " Member ID = " + memberId + " Default BG = "
									+ userDefaultBalancingGroup + " user Id = " + userId + " SessionId=" + currentSessionId;
							controlBoardFrame.LoggedIn(msg);
							
						}
					}
				}

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				String error = "catching error :" + e.toString();
				Globals.guiWindowDebug.AddText(error);
				appLog.logger.severe(error);
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}

	}

	// **************************************
	// parse Market Info Report
	// **************************************
	public void parseMktStateRprt(AMQPMessage message) {

		String marketRevisionNo = "";
		String marketState = "";

		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeMarketState = document.getElementsByTagName("MktStateRprt");

				// if there is a Market node
				appLog.logger.info("nb DlvryAreas = " + nodeMarketState.getLength());
				if (nodeMarketState != null && nodeMarketState.getLength() > 0) {
					// for each Market state node (only 1)
					for (int AreaItr = 0; AreaItr < nodeMarketState.getLength(); AreaItr++) {
						Node node = nodeMarketState.item(AreaItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;

							NamedNodeMap nodeMap = eElement.getAttributes();
							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();
								if (nodeName.contentEquals("revisionNo")) {
									marketRevisionNo = nodeValue;
								}
								if (nodeName.contentEquals("state")) {
									marketState = nodeValue;
								}
							}
							Globals.marketState = marketState;
							controlBoardFrame.textField_MarketState.setText(Globals.marketState);
						}
					}
				}
				try {
				} catch (Exception e1) {
					Globals.guiWindowDebug.AddText("Cannot write Area list file.");
				}

			} catch (SAXException | IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}

	}

	// **************************************
	// parseAllUsersResp
	// **************************************
	public void parseAllUsersResp(AMQPMessage message) {

		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);
			
			appLog.logger.info(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeUser = document.getElementsByTagName("Usr");

				// if there are User nodes
				appLog.logger.info("nb users = " + nodeUser.getLength());
				if (nodeUser != null && nodeUser.getLength() > 0) {
					// for each User node
					for (int userItr = 0; userItr < nodeUser.getLength(); userItr++) {
						Node node = nodeUser.item(userItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;
							User currentUser = new User();

//							<AllUsersResp xmlns="http://www.deutsche-boerse.com/m7/v6">
//							<UsrList>
// 								<Usr usrId="379" revisionNo="9" name="test API trader" usrCode="TRD019" mbrId="TM002" 
//										defaultAcctId="11XTM2-TM------1" state="ACTI">
//									<AssgAcctId>11XTM2-TM------2</AssgAcctId>
//									<AssgAcctId>11XTM2-TM------1</AssgAcctId><AssgAcctId>TM002BG5------------------------</AssgAcctId><AssgAcctId>Test-UK-products</AssgAcctId>
//									<UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="380" revisionNo="1" name="Test User Florian 2" usrCode="TRD022" mbrId="TM002" defaultAcctId="TM002-DE-DAs----" state="ACTI"><AssgAcctId>TM002-DE-DAs----</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1250" revisionNo="3" name="Test User Krisztian" usrCode="TRD012" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><AssgAcctId>11XTM2-TM------1</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1251" revisionNo="3" name="JM User" usrCode="TRD013" mbrId="TM002" defaultAcctId="TM002other------" state="ACTI"><AssgAcctId>11XTM2-TM------1</AssgAcctId><AssgAcctId>TM002other------</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1252" revisionNo="3" name="Test User Sophie" usrCode="TRD014" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1253" revisionNo="15" name="Test User API Member Tests" usrCode="TRD015" mbrId="TM002" defaultAcctId="Test-UK-products" state="ACTI"><AssgAcctId>Test-UK-products</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1254" revisionNo="6" name="CXSIM205" usrCode="TRD016" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1255" revisionNo="5" name="Test User API 2 Member Tests" usrCode="TRD017" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole></Usr><Usr usrId="1256" revisionNo="14" name="JEAN-MARC Test user" usrCode="TRD018" mbrId="TM002" defaultAcctId="11XTM2-TM------1" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><AssgAcctId>11XTM2-TM------1</AssgAcctId><AssgAcctId>Test-UK-products</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole></Usr><Usr usrId="1257" revisionNo="1" name="Trayport User 1" usrCode="OBHTP1" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_READ_ONLY</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1258" revisionNo="1" name="Trayport User 2" usrCode="OBHTP2" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_READ_ONLY</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1259" revisionNo="6" name="Katja Test" usrCode="TRD020" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1260" revisionNo="6" name="Test User Florian" usrCode="TRD021" mbrId="TM002" defaultAcctId="11XTM2-TM------3" state="ACTI"><AssgAcctId>11XTM2-TM------3</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1261" revisionNo="1" name="Martina Trader user" usrCode="TRD023" mbrId="TM002" defaultAcctId="11XTM2-TM------1" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><AssgAcctId>11XTM2-TM------1</AssgAcctId><AssgAcctId>TM002BG5------------------------</AssgAcctId><AssgAcctId>11XTM2-TM-247--2</AssgAcctId><AssgAcctId>TM002other------</AssgAcctId><AssgAcctId>Test-UK-products</AssgAcctId><UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1712" revisionNo="1" name="Test 03" usrCode="TRD001" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole></Usr><Usr usrId="1798" revisionNo="2" name="Test User" usrCode="TRD002" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="1912" revisionNo="1" name="EPEX TEST USER BSA" usrCode="TRD004" mbrId="TM002" defaultAcctId="11XTM2-TM------2" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><UsrRole>ROLE_READ_ONLY</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr><Usr usrId="2490" revisionNo="2" name="CXSIM216 JM" usrCode="TRD005" mbrId="TM002" defaultAcctId="11XTM2-TM------1" state="ACTI"><AssgAcctId>11XTM2-TM------2</AssgAcctId><AssgAcctId>11XTM2-TM------1</AssgAcctId><AssgAcctId>Test-UK-products</AssgAcctId><UsrRole>ROLE_ON_BEHALF</UsrRole><UsrRole>ROLE_SYSTEM_ACCESS</UsrRole><UsrRole>ROLE_USER</UsrRole><UsrRole>ROLE_PUBLIC_API</UsrRole><UsrRole>ROLE_CAPACITY_INFO</UsrRole></Usr></UsrList></AllUsersResp>
							
							NamedNodeMap nodeMap = eElement.getAttributes();

							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
									String nodeName = node2.getNodeName();
									String nodeValue = node2.getNodeValue();
									
									if ("usrId".contentEquals(nodeName)) {
										currentUser.userId = nodeValue;
									}
									if ("loginId".contentEquals(nodeName)) {
										currentUser.loginId = nodeValue;
									}									
									if ("revisionNo".contentEquals(nodeName)) {
										currentUser.revisionNo = nodeValue;
									}
									if ("name".contentEquals(nodeName)) {
										currentUser.userName = nodeValue;
									}
									if ("usrCode".contentEquals(nodeName)) {
										currentUser.usrCode = nodeValue;
									}
									if ("mbrId".contentEquals(nodeName)) {
										currentUser.mbrId = nodeValue;
									}									
									if ("defaultAcctId".contentEquals(nodeName)) {
										currentUser.defaultBG = nodeValue;
									}
									if ("state".contentEquals(nodeName)) {
										currentUser.state = nodeValue;
									}
									// only for admins: 
									if ("mailAddress".contentEquals(nodeName)) {
										currentUser.mailAddress = nodeValue;
									}
							}								
							Member memberUser = new Member(); 
							memberUser = membersList.ReturnMemberInfo(currentUser.mbrId, appLog);
							currentUser.mbrName = memberUser.getMemberName();
							
								// go through all assigned Account Ids (Balancing groups/portfolio)
								NodeList nodeListAssignedBG = eElement.getElementsByTagName("AssgAcctId");

								// for each DlvryAssignedBGState node
								for (int assignedBGItr = 0; assignedBGItr < nodeListAssignedBG.getLength(); assignedBGItr++) {
									Node nodeAssignedBG = nodeListAssignedBG.item(assignedBGItr);

									Element eElementAssignedBG = (Element) nodeAssignedBG;

									String accountID = eElementAssignedBG.getFirstChild().getTextContent();
									currentUser.assignedBGList.add(accountID);
									}

								// go through all User Roles
								NodeList nodeListUsrRole = eElement.getElementsByTagName("UsrRole");

								// for each DlvryAssignedBGState node
								for (int UsrRoleItr = 0; UsrRoleItr < nodeListUsrRole.getLength(); UsrRoleItr++) {
									Node nodeUsrRole = nodeListUsrRole.item(UsrRoleItr);

									Element eElementUserRole = (Element) nodeUsrRole;

									String userRole = eElementUserRole.getFirstChild().getTextContent();
									currentUser.userRoles.add(userRole);
									}
							
							usersList.AddUser(currentUser);
						}
					}
				}
				try {
					usersList.WriteCSVFile();
				} catch (Exception e1) {
					Globals.guiWindowDebug.AddText("Cannot write Area list file.");
				}

			} catch (SAXException | IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}

	}
	// **************************************
	// parseAreaInfoReport
	// **************************************
	public void parseAreaInfoReport(AMQPMessage message, DeliveryAreaList deliveryAreaList) {

		AreaInfoReportOnGoingProcessing = true;

		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeArea = document.getElementsByTagName("DlvryArea");

				// if there are Area nodes
				appLog.logger.info("nb DlvryAreas = " + nodeArea.getLength());
				if (nodeArea != null && nodeArea.getLength() > 0) {
					// for each Contract node
					for (int AreaItr = 0; AreaItr < nodeArea.getLength(); AreaItr++) {
						Node node = nodeArea.item(AreaItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;
							DeliveryArea deliveryArea = new DeliveryArea();

							NamedNodeMap nodeMap = eElement.getAttributes();
							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();
								if (nodeName.contentEquals("revisionNo")) {
									deliveryArea.revisionNo = nodeValue;
								}
								if (nodeName.contentEquals("remoteState")) {
									deliveryArea.remoteState = nodeValue;
								}
								if (nodeName.contentEquals("name")) {
									deliveryArea.dlvryAreaName = nodeValue;
								}
								if (nodeName.contentEquals("longName")) {
									deliveryArea.dlvryAreaLongName = nodeValue;
								}
								if (nodeName.contentEquals("mktAreaId")) {
									deliveryArea.mktAreaId = nodeValue;
								}
								if (nodeName.contentEquals("dlvryAreaId")) {
									deliveryArea.dlvryAreaId = nodeValue;
								}
								if (nodeName.contentEquals("state")) {
									deliveryArea.state = nodeValue;
								}
							}
							deliveryAreaList.AddDeliveryArea(deliveryArea);
						}
					}
				}
				AreaInfoReportOnGoingProcessing = false;
				try {
					deliveryAreaList.WriteCSVFile();
				} catch (Exception e1) {
					Globals.guiWindowDebug.AddText("Cannot write Area list file.");
				}

			} catch (SAXException | IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}

	}

	// **************************************
	// parseProductInfoReport
	// **************************************
	public void parseProductInfoReport(AMQPMessage message, ProductList productList) {

		// parse the XML message
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			try {

				document = builder.parse(input);
				document.getDocumentElement().normalize();

				// Extract the root element
				// Element root = document.getDocumentElement();

				NodeList nodeProduct = document.getElementsByTagName("Prod");

				// if there are Product nodes
				appLog.logger.info("nb Products = " + nodeProduct.getLength());
				if (nodeProduct != null && nodeProduct.getLength() > 0) {
					// for each Product node
					for (int productItr = 0; productItr < nodeProduct.getLength(); productItr++) {
						Node node = nodeProduct.item(productItr);

						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element eElement = (Element) node;
							Product product = new Product();

							NamedNodeMap nodeMap = eElement.getAttributes();
							// go through all attributes of the Account record
							for (int i = 0; i < nodeMap.getLength(); i++) {
								Node node2 = nodeMap.item(i);
								String nodeName = node2.getNodeName();
								String nodeValue = node2.getNodeValue();

									/*	 minQty="100" maxQty="999000" maxAmount="0" lotSize="100"
										 decShftQty="3" qtyUnit="MW" delUnits="0.25"
										 minPx="-999900" maxPx="999900" tickSize="1" 
										 decShftPx="2" exchangeId="EPEX" executionRestriction="NON" */
							      
								if (nodeName.contentEquals("prodName")) {
									product.name = nodeValue;
								}
								if (nodeName.contentEquals("state")) {
									product.state = nodeValue;
								}
								if (nodeName.contentEquals("prodType")) {
									product.type = nodeValue;
								}
								if (nodeName.contentEquals("minPx")) {
									product.minPx = nodeValue;
								}
								if (nodeName.contentEquals("maxPx")) {
									product.maxPx = nodeValue;
								}
								if (nodeName.contentEquals("minQty")) {
									product.minQty = nodeValue;
								}
								if (nodeName.contentEquals("maxQty")) {
									product.maxQty = nodeValue;
								}
								if (nodeName.contentEquals("currency")) {
									product.currency = nodeValue;
								}
								if (nodeName.contentEquals("timeZone")) {
									product.timeZone = nodeValue;
								}
							}
							productList.UpdateProduct(product);
						}
					}
				}
				try {
					//product.WriteCSVFile();
				} catch (Exception e1) {
					Globals.guiWindowDebug.AddText("Cannot write Products list file.");
				}

			} catch (SAXException | IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} catch (ParserConfigurationException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			msg = "ParserConfigurationException | UnsupportedEncodingException exception: " + e;
			appLog.logger.info(msg);
		}

	}


	// **************************************
	// countOMTOrderExeReport
	// **************************************
	public int countOMTOrderExeReport(AMQPMessage message, OrdersList ordersList) throws IOException {

		/*
		 * <OrdrExeRprt xmlns="http://www.deutsche-boerse.com/m7/v6"> <StandardHeader
		 * marketId="EPEX"/> <OrdrList> <Ordr ordrId="292075615"
		 * initialOrdrId="292075615" clearingAcctType="P" acctId="11XTM2-TM------1"
		 * contractId="895501" side="SELL" px="2300" qty="136000" initialQty="136000"
		 * ordrExeRestriction="NON" txt="" dlvryAreaId="10YDE-ENBW-----N"
		 * clOrdrId="85338cc8-e70b-4e41-b72e-16a23dade2e4" preArranged="false" type="O"
		 * state="ACTI" usrCode="TRD018" revisionNo="1"
		 * timestmp="2021-12-15T19:49:32.208Z" validityDate="2021-12-15T19:55:00.000Z"
		 * validityRes="GFS" action="UADD" lastUpdateUsrInfo="11XTM2-TM------1TRD018"
		 * counterOrder="false" lastUpdateTm="2021-12-15T19:49:32.208Z" aot="false"/>
		 * </OrdrList> </OrdrExeRprt>
		 */

		msg = null;
		int nbOfOrderNodes = 0;
		long start_time = System.nanoTime();

		msg = "Starting to process FullOrdrCaptureResp";
		appLog.logger.info(msg);
		// guiWindowMsgReport.AddText(msg);
		controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);

		// parse the XML message to count local and XBID/remote orders
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;

		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			document = builder.parse(input);
			document.getDocumentElement().normalize();

			NodeList nodeOrderList = document.getElementsByTagName("Ordr");

			/*
			 * msg = System.nanoTime() + " Starting to count OMTs"; System.out.println(msg);
			 * guiWindowMsgReport.AddText(msg);
			 */
			// update the count that corresponds to the correlation ID
			nbOfOrderNodes = nodeOrderList.getLength();
			/*
			 * msg = "nbOfOrderNodes = "+ nbOfOrderNodes; System.out.println(msg);
			 * guiWindowMsgReport.AddText(msg);
			 */

			msg = "*** end of Order Exe Report parsing: COUNT took " + ((System.nanoTime() - start_time) / 1e6) + " ms";
			appLog.logger.info(msg);
			// Globals.guiWindowDebug.AddText(msg);

		} catch (ParserConfigurationException | SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			Globals.guiWindowDebug.AddText(e.toString());
		}
		return nbOfOrderNodes;
	}

	// **************************************
	// parseOrderExeReport
	// **************************************
	public int parseOrderExeReport(AMQPMessage message, OrdersList ordersList, boolean bUpdateGUI) throws Exception {
		/*
		 * <OrdrExeRprt xmlns="http://www.deutsche-boerse.com/m7/v6"> <StandardHeader
		 * marketId="EPEX"/> <OrdrList> <Ordr ordrId="292075615"
		 * initialOrdrId="292075615" clearingAcctType="P" acctId="11XTM2-TM------1"
		 * contractId="895501" side="SELL" px="2300" qty="136000" initialQty="136000"
		 * ordrExeRestriction="NON" txt="" dlvryAreaId="10YDE-ENBW-----N"
		 * clOrdrId="85338cc8-e70b-4e41-b72e-16a23dade2e4" preArranged="false" type="O"
		 * state="ACTI" usrCode="TRD018" revisionNo="1"
		 * timestmp="2021-12-15T19:49:32.208Z" validityDate="2021-12-15T19:55:00.000Z"
		 * validityRes="GFS" action="UADD" lastUpdateUsrInfo="11XTM2-TM------1TRD018"
		 * counterOrder="false" lastUpdateTm="2021-12-15T19:49:32.208Z" aot="false"/>
		 * </OrdrList> </OrdrExeRprt>
		 */

		msg = null;
		int nbOMTInMessage = 0;
		long message_processing_start_time = System.nanoTime();

		Globals.guiWindowDebug.AddText(message.xmlMessagePayload);

		// parse the XML message to count local and XBID/remote orders
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;

		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			// extract the server-timestamp
			// #contentHeader<basic>(content-type=x-m7/response; version=6.0,
			// content-encoding=gzip, headers={server-timestamp=1640542630753}, ...
			String s = message.amqpProperties;
			String prefix = "server-timestamp=";
			s = s.substring(s.indexOf(prefix) + prefix.length());
			String[] result = s.split("}");
			long messageServerTimestamp_Long = Long.parseLong(result[0]);
			String messageServerTimestamp_String = sdfStatsWithDash.format(new Date(messageServerTimestamp_Long));

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			document = builder.parse(input);
			document.getDocumentElement().normalize();

			NodeList nodeOrderList = document.getElementsByTagName("Ordr");

			int nbOrderNodesInMessage = nodeOrderList.getLength();
			// totalOMTcount_approximation_DayD = nbOrderNodesInMessage;

			// if there are Order nodes
			if (nbOrderNodesInMessage > 0) {

				Node node;
				// for each Order node
				/*
				 * for (int orderItr = 0; orderItr < nbOrderNodesInMessage; orderItr++) {
				 * Globals.guiWindowDebug.AddText("***    1st loop orderItr =" + orderItr);
				 * 
				 * node = nodeOrderList.item(orderItr); if (node.getNodeType() ==
				 * Node.ELEMENT_NODE) { Element eElement = (Element) node; NamedNodeMap nodeMap
				 * = eElement.getAttributes(); // go through each attribute of the order node
				 * and extract values from relevant attributes for current order node for (int i
				 * = 0; i < nodeMap.getLength(); i++) { Node node2 = nodeMap.item(i); String
				 * nodeName =node2.getNodeName(); String nodeValue =node2.getNodeValue();
				 * 
				 * if (nodeName.contentEquals("revisionNo") ) {
				 * Globals.guiWindowDebug.AddText("    revisionNo =" + nodeValue); } if
				 * (nodeName.contentEquals("ordrId") ) {
				 * Globals.guiWindowDebug.AddText("    ordrId =" + nodeValue); } if
				 * (nodeName.contentEquals("parentOrdrId") ) {
				 * Globals.guiWindowDebug.AddText("    parentOrdrId =" + nodeValue); } } } }
				 */
				// for each Order node
				for (int orderItr = 0; orderItr < nbOrderNodesInMessage; orderItr++) {
					// trace every 100 orders (useuful when retrieving historical data)
					if (orderItr != 0 && orderItr % 100 == 0)
						Globals.guiWindowDebug.AddText("order record #" + orderItr);
					node = nodeOrderList.item(orderItr);
					msg = null;
					String action = "";
					boolean isXBID_Order = false;
					String orderId = null;
					String acctId = "";
					String parentOrdrId = null;
					String remoteOrdrId = null;
					String revisionNo = null;
					String clOrdrId = null;
					String timestmp = null;
					String lastUpdateTm = null;
					String initialOrdrId = null;
					String clearingAcctType = null;
					String state = null;
					String contractId = null;
					String side = null;
					String px = null;
					String qty = null;
					String initialQty = null;
					String ordrExeRestriction = null;
					String txt = null;
					String dlvryAreaId = null;
					String preArranged = null;
					String type = null;
					String usrCode = null;
					String validityDate = null;
					String validityRes = null;
					String lastUpdateUsrInfo = null;
					String aot = null;

					if (node.getNodeType() == Node.ELEMENT_NODE) {
						Element eElement = (Element) node;
						NamedNodeMap nodeMap = eElement.getAttributes();
						// go through each attribute of the order node and extract values from relevant
						// attributes for current order node
						for (int i = 0; i < nodeMap.getLength(); i++) {
							Node node2 = nodeMap.item(i);
							String nodeName = node2.getNodeName();
							String nodeValue = node2.getNodeValue();

							if (nodeName.contentEquals("ordrId")) {
								orderId = nodeValue;
							}
							if (nodeName.contentEquals("initialOrdrId")) {
								initialOrdrId = nodeValue;
							}
							if (nodeName.contentEquals("parentOrdrId")) {
								parentOrdrId = nodeValue;
							}
							if (nodeName.contentEquals("clearingAcctType")) {
								clearingAcctType = nodeValue;
							}
							if (nodeName.contentEquals("clearingAcctType")) {
								clearingAcctType = nodeValue;
							}

							if (nodeName.contentEquals("acctId")) {
								// balancing group
								acctId = nodeValue;
							}
							if (nodeName.contentEquals("remoteOrdrId")) {
								isXBID_Order = true;
								remoteOrdrId = nodeValue;
							}
							if (nodeName.contentEquals("action")) {
								action = nodeValue;
							}
							if (nodeName.contentEquals("revisionNo")) {
								revisionNo = nodeValue;
							}
							if (nodeName.contentEquals("clOrdrId")) {
								clOrdrId = nodeValue;
								if (clOrdrId == null)
									clOrdrId = "";
							}
							if (nodeName.contentEquals("timestmp")) {
								timestmp = nodeValue;
							}
							if (nodeName.contentEquals("lastUpdateTm")) {
								lastUpdateTm = nodeValue;
							}
							if (nodeName.contentEquals("contractId")) {
								contractId = nodeValue;
							}
							if (nodeName.contentEquals("side")) {
								side = nodeValue;
							}
							if (nodeName.contentEquals("px")) {
								px = nodeValue;
							}
							if (nodeName.contentEquals("qty")) {
								qty = nodeValue;
							}
							if (nodeName.contentEquals("initialQty")) {
								initialQty = nodeValue;
							}
							if (nodeName.contentEquals("ordrExeRestriction")) {
								ordrExeRestriction = nodeValue;
							}
							if (nodeName.contentEquals("txt")) {
								txt = nodeValue;
							}
							if (nodeName.contentEquals("dlvryAreaIdString")) {
								dlvryAreaId = nodeValue;
							}
							if (nodeName.contentEquals("preArranged")) {
								preArranged = nodeValue;
							}
							if (nodeName.contentEquals("type")) {
								type = nodeValue;
							}
							if (nodeName.contentEquals("state")) {
								state = nodeValue;
							}
							if (nodeName.contentEquals("usrCode")) {
								usrCode = nodeValue;
							}
							if (nodeName.contentEquals("validityDate")) {
								validityDate = nodeValue;
							}
							if (nodeName.contentEquals("validityRes")) {
								validityRes = nodeValue;
							}
							if (nodeName.contentEquals("lastUpdateUsrInfo")) {
								lastUpdateUsrInfo = nodeValue;
							}
							if (nodeName.contentEquals("aot")) {
								aot = nodeValue;
							}
						} // for each attribute

						// increase the nb of Order event triggered by the user
						// only count UADD without a parent Id, to count the order start cycle
						// to avoid counting D+A events (priority change) twice (with the A having a
						// parent Id AND a D)
						boolean bOrderEventToBeCountedAsOMT = orderEventToBeCountedAsOMT(action, parentOrdrId);
						if (bOrderEventToBeCountedAsOMT) {
							// count "OMT" : events triggered by the user (not the exact formula but really
							// close)
							msg = "event to be counted : UserOrderEventsNbM7 = " + UserOrderEventsNbM7 + ", BG = "
									+ acctId;
							appLog.logger.info(msg);

							// update the Throttling status log or the chart
							// since this event does not have any throttling data just copy the last known
							// data (from the last Throttling status response)
							// and add specific data for the current msg

							nbOMTInMessage++;
							UserOrderEventsNbM7++;

							if (isXBID_Order) {
								UserOrderEventsNbRemote++;
								Globals.Increment_OMT(1, 0, 1, 0, 0, 0, 0, message.correlationId);
							}
							if (!isXBID_Order) {
								UserOrderEventsNbLocal++;
								Globals.Increment_OMT(1, 1, 0, 0, 0, 0, 0, message.correlationId);
							}

							// count the contribution of the EPEX Order Generator
							if (acctId.contentEquals(EPEX_ORDER_GENERATOR_BG)) {
								UserOrderEventsNb_M7_EPEXOrderGenerator++;
								if (isXBID_Order) {
									UserOrderEventsNb_Remote_EPEXOrderGenerator++;
									Globals.Increment_OMT(0, 0, 0, 1, 0, 1, 0, message.correlationId);
								}
								if (!isXBID_Order) {
									UserOrderEventsNb_Local_EPEXOrderGenerator++;
									Globals.Increment_OMT(0, 0, 0, 1, 1, 0, 0, message.correlationId);
								}
							}

							// update the Order Market Player stats list and redraw the chart
							boolean resultPlayersUpdate = false;

							// dates/times preparation
							Instant lastUpdateTm_Instant = Instant.parse(lastUpdateTm);
							ZonedDateTime localLastUpdateTm = lastUpdateTm_Instant.atZone(ZoneId.systemDefault());
							//System.out.println("lastUpdateTm= " + lastUpdateTm + " CET_CEST_Time = " + localLastUpdateTm);
							// isolate the string until the time zone correction "+"
							String sLocalCorrectedDateTime = localLastUpdateTm.toString().substring(0,
									localLastUpdateTm.toString().indexOf("+"));

							// transform the last update timestamp into a long (for later time diff
							// calculation)
							// Long lastUpdateTm_Long = sdfUTCWithDash.parse(lastUpdateTm).getTime(); //
							// milliseconds conversion
							Long lastUpdateTm_Long = sdfStatsWithDash.parse(messageServerTimestamp_String).getTime(); // milliseconds
																														// conversion
							Long LastUpdateTm_NanoSec_Long = TimeUnit.MILLISECONDS.toNanos(lastUpdateTm_Long);
							int tempsPasseSec = (int) ((System.currentTimeMillis() - lastUpdateTm_Long) / 1e6);
							// System.out.println("tempsPasseSec = " + tempsPasseSec + " = "+
							// System.currentTimeMillis() + " - "+ lastUpdateTm_Long);

							// System.out.println("lastUpdateTm= " + lastUpdateTm + "CET_CEST_Time = " +
							// localLastUpdateTm + " lastUpdateTm_Long="+lastUpdateTm_Long+ "
							// nanoTime()="+System.nanoTime() + " currentMS = "+
							// System.currentTimeMillis());

							resultPlayersUpdate = orderPlayersList.UpdatePlayersList(System.nanoTime(),
									sLocalCorrectedDateTime, acctId, isXBID_Order, UserOrderEventsNbM7,
									UserOrderEventsNbLocal, UserOrderEventsNbRemote, bgMemberList, appLog);
							// **************

							/*
							 * long elapsedSecLocal = (long)((System.nanoTime() - applicationStartNanoTime)
							 * / 1e9 ); System.out.println("lastUpdateTm=" + lastUpdateTm +
							 * " messageServerTimestamp_String="+messageServerTimestamp_String); Timestamp
							 * serverTimestamp = Timestamp.valueOf(messageServerTimestamp_String); long
							 * diff_MessageSending_start_Sec =
							 * (long)((messageServerTimestamp_Long-applicationStartMillisecondsTime ) / 1e9
							 * ); System.out.println("Timestamp = " + serverTimestamp +
							 * " elapsedSecLocal="+elapsedSecLocal+ " diff_MessageSending_start_Sec=" +
							 * diff_MessageSending_start_Sec +" System.nanoTime()="+ System.nanoTime() +
							 * " messageServerTimestamp_Long= "+ messageServerTimestamp_Long+
							 * " messageServerTimestamp_String = "+messageServerTimestamp_String);
							 */
							// **************
							if (bUpdateGUI) {
								if (adminRetrieveOrdersPastDaysShift == 0)
									loadChart.repaint();
								// update players' table in the GUI
								orderPlayersList.updateGUITable(playersTable, commentTextPlayers);
							}

							// log count info
							msg = "USER ORDER EVENT ordrId ='" + orderId + "' action ='" + action + "' parentOrdrId = '"
									+ parentOrdrId + "' BG/acctId = '" + acctId + "' remote order Id (optional)='"
									+ remoteOrdrId + "'" + "UserOrderEventsNbM7 = " + UserOrderEventsNbM7;
							// guiWindowOrders.AddText(msg);
							appLog.logger.fine(msg);
						} // if action must be counted

						else { // if action not counted
							msg = "Do not count ordrId ='" + orderId + "' action ='" + action + "' parentOrdrId = '"
									+ parentOrdrId + "' BG/acctId = '" + acctId + "' remote order Id (optional)='"
									+ remoteOrdrId + "'" + " UserOrderEventsNbM7 = " + UserOrderEventsNbM7;
							// guiWindowOrders.AddText(msg);
							appLog.logger.fine(msg);
						}
						// Globals.guiWindowDebug.AddText("processed Order Exe Report: revisionNo = " +
						// revisionNo + " action = " + action + " state=" + state);
						// if the received order is not already in the order table, add it, otherwise
						// update it
						if (adminMode == false) {
							boolean orderStoredInternally;
							try {
								orderStoredInternally = ordersList.updateOrder_CorrelationId_OrderId(message.correlationId,
										clOrdrId, messageServerTimestamp_String, timestmp, lastUpdateTm,
										sdfStats.format(new Date()), revisionNo, orderId, action, state, px, qty,
										Globals.guiWindowDebug);
								if (!orderStoredInternally) {
									appLog.logger.info("Order " + orderId + "correlation ID = " + message.correlationId
											+ " unknown: added to the list");

									Contract contract = new Contract();
									if (contractList != null) {
										contract = contractList.FindContractIdInfo_Contract(contractId,
												Globals.guiWindowDebug);
									} else {
										contract.setName("UNKNOWN: contractList is null");
										contract.setProd("UNKNOWN: contractList is null");
										contract.setDlvryStart("UNKNOWN: contractList is null");
										contract.setDlvryEnd("UNKNOWN: contractList is null");
									}

									ordersList.addOrder(timestmp, message.correlationId, side, action, orderId,
											parentOrdrId, initialOrdrId, "", clOrdrId, revisionNo, state, acctId,
											dlvryAreaId, ordrExeRestriction, contractId, contract.getName(),
											contract.getProd(), contract.getDlvryStart(), contract.getDlvryEnd(), qty,
											px, type, txt, deliveryAreaList, Globals.guiWindowDebug);
								}
							} catch (Exception e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
								String error = "catching error :" + e.toString();
								Globals.guiWindowDebug.AddText(error);
								appLog.logger.severe(error);
							}
							// refresh the rolling count of OMT during the short period
							if (bOrderEventToBeCountedAsOMT) {
								throttlingStatus.addNewThrottlingData(bThrottlingEnabled, "OrdrExeRprt",
										message.clientReceptionTime, lastUpdateTm, message.correlationId,
										windowOrderGenerationControl.strategy, "0", "1", "0", ordersList,
										throttlingDataChart_ShortRule, throttlingDataList);
							}

							/*
							 * if (bThrottlingEnabled) { // commented because: : this leads to an advanced
							 * indicator on the throttling chart compared with the result of the
							 * ThrottlingStatusReq throttlingStatus.Short_OmtCountApproximation =
							 * Integer.toString(ordersList.countUserOMTduringPeriod(Integer.valueOf(
							 * throttlingStatus.Short_observationWindow)));
							 * this.throttlingDataList.Add(throttlingStatus); throttlingDataChart_ShortRule.repaint();
							 * throttlingStatus.WriteThrottlingStatusResponsesCSVFile(); }
							 */
						}
						// refresh the orders list file
						try {
							ordersList.WriteOrdersListCSVFile();
						} catch (Exception e) {
							e.printStackTrace();
							String error = "catching error :" + e.toString();
							Globals.guiWindowDebug.AddText(error);
							appLog.logger.severe(error);
						}

						// update the orders table
						if (bUpdateGUI)
							ordersList.updateGUITable(controlBoardFrame.ownOrders_GUI_Panel);
					} // if (node.getNodeType() == Node.ELEMENT_NODE)
				} // for each Order Exe Report Order record/node

				if (bUpdateGUI == false) { // update the GUI part only once per Order Exe Report message (not for each
											// Order node within the msg)
					if (adminRetrieveOrdersPastDaysShift == 0)
						loadChart.repaint();
					// update players' table in the GUI
					orderPlayersList.updateGUITable(playersTable, commentTextPlayers);
				}
			} // if there are Order nodes
			msg = "*** end of Order Exe Report parsing: took "
					+ ((System.nanoTime() - message_processing_start_time) / 1e6) + " ms";
			appLog.logger.info(msg);
			// guiWindowOrders.AddText(msg);
			// Globals.guiWindowDebug.AddText(msg);

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			String error = "catching error :" + e.toString();
			Globals.guiWindowDebug.AddText(error);
			appLog.logger.severe(error);
		}

		Globals.Write_Globals_CSVFile();
		return nbOMTInMessage;
	}

	// **************************************
	// orderEventToBeCountedAsOMT: determine which order action is counted as an OMT
	// **************************************
	public boolean orderEventToBeCountedAsOMT(String action, String parentOrdrId) {
		if ((action.contentEquals("UADD") && parentOrdrId == null) || action.contentEquals("UHIB")
				|| action.contentEquals("UDEL") || action.contentEquals("UMOD") || action.contentEquals("UREJ")) {
			return true;
		} else
			return false;
	}

	// **************************************
	// parseMsgReport
	// **************************************
	public void parseMsgReport(AMQPMessage message) throws IOException {
		msg = null;
		long start_time = System.nanoTime();

		// parse the XML message to count local and XBID/remote orders
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;

		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			document = builder.parse(input);
			document.getDocumentElement().normalize();

			NodeList nodeMsgList = document.getElementsByTagName("Msg");

			// if there are Order nodes
			if (nodeMsgList != null && nodeMsgList.getLength() > 0) {
				// for each Order node
				for (int msgItr = 0; msgItr < nodeMsgList.getLength(); msgItr++) {
					msg = null;
					Node node = nodeMsgList.item(msgItr);
					String msgId = "";
					String type = "";
					String messageCode = "";
					String svrty = "";
					String txt = "";

					if (node.getNodeType() == Node.ELEMENT_NODE) {
						Element eElement = (Element) node;
						NamedNodeMap nodeMap = eElement.getAttributes();
						// go through each attribute of the order node and extract values from relevant
						// attributes for current order node
						for (int i = 0; i < nodeMap.getLength(); i++) {
							Node node2 = nodeMap.item(i);
							String nodeName = node2.getNodeName();
							String nodeValue = node2.getNodeValue();

							if (nodeName.contentEquals("msgId")) {
								msgId = nodeValue;
							}
							if (nodeName.contentEquals("type")) {
								type = nodeValue;
							}
							if (nodeName.contentEquals("messageCode")) {
								messageCode = nodeValue;
							}
							if (nodeName.contentEquals("svrty")) {
								svrty = nodeValue;
							}
							if (nodeName.contentEquals("txt")) {
								txt = nodeValue;
							}
						} // for each attribute

						msg = "\"" + txt + "\"" + " msgId=" + msgId + " messageCode=" + messageCode + " type=" + type
								+ " svrty=" + svrty;
						// guiWindowMsgReport.AddText(msg);
						controlBoardFrame.AddText(msg, controlBoardFrame.textAreaMessages);

						// add to throttling data if relevant
						if (bThrottlingEnabled && (txt.contains("RESTRICT") || txt.contains("WARNING"))) {
							appLog.logger.warning(message.xmlMessagePayload);

							// update the Throttling status log or the chart
							// since this event does not have any throttling data just copy the last known
							// data (from the last Throttling status response)
							// and add specific data for the current msg

							ThrottlingStatus previousThrottlingStatus = new ThrottlingStatus(controlBoardFrame);
							try {
								previousThrottlingStatus.copy(throttlingStatus);
							} catch (Exception e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
								msg = "Catching error in  previousThrottlingStatus.copy : " + e.toString();
								JOptionPane.showMessageDialog(Globals.controlBoardFrame, msg);
							}

							throttlingStatus = new ThrottlingStatus(controlBoardFrame);
							try {
								throttlingStatus.copy(previousThrottlingStatus);
							} catch (Exception e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
								msg = "Catching error in  previousThrottlingStatus.copy : " + e.toString();
								JOptionPane.showMessageDialog(Globals.controlBoardFrame, msg);
							}

							throttlingStatus.strategy = windowOrderGenerationControl.strategy;
							throttlingStatus.correlationId = message.correlationId;
							throttlingStatus.clientReceptionTime = message.clientReceptionTime;
							throttlingStatus.sourceMessage = "MsgRprt";
							// extract the announced release time
							// short rule example : "short rule (status=WARNING, end of
							// tolerance:2021-12-31T09:47:27.553+01:00)"
							/*
							 * String prefix = "short rule (status=WARNING, end of tolerance:"; if
							 * (txt.contains(prefix)) { String s= message.xmlMessagePayload; s =
							 * s.substring(s.indexOf(prefix) + prefix.length()); try { String[] result =
							 * s.split("+"); throttlingStatus.clientReceptionTime = result[0];
							 * throttlingStatus.M7_Msg_Report_Announced_Short_ReleaseTime = "1";
							 * throttlingStatus.WriteThrottlingStatusResponsesCSVFile(); } catch (Exception
							 * e) { // TODO Auto-generated catch block e.printStackTrace();
							 * guiWindowOrders.AddText(e.toString()); }
							 * 
							 * } prefix = "short rule (status=RESTRICTED, release time:"; if
							 * (txt.contains(prefix)) { String s= message.xmlMessagePayload; s =
							 * s.substring(s.indexOf(prefix) + prefix.length()); try { String[] result =
							 * s.split("+"); throttlingStatus.clientReceptionTime = result[0];
							 * throttlingStatus.M7_Msg_Report_Announced_Short_ReleaseTime = "1";
							 * throttlingStatus.WriteThrottlingStatusResponsesCSVFile(); } catch (Exception
							 * e) { // TODO Auto-generated catch block e.printStackTrace();
							 * guiWindowOrders.AddText(e.toString()); } }
							 */
						}
					} // if (node.getNodeType() == Node.ELEMENT_NODE)
				} // for each Order Exe Report Order record/node
			} // if there are Order nodes
			msg = "*** end of Msg Report parsing: took " + ((System.nanoTime() - start_time) / 1e6) + " ms";
			appLog.logger.fine(msg);

			// guiWindowMsgReport.AddText(msg);

		} catch (ParserConfigurationException | SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			Globals.guiWindowDebug.AddText(e.toString());
		}
	}

	// **************************************
	// parseThrottlingStatusReponse
	// **************************************
	public void parseThrottlingStatusReponse(AMQPMessage message) throws IOException {

		/*
		 * <ThrottlingStatusResp xmlns="http://www.deutsche-boerse.com/m7/v6">
		 * <StandardHeader marketId="EPEX"/> <ThrottlingMemberStatus mbrId="MDTEX"
		 * timestamp="2021-12-27T18:21:13.703Z" status="NO_RESTRICTION"><ShortRule
		 * observationPeriodLength="20" tolerancePeriodLength="40"
		 * reconnectionCoolDown="120" omtLimitL1="10" omtLimitL2="2000"> <Status
		 * status="NO_RESTRICTION" currentOmtCount="8"/> </ShortRule> <LongRule
		 * observationPeriodLength="86400" tolerancePeriodLength="10800"
		 * reconnectionCoolDown="10800" omtLimitL1="7000" omtLimitL2="20000"><Status
		 * status="NO_RESTRICTION" currentOmtCount="232"/> </LongRule>
		 * </ThrottlingMemberStatus></ThrottlingStatusResp>
		 */
		msg = null;
		long start_time = System.nanoTime();
		throttlingStatus = new ThrottlingStatus(controlBoardFrame);
		throttlingStatus.strategy = windowOrderGenerationControl.strategy;
		throttlingStatus.clientReceptionTime = message.clientReceptionTime;
		throttlingStatus.correlationId = message.correlationId;
		throttlingStatus.sourceMessage = "ThrottlingStatusResp";

		// parse the XML message to count local and XBID/remote orders
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;

		try {
			builder = docFactory.newDocumentBuilder();

			// Create a Document from the XML payload
			StringBuilder xmlStringBuilder = new StringBuilder();
			xmlStringBuilder.append(message.xmlMessagePayload);

			ByteArrayInputStream input = new ByteArrayInputStream(xmlStringBuilder.toString().getBytes("UTF-8"));
			Document document = null;
			document = builder.parse(input);
			document.getDocumentElement().normalize();

			// ThrottlingStatus throttlingStatus = new ThrottlingStatus(controlBoardFrame);

			// GENERIC / GLOBAL INFO
			NodeList nodeListGlobal = document.getElementsByTagName("ThrottlingMemberStatus");

			// if there are Order nodes
			if (nodeListGlobal != null && nodeListGlobal.getLength() > 0) {
				// for each Order node
				for (int itr = 0; itr < nodeListGlobal.getLength(); itr++) {
					Node node = nodeListGlobal.item(itr);

					if (node.getNodeType() == Node.ELEMENT_NODE) {
						Element eElement = (Element) node;
						NamedNodeMap nodeMap = eElement.getAttributes();
						// go through each attribute of the order node and extract values from relevant
						// attributes for current order node
						for (int i = 0; i < nodeMap.getLength(); i++) {
							Node node2 = nodeMap.item(i);
							String nodeName = node2.getNodeName();
							String nodeValue = node2.getNodeValue();

							if (nodeName.contentEquals("mbrId")) {
								throttlingStatus.mbrId = nodeValue;
							}
							if (nodeName.contentEquals("timestamp")) {
								throttlingStatus.timestamp = nodeValue;
							}
							if (nodeName.contentEquals("status")) {
								throttlingStatus.globalStatus = nodeValue;
							}
							/*
							 * if (nodeName.contentEquals("releaseTimestamp") ) {
							 * throttlingStatus.releaseTimestamp = nodeValue; }
							 */

						} // for each attribute
					} // if (node.getNodeType() == Node.ELEMENT_NODE)
				} // for each record/node
			} // if there are nodes
			NodeList nodeList_ShortRule = document.getElementsByTagName("ShortRule");

			// if there are Order nodes
			if (nodeList_ShortRule != null && nodeList_ShortRule.getLength() > 0) {
				// for each Order node
				for (int itr = 0; itr < nodeList_ShortRule.getLength(); itr++) {
					Node nodeShort = nodeList_ShortRule.item(itr);

					if (nodeShort.getNodeType() == Node.ELEMENT_NODE) {
						Element eElement = (Element) nodeShort;
						NamedNodeMap nodeMap = eElement.getAttributes();
						// go through each attribute of the order node and extract values from relevant
						// attributes for current order node
						for (int i = 0; i < nodeMap.getLength(); i++) {
							Node node2 = nodeMap.item(i);
							String nodeName = node2.getNodeName();
							String nodeValue = node2.getNodeValue();

							if (nodeName.contentEquals("observationPeriodLength")) {
								throttlingStatus.Short_observationWindow = nodeValue;
								iThrottlingData_Short_OW = Integer.parseInt(nodeValue);
							}
							if (nodeName.contentEquals("tolerancePeriodLength")) {
								throttlingStatus.Short_tolerance = nodeValue;
							}
							if (nodeName.contentEquals("reconnectionCoolDown")) {
								throttlingStatus.Short_cooldown = nodeValue;
							}
							if (nodeName.contentEquals("omtLimitL1")) {
								throttlingStatus.Short_L1 = nodeValue;
							}
							if (nodeName.contentEquals("omtLimitL2")) {
								throttlingStatus.Short_L2 = nodeValue;
							}
						} // for each attribute

						// get status info

						NodeList nodeStatusList = eElement.getElementsByTagName("Status");

						// if there are Order nodes
						if (nodeStatusList != null && nodeStatusList.getLength() > 0) {
							// for each Order node
							for (int msgItr = 0; msgItr < nodeStatusList.getLength(); msgItr++) {
								msg = null;
								Node node = nodeStatusList.item(msgItr);

								if (node.getNodeType() == Node.ELEMENT_NODE) {
									Element eElementShort = (Element) node;
									NamedNodeMap nodeMapShort = eElementShort.getAttributes();
									// go through each attribute of the order node and extract values from relevant
									// attributes for current order node
									for (int i = 0; i < nodeMapShort.getLength(); i++) {
										Node node2 = nodeMapShort.item(i);
										String nodeName = node2.getNodeName();
										String nodeValue = node2.getNodeValue();

										if (nodeName.contentEquals("status")) {
											throttlingStatus.Short_status = nodeValue;
										}
										if (nodeName.contentEquals("currentOmtCount")) {
											throttlingStatus.Short_OmtCount = nodeValue;
											msg = "Short RULE currentOmtCount = " + nodeValue;
											appLog.logger.warning(msg);
										}
										if (nodeName.contentEquals("releaseTimestamp")) {
											throttlingStatus.Short_releaseTimestamp = nodeValue;
										}

									} // for each attribute
								} // if (node.getNodeType() == Node.ELEMENT_NODE)
							} // for each record/node
						} // if there are nodes

					} // if (node.getNodeType() == Node.ELEMENT_NODE)
				} // for each record/node
			} // if there are nodes

			NodeList nodeList_LongRule = document.getElementsByTagName("LongRule");

			// if there are Order nodes
			if (nodeList_LongRule != null && nodeList_LongRule.getLength() > 0) {
				// for each Order node
				for (int itr = 0; itr < nodeList_LongRule.getLength(); itr++) {
					Node nodeLong = nodeList_LongRule.item(itr);

					if (nodeLong.getNodeType() == Node.ELEMENT_NODE) {
						Element eElement = (Element) nodeLong;
						NamedNodeMap nodeMap = eElement.getAttributes();
						// go through each attribute of the order node and extract values from relevant
						// attributes for current order node
						for (int i = 0; i < nodeMap.getLength(); i++) {
							Node node2 = nodeMap.item(i);
							String nodeName = node2.getNodeName();
							String nodeValue = node2.getNodeValue();

							if (nodeName.contentEquals("observationPeriodLength")) {
								throttlingStatus.Long_observationWindow = nodeValue;
							}
							if (nodeName.contentEquals("tolerancePeriodLength")) {
								throttlingStatus.Long_tolerance = nodeValue;
							}
							if (nodeName.contentEquals("reconnectionCoolDown")) {
								throttlingStatus.Long_cooldown = nodeValue;
							}
							if (nodeName.contentEquals("omtLimitL1")) {
								throttlingStatus.Long_L1 = nodeValue;
							}
							if (nodeName.contentEquals("omtLimitL2")) {
								throttlingStatus.Long_L2 = nodeValue;
							}
						} // for each attribute

						// get status info

						NodeList nodeStatusList = eElement.getElementsByTagName("Status");

						// if there are Order nodes
						if (nodeStatusList != null && nodeStatusList.getLength() > 0) {
							// for each Order node
							for (int msgItr = 0; msgItr < nodeStatusList.getLength(); msgItr++) {
								msg = null;
								Node node = nodeStatusList.item(msgItr);

								if (node.getNodeType() == Node.ELEMENT_NODE) {
									Element eElementLong = (Element) node;
									NamedNodeMap nodeMapLong = eElementLong.getAttributes();
									// go through each attribute of the order node and extract values from relevant
									// attributes for current order node
									for (int i = 0; i < nodeMapLong.getLength(); i++) {
										Node node2 = nodeMapLong.item(i);
										String nodeName = node2.getNodeName();
										String nodeValue = node2.getNodeValue();

										if (nodeName.contentEquals("status")) {
											throttlingStatus.Long_status = nodeValue;
										}
										if (nodeName.contentEquals("currentOmtCount")) {
											throttlingStatus.Long_OmtCount = nodeValue;
										}
										if (nodeName.contentEquals("releaseTimestamp")) {
											throttlingStatus.Long_releaseTimestamp = nodeValue;
										}

									} // for each attribute
								} // if (node.getNodeType() == Node.ELEMENT_NODE)
							} // for each record/node
						} // if there are nodes

					} // if (node.getNodeType() == Node.ELEMENT_NODE)
				} // for each record/node
			} // if there are nodes

			// force the calculation of the nb of OMT per period:
			// calculate the approximate OMT count during the short observation period
			if (bThrottlingEnabled) {
				try {
					throttlingStatus.Short_OmtCountApproximation = Integer
							.toString(ordersList.countUserOMTduringPeriod(iThrottlingData_Short_OW));
				} catch (Exception e) {
					msg = "Short_OmtCountApproximation error : " + e.toString();
					Globals.guiWindowDebug.AddText(msg);
					appLog.logger.warning(msg);
				}
			}
			// get this nb mentioned in the Order table
			try {
				ordersList.updateGUITable(controlBoardFrame.ownOrders_GUI_Panel);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				String error = "catching error: " + e.toString();
				appLog.logger.severe(error);
			}
			// get the throttling table updated
			this.throttlingDataList.Add(throttlingStatus, controlBoardFrame);
			throttlingDataChart_ShortRule.repaint();
			throttlingDataChart_LongRule.repaint();
			throttlingStatus.updateGUITable(ThrottlingTable, commentTextThrottling);

			msg = "*** end of Throttling Status Response parsing: took " + ((System.nanoTime() - start_time) / 1e6)
					+ " ms";
			appLog.logger.fine(msg);
			// guiWindowMsgReport.AddText(msg);

		} catch (ParserConfigurationException | SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			Globals.guiWindowDebug.AddText(e.toString());
		}
	}

	// ***************************************************
	// *** updateOrderList
	// ***************************************************
	// update the orderList when receiving a Contract Info Report new broadcast
	public void updateOrderList(List<Order> orderList, String orderExeREportCorrelationId, String orderId,
			String revisionNo) {
		for (Order next : orderList) {
			if (next.fileOrderId == orderExeREportCorrelationId) {
				next.m7OrderId = orderId;
				next.m7RevisionNo = revisionNo;
			}
		}
	}

	// ***************************************************
	// *** displayOrderList
	// ***************************************************
	public void displayOrderList(List<Order> orderList, GUIWindow guiWindow) {
		for (Order next : orderList) {
			Globals.guiWindowDebug.AddText("displayOrderList :'" + next.Display() + "'");
		}
	}

	// ***************************************************
	// *** displayOrderBeingProcessedList
	// ***************************************************
	public void displayOrderBeingProcessedList(List<OrderBeingProcessed> orderList, GUIWindow guiWindow) {
		for (OrderBeingProcessed next : orderList) {
			Globals.guiWindowDebug.AddText("OrderBeingProcessed Display :'" + next.Display() + "'");

		}
	}

	// ***************************************************
	// *** waitUntilOrderHasBeenProcessedByM7
	// ***************************************************
	public void waitUntilOrderHasBeenProcessedByM7(List<OrderBeingProcessed> orderListBeingProcessed,
			String clientOrderIdToCheck, GUIWindow guiWindow) throws InterruptedException {

		int positionOfFirstOccurrence = 0;
		int i = 0;
		boolean orderExeReportReceived = false;
		boolean orderFound = false;

		Globals.guiWindowDebug
				.AddText("order '" + clientOrderIdToCheck + "' : being checked in orderListBeingProcessed");
		// if an occurrence of the order is found in the list, loop until that first
		// occurrence is being removed (by the reception of an Order Exe Report with the
		// same client Order Id)

		// go through the list and check the order is featured
		// if found, track its position/index in the list
		for (OrderBeingProcessed next : orderListBeingProcessed) {
			Globals.guiWindowDebug.AddText(" current order in the list being checked = '" + next.fileOrderId + "'");
			if (next.fileOrderId.contentEquals(clientOrderIdToCheck)) {
				positionOfFirstOccurrence = i;
				orderFound = true;
				Globals.guiWindowDebug.AddText(sdf.format(new Date()) + " ******* WAIT: order " + clientOrderIdToCheck
						+ " to be marked as processed found in position: " + i + " orderExeReportReceived = "
						+ next.orderExeReportReceived);
			}
			i++;
		}
		// track the start of the waiting time
		long start = System.currentTimeMillis();
		long end = 0;
		float sec = 0;

		// while this 1st occurrence does not have orderExeReportReceived = true: wait
		// for max 5 seconds not to block the replay
		while (orderFound == true && orderExeReportReceived == false && sec < 5) {

			Globals.guiWindowDebug.AddText(sdf.format(new Date()) + " ******* WAIT: order '" + clientOrderIdToCheck
					+ "' : still waiting for Order Exe Report");
			Thread.sleep(500);
			orderExeReportReceived = orderListBeingProcessed.get(positionOfFirstOccurrence).orderExeReportReceived;

			// finding the time after the operation is executed
			end = System.currentTimeMillis();
			// finding the time difference and converting it into seconds
			sec = (end - start) / 1000F;
			Globals.guiWindowDebug.AddText(sdf.format(new Date()) + " Having been waiting for " + sec + "seconds");

		}

		// remove from the list
		if (orderFound == true) {
			Globals.guiWindowDebug.AddText(
					" order " + clientOrderIdToCheck + " orderExeReportReceived = : " + orderExeReportReceived);
			removeOrderFromList(orderListBeingProcessed, clientOrderIdToCheck, guiWindow);
		} else { // nothing to remove
			Globals.guiWindowDebug
					.AddText(" order " + clientOrderIdToCheck + " not found in the list of orders being processed");
		}

		Globals.guiWindowDebug.AddText(sdf.format(new Date()) + " end of waiting loop : orderExeReportReceived = "
				+ orderExeReportReceived + " after " + sec + " seconds");

	}

	// ******************************
	// remove an order from the list
	// ******************************
	public void removeOrderFromList(List<OrderBeingProcessed> orderBeingProcessedList, String fileOrderIdToBeRemoved,
			GUIWindow guiWindow) {

		Globals.guiWindowDebug.AddText("-----------Start of removeOrderFromList");
		// displayOrderBeingProcessedList(orderBeingProcessedList, guiWindow);

		// find the 1st occurrence of the order to be removed
		int i = 0;
		for (OrderBeingProcessed next : orderBeingProcessedList) {
			if (next.fileOrderId.contentEquals(fileOrderIdToBeRemoved)) {
				Globals.guiWindowDebug.AddText(fileOrderIdToBeRemoved + " found in position " + i);
				Globals.guiWindowDebug.AddText(" removal result of '" + fileOrderIdToBeRemoved + "' = "
						+ orderBeingProcessedList.remove(i + 0));
				break;
			}
			i++;
		}
	}

	// ***************************
	// logoutOutM7
	// ***************************
	public void logoutOutM7(String sessionId, Channel channel) throws IOException {
		AMQP.BasicProperties.Builder headers = new AMQP.BasicProperties.Builder().userId(userName)
				.contentType("x-m7/request; version=6.0").headers(Collections.singletonMap("app-version", "0.1")) // your
																													// app
																													// version
				.appId(applicationID) //
				.replyTo(responseQueue);

		// Send logout request
		/*
		 * example : <?xml version="1.0" encoding="UTF-8"?> <LogoutReq
		 * xmlns="http://www.deutsche-boerse.com/m7/v6" sessionId="1616686419339">
		 * <StandardHeader marketId="EPEX"/> </LogoutReq>
		 */
		String logoutMessage = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<LogoutReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" sessionId=\"" + sessionId + "\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + "</LogoutReq>";

		appLog.logger.info(logoutMessage);
		Globals.guiWindowDebug.AddText(logoutMessage);

		channel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_INQUIRY, true, false,
				headers.correlationId("Logout").build(), logoutMessage.getBytes());

	}

	// ***********************************************
	// readOrderFile
	// ***********************************************
	public List<Order> readOrderFile() {
		String orderFileName = "Unit Test order file.csv";
		String line = "";
		int orderNb = 0;
		List<Order> orderList = new ArrayList<Order>();

		// manage a list for order creations
		List<Order> orderWithActionCodeAList = new ArrayList<Order>();

		try {
			BufferedReader br = new BufferedReader(new FileReader(orderFileName));
			while ((line = br.readLine()) != null) {
				orderNb++;
				boolean orderFound = false;

				if (orderNb > 1) { // skip the labels row
					String[] columnValue = line.split(";");
					// System.out.println(line);
					// Globals.guiWindowDebug.AddText(line);
					Order currentOrder = new Order();

					currentOrder.fileOrderId = columnValue[0];
					currentOrder.entryTime = columnValue[3];
					currentOrder.action = columnValue[4];
					currentOrder.orderTransactionTime = columnValue[5];
					currentOrder.deliveryStart = columnValue[7];
					currentOrder.deliveryEnd = columnValue[8];
					currentOrder.product = columnValue[9];
					currentOrder.deliveryAreaId = columnValue[10];
					currentOrder.side = columnValue[12];
					currentOrder.price = columnValue[13];
					currentOrder.quantity = columnValue[15];

					if ("A".contentEquals(currentOrder.action)) {
						// Globals.guiWindowDebug.AddText("order "+ currentOrder.fileOrderId + " action
						// is A : adding it to the A list");
						orderWithActionCodeAList.add(currentOrder);
					} else {
						Globals.guiWindowDebug.AddText("action is not A but " + currentOrder.action
								+ ": add the order creation to the order List");
						// check whether there was already an A :if not add it to avoid to try to manage
						// an order that does not exist
						for (Order next : orderWithActionCodeAList) {
							if (next.fileOrderId.contentEquals(currentOrder.fileOrderId)) {
								// the order has been found in the list : there is already an order with an A :
								// exit loop
								// Globals.guiWindowDebug.AddText("order "+ currentOrder.fileOrderId + " already
								// listed with an A action");
								orderFound = true;
								break;
							}
						}
						if (orderFound == false) {
							Globals.guiWindowDebug.AddText("Could not find order '" + currentOrder.fileOrderId
									+ "' with an earlier A action : adding it");
							// an the same order but with action = A
							Order additionalOrder = new Order();
							additionalOrder.action = "A"; // forcing "A"
							additionalOrder.fileOrderId = currentOrder.fileOrderId;
							additionalOrder.entryTime = currentOrder.entryTime;
							additionalOrder.orderTransactionTime = currentOrder.orderTransactionTime;
							additionalOrder.deliveryStart = currentOrder.deliveryStart;
							additionalOrder.deliveryEnd = currentOrder.deliveryEnd;
							additionalOrder.product = currentOrder.product;
							additionalOrder.deliveryAreaId = currentOrder.deliveryAreaId;
							additionalOrder.side = currentOrder.side;
							additionalOrder.price = currentOrder.price;
							additionalOrder.quantity = currentOrder.quantity;

							orderList.add(additionalOrder);
							orderWithActionCodeAList.add(additionalOrder);

						}

					}
					orderList.add(currentOrder);
				}
			}
			br.close();
			// display the content of the A list
			Globals.guiWindowDebug
					.AddText("	    => *** resulting A list of orders: size = " + orderWithActionCodeAList.size());
			for (Order next : orderWithActionCodeAList) {
				Globals.guiWindowDebug.AddText("A list :" + next.Display());
			}
			// Globals.guiWindowDebug.AddText(" <= *** end of new order List:");

			// display the content of the new order list where necessary A were added
			// Globals.guiWindowDebug.AddText(" => *** resulting A list of orders: size = "+
			// orderList.size());
			/*
			 * for (Order next : orderList) {
			 * Globals.guiWindowDebug.AddText("new order list :" + next.Display()); }
			 * Globals.guiWindowDebug.AddText("	    <= *** end of new order List:");
			 */

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return orderList;
	}

	// ***************************************************
	// *** UpdateStatsCSVFile
	// ***************************************************

	public void UpdateStatsFile(String time, long nbOrderEventsM7, int projectionUserOrderEventsTotal,
			int nbOrderEventsLocal, int projectionUserOrderEventsLocal, int nbOrderEventsRemote,
			int projectionUserOrderEventsRemote) {
		try {
			FileWriter fw = new FileWriter(FILE_STATS_NAME, true);
			String row = time + CSV_SEPARATOR + projectionUserOrderEventsTotal + CSV_SEPARATOR
					+ projectionUserOrderEventsLocal + CSV_SEPARATOR + projectionUserOrderEventsRemote + CSV_SEPARATOR
					+ nbOrderEventsM7 + CSV_SEPARATOR + nbOrderEventsLocal + CSV_SEPARATOR + nbOrderEventsRemote
					+ NEW_LINE_SEPARATOR;
			fw.append(row);

			fw.flush();
			fw.close();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	// ***************************************************
	// *** CreateGUI
	// ***************************************************
	public void CreateGUI() {
		// GUI : create all windows
		// LEFT side of the screen

		// STATS PANEL
		// JTable Header
		String[] columns = { "User Order Events", "MARKET", "EPEX", "EPEX %", "** 24h MARKET PROJECTION",
				"24h EPEX PROJECTION", "MARKET TRADES", "24H TRADES PROJECTION" };
		// Create the table model
		DefaultTableModel dataModel = new DefaultTableModel(columns, 12);

		// create the table in which order and trade events stats will be displayed
		statsTable = new JTable(dataModel);
		// center all columns content but the 1st one which contains labels
		DefaultTableCellRenderer centerRenderer = new DefaultTableCellRenderer();
		centerRenderer.setHorizontalAlignment(SwingConstants.CENTER);

		for (int i = 1; i < statsTable.getColumnCount(); i++) {
			statsTable.setDefaultRenderer(statsTable.getColumnClass(i), centerRenderer);
		}
		// JScrollPane sp = new JScrollPane(statsTable);

		JFrame statsJFrame = new JFrame();

		JPanel mainPanel = new JPanel(new BorderLayout());
		JPanel durationTextPanel = new JPanel(new BorderLayout());
		durationTextField = new JTextField();
		commentTextField = new JTextField();
		commentTextField.setSize(200, 200);
		durationTextPanel.add(durationTextField, BorderLayout.SOUTH);

		// Add the panels and the table to the main panel
		mainPanel.add(durationTextPanel, BorderLayout.NORTH);
		mainPanel.add(new JScrollPane(statsTable), BorderLayout.CENTER);

		statsJFrame.getContentPane().add(mainPanel);
		statsJFrame.setBounds(0, 100, 1500, 300);
		statsJFrame.setTitle("Stats table");
		statsJFrame.setVisible(true);
		statsJFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// order and trades PLAYERS PANEL
		// JTable Header

		String[] columnsPlayers = { "Member name", "Member ID", "BG", "Total orders", "TOTAL Market %", "Start Time",
				"Last Update", "Activity Time", "Silence period", "Local", "Remote", "Local Market %",
				"Remote Market %", "Projection 24h Total", "Projection 24h Local", "Projection 24h Remote" };
		// Create the table model
		DefaultTableModel dataModelPlayers = new DefaultTableModel(columnsPlayers, 300);

		// create the table in which order and trade events stats will be displayed
		playersTable = new JTable(dataModelPlayers);
		playersTable.setAutoCreateRowSorter(true);
		// center all columns content but the 1st one which contains labels
		for (int i = 1; i < playersTable.getColumnCount(); i++) {
			playersTable.setDefaultRenderer(playersTable.getColumnClass(i), centerRenderer);
		}
		resizeColumnWidth(playersTable);
		JFrame playersJFrame = new JFrame();

		JPanel mainPanelPlayers = new JPanel(new BorderLayout());
		JPanel textPanelPlayers = new JPanel(new BorderLayout());
		commentTextPlayers = new JTextField();
		textPanelPlayers.add(commentTextPlayers, BorderLayout.SOUTH);

		// Add the panels and the table to the main panel
		mainPanelPlayers.add(textPanelPlayers, BorderLayout.NORTH);
		mainPanelPlayers.add(new JScrollPane(playersTable), BorderLayout.CENTER);

		playersJFrame.getContentPane().add(mainPanelPlayers);
		playersJFrame.setBounds(0, 390, 1900, 500);
		playersJFrame.setTitle("Players table - detailed market activity");
		playersJFrame.setVisible(true);
		playersJFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// Throttling Status table
		// JTable Header
		String[] columnsThrottlingStatus = { "RULE", "Release Time", "Status", "OMT count", "L1", "L2", "Observation",
				"Tolerance", "Cooldown" };
		// Create the table model
		DefaultTableModel dataModelThrottling = new DefaultTableModel(columnsThrottlingStatus, 4);

		// create the table in which order and trade events stats will be displayed
		ThrottlingTable = new JTable(dataModelThrottling);

		// center all columns content but the 1st one which contains labels
		for (int i = 1; i < ThrottlingTable.getColumnCount(); i++) {
			ThrottlingTable.setDefaultRenderer(ThrottlingTable.getColumnClass(i), centerRenderer);
		}
		resizeColumnWidth(ThrottlingTable);
		JFrame throttlingTableJFrame = new JFrame();

		JPanel mainPanelThrottling = new JPanel(new BorderLayout());
		JPanel textPanelThrottling = new JPanel(new BorderLayout());
		commentTextThrottling = new JTextField();
		textPanelThrottling.add(commentTextThrottling, BorderLayout.SOUTH);

		// Add the panels and the table to the main panel
		mainPanelThrottling.add(textPanelThrottling, BorderLayout.NORTH);
		mainPanelThrottling.add(new JScrollPane(ThrottlingTable), BorderLayout.CENTER);

		throttlingTableJFrame.getContentPane().add(mainPanelThrottling);
		throttlingTableJFrame.setBounds(0, 800, 1400, 170);
		throttlingTableJFrame.setTitle("Throttling Status table");
		throttlingTableJFrame.setVisible(true);
		throttlingTableJFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// simple text panels

		// guiWindowMsgReport = new GUIWindow("Message Reports", 0, 530,1300,200);
		// guiWindowMsgReport.AddText("Waiting for message reports...");

//	guiWindowErrorResponse = new GUIWindow("Error Responses", 0, 860,1300,200);
		// guiWindowErrorResponse.AddText("No error response so far...");

		statsJFrame.requestFocus();
		playersJFrame.requestFocus();

		// guiWindowMsgReport.requestFocus();

		if (adminMode == true) {
			playersJFrame.requestFocus();
		}
		/*
		 * if (bThrottlingEnabled ) { guiWindowErrorResponse.requestFocus(); }
		 */
		// Load Chart
		loadChart = new DrawMarketLoad(controlBoardFrame, orderPlayersList, appLog);
		loadChart.setVisible(true);
		
		// Empty Order Books Chart
		emptyObkChart = new DrawEmptyObkFrame(controlBoardFrame, emptyOrderBooksList, appLog);
		emptyObkChart.setVisible(true);

		// window order generation
		windowOrderGenerationControl = new WindowOGStartStop(this);

		windowOrderGenerationControl.setVisible(true);

		/*
		 * String[] broadcastColumnLabels= {"#","Reception Time", "Sending Time","Type",
		 * "Routing Key", "Sequence No", "XML payload"}; broadcast_GUI_Panel = new
		 * GUI_Panel("BROADCASTS", broadcastColumnLabels, 15, 0, 100, 1500, 500);
		 * broadcast_GUI_Panel.Init();
		 */

		controlBoardFrame = new ControlBoard(this);
		controlBoardFrame.setVisible(true);
		controlBoardFrame.addWindowListener(new WindowListener() {

			@Override
			public void windowActivated(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void windowClosed(WindowEvent e) {

			}

			@Override
			public void windowClosing(WindowEvent e) {
				// if the user is logged in ask if a logout req must be sent or not
				if (!"".contentEquals(currentSessionId))
				{
					int output = JOptionPane.showConfirmDialog(controlBoardFrame,

						"Do you want to log out before exiting? (otherwise the broadcast Q will survive for 3 minutes)",
						"Exit choice", JOptionPane.YES_NO_OPTION);

					if (output == JOptionPane.YES_OPTION) {
						// show the connection tab
						controlBoardFrame.tabbedPane.setSelectedIndex(0);
						Logout();
						// wait for the logout response to be received before exiting
						try {
							Thread.sleep(3000);
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					} else if (output == JOptionPane.NO_OPTION) {
						// nothing
					}
				}
				System.exit(0);
			}

			@Override
			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub

			}

		});

		controlBoardFrame.textField_UserName.setText(userName);
		controlBoardFrame.textField_Pwd.setText(password);
		controlBoardFrame.textField_URL1.setText(rabbitHost1);
		controlBoardFrame.textField_URL2.setText(rabbitHost2);

		controlBoardFrame.initConnection(null);

		if (bThrottlingEnabled) {
			throttlingTableJFrame.requestFocus();

			// Throttling data Chart
			
			// short rule
			throttlingDataChart_ShortRule = new ThrottlingDataChartFrame("SHORT",controlBoardFrame, throttlingDataList, windowOrderGenerationControl, appLog);
			throttlingDataChart_ShortRule.setVisible(true);

			// long rule
			throttlingDataChart_LongRule = new ThrottlingDataChartFrame("LONG",controlBoardFrame, throttlingDataList, windowOrderGenerationControl, appLog);
			throttlingDataChart_LongRule.setVisible(true);
		}

		if ("true".contentEquals(marketAnimation) || "true".contentEquals(orderGeneration))
			windowOrderGenerationControl.requestFocus();
		
		if ("true".contentEquals(fillEmptyOrderBooks)) {
			emptyObkChart.requestFocus();
		}
	}

	// ***************************************************
	// *** resizeColumnWidth
	// ***************************************************
	public void resizeColumnWidth(JTable table) {
		final TableColumnModel columnModel = table.getColumnModel();
		for (int column = 0; column < table.getColumnCount(); column++) {
			int width = 15; // Min width
			for (int row = 0; row < table.getRowCount(); row++) {
				TableCellRenderer renderer = table.getCellRenderer(row, column);
				Component comp = table.prepareRenderer(renderer, row, column);
				width = Math.max(comp.getPreferredSize().width + 1, width);
			}
			if (width > 15)
				width = 50;
			columnModel.getColumn(column).setPreferredWidth(width);
		}
	}

	// ***************************************************
	// *** Send AMQP Request
	// ***************************************************
	public int sendRequest(String routingKey, String type, String correlationId, String XMLmessage,
			boolean bresponseReceptionMandatoryToStart) {
		int returnCode = 0;
		String clientSendingTime = sdfTime.format(new Date());
		try {
			request_responseList.AddRequestResponse("REQUEST", sentMsgContentEncoding, clientSendingTime, "N/A (Request)", type, routingKey,
					correlationId, XMLmessage, bresponseReceptionMandatoryToStart);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			msg = "Error when adding a request :" + e1.toString();
			Globals.guiWindowDebug.AddText(msg);
			appLog.logger.warning(msg);
		}

		// update the request tab content
		try {
			request_responseList.updateGUITable(controlBoardFrame.request_response_GUI_Panel);
		} catch (Exception e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
			msg = "Error when displaying the request response list:" + e2.toString();
			Globals.guiWindowDebug.AddText(msg);
			appLog.logger.warning(msg);
		}

		try {
			boolean MANDATORY = true;

			if ("gzip".contentEquals(sentMsgContentEncoding)) 
				requestChannel.basicPublish(REQUEST_EXCHANGE, routingKey, MANDATORY, false, headers.correlationId(correlationId).build(), AMQPMessage.compress(XMLmessage));
			else requestChannel.basicPublish(REQUEST_EXCHANGE, routingKey, MANDATORY, false, headers.correlationId(correlationId).build(), XMLmessage.getBytes());
			
			appLog.logger.warning(msg);
			msg = "Request header for Correlation Id: " + correlationId + ": " + headers.build().toString();
			appLog.logger.info(msg);

		} catch (IOException e) {
			// msg AMQP publication error
			e.printStackTrace();
			String errorMsg = e.getMessage() + e.getClass();
			this.appLog.logger.warning("AMQP message Publication error: " + errorMsg);
			returnCode = -1;
		}

		// ordersList.WriteOrdersListCSVFile();

		return returnCode;
	}

	// ***************************************************
	// *** submit order to M7 on a correct contract
	// ***************************************************
	public void SendCorrectOrderRandomContract() {
		String randomAreaId = "";
		
		Order sellOrder = new Order();
		String prefix = "MANUAL_ORDER_CLICK #" ;
		sellOrder.correlationId = prefix + orderNb + "_" + sdfTime.format(new Date());
		sellOrder.clientOrderId = sellOrder.correlationId;
		sellOrder.side = "SELL";
		sellOrder.state = "ACTI";
		sellOrder.BalancingGroup = userDefaultBalancingGroup;

		Contract tradableContract = new Contract();
		tradableContract = contractList.pickUp_Tradable_Contract(controlBoardFrame);
		if (tradableContract != null) 	tradableContractId = tradableContract.getContractId();
		else JOptionPane.showMessageDialog(Globals.guiWindowDebug, "Tradable Contract is null");
		sellOrder.contractId = tradableContractId;
		
		sellOrder.deliveryAreaId = tradableContract.getChosenAreaToTrade();
		sellOrder.executionRestriction = "NON";

		// type: O for limit Orders, B for User Defined Blocks
		if (tradableContract.getPredefined().contentEquals("false")) {
			// the 1st block order generates the contract ID : need to provide functional
			// information instead of contract Id
			sellOrder.executionRestriction = "AON";
			sellOrder.type = "B";
		} else {
			sellOrder.type = "O";
		}
		sellOrder.contractName = tradableContract.getName(); // not mandatory to submit the order, just
																// used for the order text content /
																// logs
		sellOrder.product = tradableContract.getProd();
		sellOrder.deliveryStart = tradableContract.getDlvryStart();
		sellOrder.deliveryEnd = tradableContract.getDlvryEnd();
		sellOrder.contractId = tradableContract.getContractId(); // contract ID is enough for predefined
																	// products

		// random price in a range
		Random randomP = new Random();
		sellOrder.price = randomP.nextInt(5) + 120 + "00";
		sellOrder.quantity = randomP.nextInt(10) + 10 + "000";
		sellOrder.text = prefix + sellOrder.correlationId + " contract " + sellOrder.contractName + " ";

		this.submitOrder(sellOrder);
	}
	

	
	// ***************************************************
	// *** submit order to M7 on an incorrect contract, for testing/illustration purposes
	// ***************************************************
	public void SendOrderOnClosedContract() {
		String randomAreaId = "";
		
		Order sellOrder = new Order();
		sellOrder.correlationId = "ERROR_ORDER_ON_CLOSED_CONTRACT #" + orderNb + "_" + sdfTime.format(new Date());
		sellOrder.clientOrderId = sellOrder.correlationId;
		sellOrder.side = "SELL";
		sellOrder.state = "ACTI";
		sellOrder.BalancingGroup = userDefaultBalancingGroup;
		
		Contract closedContract = new Contract();
		closedContract = contractList.FindClosedContract();
		
		sellOrder.contractId = closedContract.getContractId();		
		sellOrder.product = closedContract.getProd();
		sellOrder.contractName = closedContract.getName();
		
		randomAreaId = deliveryAreaList.GetRandomArea().dlvryAreaId;
			
		sellOrder.deliveryAreaId = randomAreaId;
		sellOrder.executionRestriction = "NON";
		// type: O for limit Orders, B for User Defined Blocks
		if ("false".contentEquals(closedContract.getPredefined())) {
			sellOrder.executionRestriction = "AON";
			sellOrder.type = "B";
		} else {
			sellOrder.type = "O";
		}
		// random price in a range
		sellOrder.price = 10000 + "";
		sellOrder.quantity = 15 + "000";
		sellOrder.text = "attempt to send an order on closed contract : " + sellOrder.contractId + " area : " + sellOrder.deliveryAreaId;

		this.submitOrder(sellOrder);	
	}
	
	// ***************************************************
	// *** submit order to M7
	// ***************************************************
	public int submitOrder(Order order) {
		int returnCode = 0;

		// String priceString = order.price + "00";
		String priceString = order.price;
		// String qtyString = order.quantity + "000";
		String qtyString = order.quantity;

		String clientSendingTime = sdfStats.format(new Date());

		String orderRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<OrdrEntry xmlns=\"http://www.deutsche-boerse.com/m7/v6\"";
		
		// no list execution restriction for User Defined Blocks
		if (!"B".contentEquals(order.type)) orderRequest =orderRequest + " listExecInst=\"" + basketListExecInst + "\"";
		
		orderRequest = orderRequest + ">" + "<StandardHeader marketId=\"EPEX\"/>" + "<OrdrList>";

		String oneOrderString = "";

		String orderPart = "";

		// prepare the order management request
		for (int i = 1; i <= nbOfOrdersPerBasket; i++) {

			// force the FOK order execution restriction if basket execution restriction =
			// "LFOK"
			if (basketListExecInst == "LFOK")
				order.executionRestriction = "FOK";

			
			oneOrderString = // build basket of 2 orders: 1 buy + 1 sell with slightly different quantity and
								// price
					" <Ordr " + " clearingAcctType=\"P\"" + " acctId=\"" + order.BalancingGroup + "\"" + " prod=\""
							+ order.product + "\"";
	
			// add contract ID only if not submitting a new UDB order
			if (!"".contentEquals(order.contractId))    oneOrderString = oneOrderString + " contractId=\"" + order.contractId + "\"" ;
			if (!"".contentEquals(order.deliveryStart)) oneOrderString = oneOrderString + " dlvryStart=\"" + order.deliveryStart + "\"" ;
			if (!"".contentEquals(order.deliveryEnd))   oneOrderString = oneOrderString + " dlvryEnd=\"" + order.deliveryEnd + "\"" ;
			
			oneOrderString = oneOrderString + " side=\"" + order.side + "\"" 
							+ " px=\"" + priceString + "\"" + " qty=\"" + qtyString + "\""
							+ " ordrExeRestriction=\"" + order.executionRestriction + "\"" + " txt=\"" + order.text
							+ "\"" + " dlvryAreaId=\"" + order.deliveryAreaId + "\"" + " clOrdrId=\""
							+ order.clientOrderId + "-" + i + "\"" + " type=\"" + order.type + "\""
							+ " validityRes=\"GFS\" state=\"" + order.state + "\" />";

			ordersList.addOrder(clientSendingTime, order.correlationId, order.side, order.action, "", "", "",
					order.fileOrderId, order.clientOrderId + "-" + i, "", order.state, order.BalancingGroup,
					order.deliveryAreaId, order.executionRestriction, order.contractId, order.contractName,
					order.product, order.deliveryStart, order.deliveryEnd, order.quantity, order.price, order.type,
					order.text, deliveryAreaList, Globals.guiWindowDebug);

			orderPart = orderPart + oneOrderString;
		}

		// calculate the OMT count approx/internal simple Oracle
		if (bThrottlingEnabled)
			throttlingStatus.Short_OmtCountApproximation = Integer
					.toString(ordersList.countUserOMTduringPeriod(iThrottlingData_Short_OW));
		try {
			ordersList.updateGUITable(controlBoardFrame.ownOrders_GUI_Panel);
		} catch (Exception e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
			String error = "catching error: " + e2.toString();
			appLog.logger.severe(error);
		}

		// send the order
		orderRequest = orderRequest + orderPart + "</OrdrList>" + "</OrdrEntry>";

		msg = "Sending Order Entry request : Correlation Id: " + order.correlationId;
		appLog.logger.warning(msg);
		msg = "XML for Correlation Id: " + order.correlationId + " : " + orderRequest;
		Globals.guiWindowDebug.AddText(msg);

		try {		
			
			if ("gzip".contentEquals(sentMsgContentEncoding)) 
				requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_MANAGEMENT, true, false, headers.correlationId(order.correlationId).build(), AMQPMessage.compress(orderRequest));
			else 
				requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_MANAGEMENT, true, false, headers.correlationId(order.correlationId).build(), orderRequest.getBytes());

			appLog.logger.warning(msg);
			msg = "Request header for Correlation Id: " + order.correlationId + ": " + headers.build().toString();
			appLog.logger.info(msg);
			
		} catch (IOException e) {
			// msg AMQP publication error
			e.printStackTrace();
			String errorMsg = e.getMessage() + e.getClass();
			this.appLog.logger.warning("AMQP message Publication error: " + errorMsg);
			returnCode = -1;
		}

		try {
			request_responseList.AddRequestResponse("REQUEST", sentMsgContentEncoding, clientSendingTime, "-", "OrdrEntry",
					ROUTING_KEY_MANAGEMENT, order.correlationId, orderRequest, false);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			Globals.guiWindowDebug.AddText(e1.toString());
			msg = "catching error : " + e1.toString();
			appLog.logger.info(msg);
		}

		orderNb++;
		try {
			ordersList.updateGUITable(controlBoardFrame.ownOrders_GUI_Panel);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			String error = "catching error: " + e1.toString();
			appLog.logger.severe(error);
		}

		try {
			ordersList.WriteOrdersListCSVFile();
		} catch (Exception e) {
			e.printStackTrace();
			msg = "error writing orders List: " + e.toString();
			appLog.logger.info(msg);
		}

		// send a Throttling Status Req immediately after the order sending, if requested and only for testing purposes
		if ("true".contentEquals(sendThrottlingStatusReqAfterEachOrder)) this.sendThrottlingStatusReq();
		return returnCode;
	}

// ***************************************************
// * Modify an order : ordrModType defines which type of modification is performed: ACTI, DEAC, MODI, DELE (see DFS180)
// * for MODI : modify the  price and/or qty in the order object before calling modifyOrder
// ***************************************************
	public int modifyOrder(Order order, String ordrModType) {

		int returnCode = 0;
		String txt = "Market animation modification: " + ordrModType + " " + order.text;

		String priceString = order.price;
		String qtyString = order.quantity;

		String clientSendingTime = sdfTime.format(new Date());

		// if (order.type.contentEquals("")) order.type = "O";

		String orderModifyRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<OrdrModify xmlns=\"http://www.deutsche-boerse.com/m7/v6\" ordrModType=\"" + ordrModType + "\">"
				+ "<StandardHeader marketId=\"EPEX\"/>" + "<OrdrList>" + "<Ordr" + " ordrId=\"" + order.m7OrderId + "\""
				+ " clOrdrId=\"" + order.clientOrderId + "\"" + " px=\"" + priceString + "\"" + " qty=\"" + qtyString
				+ "\"" + " revisionNo=\"" + order.m7RevisionNo + "\"" + " txt=\"" + txt + "\"" 
				+ " ordrExeRestriction=\"" + order.executionRestriction + "\""
				+ " type=\"" + order.type
				+ "\"/>"

				+ "</OrdrList>" + "</OrdrModify>";

		Globals.guiWindowDebug.AddText(orderModifyRequest);
		
		ordersList.lock_Order(order.correlationId, order.m7OrderId); // lock while waiting for the order Exe Report;
		
		try {
			request_responseList.AddRequestResponse("REQUEST", sentMsgContentEncoding, clientSendingTime, "Request: N/A", "OrdrModify",
					ROUTING_KEY_MANAGEMENT, order.correlationId, orderModifyRequest, false);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			String error = "catch error : " + e1.toString();
			Globals.guiWindowDebug.AddText(error);
			appLog.logger.info(error);
		}
		try {
			requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_MANAGEMENT, true, false,
					headers.correlationId(order.correlationId).build(), orderModifyRequest.getBytes());
			appLog.logger.warning(msg);
			msg = "Request header for Correlation Id: " + order.correlationId + ": " + headers.build().toString();
			appLog.logger.info(msg);
		} catch (IOException e) {
			// msg AMQP publication error
			e.printStackTrace();
			String errorMsg = e.getMessage() + e.getClass();
			this.appLog.logger.warning("catching error: AMQP message Order modification Publication error: " + errorMsg);
			Globals.guiWindowDebug.AddText(errorMsg);
			try {
				Thread.sleep(10000);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			returnCode = -1;
		}

		try {
			ordersList.updateGUITable(controlBoardFrame.ownOrders_GUI_Panel);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();		
			String error = "catching error: " + e1.toString();
			appLog.logger.severe(error);			
		}

		try {
			ordersList.WriteOrdersListCSVFile();
		} catch (Exception e) {
			e.printStackTrace();
			msg = "error writing orders List: " + e.toString();
			appLog.logger.info(msg);
		}

		return returnCode;
	}

// ***************************************************
// *** Logout
// ***************************************************	
	public void Logout() {

		if (amqpConnection.ConnectionIsOpen()) {
			bWaitingForLogoutReport = true;
			String logoutRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
					+ "<LogoutReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\" sessionId=\"" + currentSessionId + "\">"
					+ "<StandardHeader marketId=\"EPEX\"/>" + "</LogoutReq>";
			// update DEBUG GUI and update GUI Connection section
			msg = "Logout requested for session Id = " + currentSessionId;
			Globals.guiWindowDebug.AddText("Logout requested for session Id = " + currentSessionId);
			controlBoardFrame.AddText(msg, controlBoardFrame.textAreaConnection);
	
			Globals.guiWindowDebug.AddText(logoutRequest);
			controlBoardFrame.AddText(logoutRequest, controlBoardFrame.textAreaConnection);
			//
	
			// Log
			this.appLog.logger.warning("Logout requested for session Id = " + currentSessionId);
			this.appLog.logger.warning(logoutRequest);
			// send the Logout requests
			logoutReqAttemptNb++;
			sendRequest(ROUTING_KEY_INQUIRY, "LogoutReq", "Logout_"+connectionLossNb+"_"+logoutReqAttemptNb, logoutRequest, RESP_OPTIONAL_TO_START);

			try {
				request_responseList.WriteCSVFile();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				msg = "Error writing request_reponseList to a file : " + e.toString();
				Globals.guiWindowDebug.AddText(msg);
				this.appLog.logger.warning(msg);
			}
		}

	}

//***************************************************
//*** sendThrottlingStatusReq
//***************************************************	
	public void sendThrottlingStatusReq() {
		msg = "";
		String throttlingStatusReq = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> "
				+ "<ThrottlingStatusReq xmlns=\"http://www.deutsche-boerse.com/m7/v6\">"
//				+ "<StandardHeader marketId=\"EPEX\"/>"
				+ "<StandardHeader marketId=\"EPEX\"" + " onBehalfUserId=\"" + "1251" + "\"" + "/>"				
				+ "</ThrottlingStatusReq>";
		

		if (bThrottlingEnabled == true) {
			throttlingStatusReqNb++;
			String ReqcorrelationId = "throttlingStatusReq #" + throttlingStatusReqNb;
			msg = "=> Sending request :" + " Correlation Id : " + ReqcorrelationId + " " + throttlingStatusReq;
			// Globals.guiWindowDebug.AddText(msg);
			//appLog.logger.warning(msg);
			try {
				sendRequest(ROUTING_KEY_INQUIRY_THROTTLING, "throttlingStatusReq", "THROTTLING_STATUS_REQ_#" + throttlingStatusReqNb +"_"+connectionLossNb, throttlingStatusReq, RESP_OPTIONAL_TO_START);
				
				//requestChannel.basicPublish(REQUEST_EXCHANGE, ROUTING_KEY_INQUIRY_THROTTLING, true, false,		headers.correlationId(ReqcorrelationId).build(), throttlingStatusReq.getBytes());
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
				msg = "Error when publishing ThrottlingStatusReq: " + e1.toString();
				Globals.guiWindowDebug.AddText(msg);
				appLog.logger.warning(msg);
			}
		}
	}

// ***************************************************
// *** openNewAMQPConnection
// ***************************************************	
	public AMQPConnection openNewAMQPConnection() {

		AMQPConnection amqpConnection = new AMQPConnection(userName, password, rabbitHost1, rabbitHost2, rabbitPort,
				rabbitVHost, certPath, certPassword, applicationID, controlBoardFrame, appLog);

		amqpConnection.ConnectWithClientFailover(controlBoardFrame);

		return amqpConnection;
	}

	// ***************************************************
	// *** Main
	// ***************************************************
	public static void main(String[] args) {

		try {
			new SampleCode();
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(Globals.guiWindowDebug, "catching error in Main : " + e.toString());
		}
	}
}